forth definitions hex

-find base+ 0= constant version sp!
: testver version 1- 8000 and ;
( abs. ptrs must be offset by $8000 for the 64K version! )
: code+ testver -dup IF 104 - - ENDIF ;

: sp. depth -dup        ( show max 10 top items of stack )
        if 0A min 0 swap do i pick . -1 +loop
        else ." <empty> " then ;

: dump 0 do
 i i +  base @ mod 0= if cr dup . ." : " then
 over + ? loop drop ;

: 2rot 6 roll 6 roll ;  ( d1 d2 d3 --- d2 d3 d1 )

vocabulary qdos immediate qdos definitions

create fdelete smudge  ( addr --- d0.l )
 305F ,         ( move.w [sp]+,a0 )
 72FF ,         ( moveq #-1,d1 )
 7004 ,         ( moveq #4,d0 )
 4E44 ,         ( trap #4 )
 4E42 ,         ( trap #2 )
 2F00 ,         ( move.l d0,-[sp] )
 4ED3 ,         ( jmp [a3] )

: ch@ 2b c@ ; ( --- currchan )
: ch! 2b c! ; ( newchan --- )
: chp 4 * limit + ; ( ch --- channeladdr )
: newch 1 10 2 do
 i chp @ 0< if 1- i ch! leave then loop ; ( --- flagerr )

0. 2constant ernum
: qernum 2dup or if ' ernum 2! 1 else 2drop 0 then ;  
: ert qernum if ernum 1 report quit then ;      ( d0.l --- ) 

( all the following want the channel number 0-15 set by ch! )

: fopeny" <builds ,                     ( type --- )
 does> @ [compile] w" swap ch@ open ;   ( --- err.l )
0 fopeny" fopen" 1 fopeny" fop_in" 2 fopeny" fop_new"
3 fopeny" fop_over" 4 fopeny" fop_dir"

: openy" <builds , immediate            ( type --- )
 does> @ [compile] w" swap ch@ open ert ; ( --- )
0 openy" open" 1 openy" open_in" 2 openy" open_new"
3 openy" open_over" 4 openy" open_dir"

  00 ( multiple use of hi-level code added .hpr'96
: .d base @ decimal [ drop here ] swap 0 d. base ! ;
: .h base @ hex branch  [ dup here - , smudge
: .b base @ 2 base ! branch [ here - , smudge

( the next two do not alter the currently set channel )
( they expect it to reference the output end of a pipe )
: fconnect" w" pipe_" ch@ rot open ; immediate
        ( inchan --- err.l )
: connect" [compile] fconnect" ert ; immediate  ( inchan --- )
        ( Eg 5 ch! open" pipe_100" 6 connect )

: fdelete" [compile] w" fdelete ; immediate
        ( --- err.l ) ( + filename )
: delete" [compile] fdelete" ert ; immediate ( --- ) ( + filename )

0. 2constant d1l? 12 allot
: d1h? ' d1l? @ ;
: d1w? [ ' d1l? 2+ ] literal @ ;
: d1b? [ ' d1l? 3 + ] literal c@ ;
: a1w? [ ' d1l? 4 + ] literal @ ;
        ( outputs: d1.x a1.w ) ( do not destroy inputs )
: wom.w <builds ' d1l? + , does> @ ! ;
: d1l [ ' d1l? 06 + ] literal 2! ;
: d2l [ ' d1l? 0A + ] literal 2! ;
06 wom.w d1h    08 wom.w d1w                    0C wom.w d2w
0E wom.w d0w    10 wom.w d3w    12 wom.w a1w    14 wom.w a2w
        ( inputs: d1.l d2.l d0.w d3.w a1.w a2.w )

create dot3 smudge      ( chanid.l --- d0.l )
 4CEE.0006 , , ' d1l? 06 + , ( movem.l d1l,d1/d2 )
 4CAE.0609 , , ' d1l? 0E + , ( movem.w d0w,d0/d3/a1/a2 )
 D5CE ,         ( add.l a6,a2 )
 2057 ,         ( move.l [sp],a0 )
 2E8B ,         ( move.l a3,[sp] )
 4E44 ,         ( trap #4 )
 4E43 ,         ( trap #3 )
 2657 ,         ( move.l [sp],a3 )
 2E80 ,         ( move.l d0,[sp] )
 2D41 , ' d1l? , ( move.l d1,d1l? )
 3D49 , ' d1l? 4 + , ( move.w a1,a1w? )
 4ED3 ,         ( jmp [a3] )

: t3 ch@ chp 2@ dot3 ; ( --- err.l )
: t30 d0w t3 ert ;  ( for no parameters )
: t31 d0w d1w t3 ert ;  ( for just d1 parameter )
: t32 d0w d1w d2w t3 ert ;      ( for just d1 and d2 parms )
: t3e d0w 0. 0. sp@ a1w t3 ert ; ( for window enquiries )
: t3b d0w sp@ a1w t3 ert 2drop 2drop ;  ( for wdef and bfill )
: t3t d0w [ ' d1l? 10 + ] literal @ swap d3w t3 rot d3w ;
        ( temptimeout opn --- d0.l )

: pend 0 t3t or 0= ;    ( temptimeout --- readyflag )
: eof 0 0 t3t 10. d+ or 0= ;   ( --- eofflag )
: inkey 1 t3t or 0= dup if d1b? swap endif ;
        ( temptimeout --- byte 1 ) ( temptimeout --- 0 )
: fbyte 1 t30 d1b? ;    ( --- byte )
: fline d2w a1w 2 t30 d1w? 1 - ;        ( addr len --- valid )
: fstrg d2w a1w 3 t30 ; ( addr len --- )
: edlin d2w a1w d1l 4 t30 d1w? 1 - d1h? ;
        ( valid curs addr len --- valid curs )
: sbyte 5 t31 ; ( byte --- )
: sstrg d2w a1w 7 t30 ; ( addr len --- )

( : extop 09 t30 ; ) ( --- ) ( needs a thought or two... )

: pxenq 0A t3e ;        ( --- y x height width ) ( pixels)
: chenq 0B t3e ;        ( --- row col rows cols ) ( chars )
: border 0C t32 ;       ( width colour --- )
: wdef d2w d1w 0D t3b ; ( y x width height bwid bcol --- )
: window 0. wdef ;      ( x y height width --- )
: cursen 0E t30 ;
: curdis 0F t30 ;
: at 10 t32 ; ( row col --- )
: tab 11 t31 ; ( col --- )
: nl 12 t30 ; ( do a newline )
: pcol 13 t30 ; ( go to prev col )
: ncol 14 t30 ; ( go to next col )
: prow 15 t30 ; ( go to prev row )
: nrow 16 t30 ; ( go to next row )
: pixp 17 t32 ; ( y x --- )
: scroll 18 t31 ; ( distance --- )
: scrtp 19 t31 ; ( distance --- )
: scrbt 1A t31 ; ( distance --- )
: pan 1B t31 ; ( distance --- )
: panln 1E t31 ; ( distance --- )
: panrt 1F t31 ; ( distance --- )
: cls 20 t30 ;
: clrtp 21 t30 ;
: clrbt 22 t30 ;
: clrln 23 t30 ;
: clrrt 24 t30 ;
: fount a2w a1w 25 t30 ; ( firstfont secondfont --- )
: recol a1w 26 t30 ; ( addr --- ) ( 8 colour bytes at addr )
: paper 27 t31 ; ( colour --- )
: strip 28 t31 ; ( colour --- )
: ink   29 t31 ; ( colour --- )
: flash 2A t31 ; ( boolean --- )
: under 2B t31 ; ( boolean --- )
: setmd 2C t31 ; ( SuperBasic OVER )
: csize 2D t32 ; ( height width --- )
: bfill d1w 2E t3b ; ( y x height width colour )

( 30 to 35 are not relevent, we need F.P. for graphics )

: fscheck 40 t3t or 0= ;
: fsflush 41 t30 ;
: posab d1l 42 t3t or 0= ;      ( pos.l --- okflag )
: posre d1l 43 t3t or 0= ;      ( adj.l --- okflag )
: poseof 7FFF.FFFF posre drop ; ( --- )
: pos? 0 0 posre drop d1l? ;    ( --- pos.l)
: flen pos? poseof d1l? 2swap posab drop ;
        ( --- flen.l ) ( and file posn restored )
        ( immediately after any of the pos calls, )
        ( d1l? will give the current position )
: mdinf a1w 45 t30 d1l? ;       ( addr --- good empty )
        ( 10 bytes to addr )
: heads a1w 46 t30 d1w? ;       ( addr --- len )
        ( 14 bytes sent from addr )
: headr a1w 47 t30 d1w? ;       ( addr --- len )
        ( 14 bytes read to addr )
: fsload a1w 48 t30 ;   ( addr --- ) ( load all file to addr )
: fssave 0 d2l a1w 49 t30 ;        ( addr len --- )
        ( save to file, note unsigned len, as we're < 32K )

: select 0 begin inkey if 1 exit then
 ?terminal if key 0 exit then 3 again [ smudge

( wind it all up and save the new program )
forth definitions decimal
latest 12 +origin !     ( top nfa )
here 28 +origin !       ( fence )
here 30 +origin !       ( dp )
' qdos 6 + 32 +origin ! ( voc-link )
here fence !
1 40 ! save" win1_Forth_temp_FQDOS" 39 c@ close

