 NOLIST * 2.1.95 *
* qxl * flp1_forth_asm - lwr68k - .hpr'93 - jobname "F6" 64K-system *
* copyright 1994 h.-peter recktenwald, albestr. 21, d-12159 berlin  *

 section   Forth
 pagelen   20000

* label TST... 2ndary job watched ared

.vers  setstr {7.23} *7.15+ kontrolljob 7.12+: 8/94-11/94 (qxl)
.cpu   setnum $4fe9fe22

* Registers: (I)nput only, (F)orth reserved
os setstr d6 (F) (n.i.) bank-offset rel(a6)
up setstr d7 (F) user pointer, needing offset by a6
w  setstr a2 (I) parameter field pointer
nx setstr a3 (F) jump address to leave assembler
ip setstr a4 (F) forth next instruction pointer
rp setstr a7 (F) return stack pointer
bp setstr a6 (F) base ptr
sp setstr a5 (F) forth stack pointer, params in/out

* jdt disp
;jobtv   equ -$4c trap redirection
;jobd0   equ -$48
;jobd6   equ -$30 reg. storage
;jobd7   equ -$2c
;joba2   equ -$20
;joba3   equ -$1c
;joba4   equ -$18
;joba5   equ -$14
joba6   equ -$10
;joba7   equ -$0c
;jobsr   equ -8
;jobpc   equ -6

* system
msb.b     equ   $80       name flag bit
immed.b   equ   $40       precedence bit
smudge.b  equ   $20       smudge bit
del.c     equ   $C2       <del> char
.lumpplus equ   $50       for disp here to pad
.vocs     equ   16        max no. of stacked vocabularies

cfname    equ   38        max chars of a filename (+ count.w = 40) f/n
cfhead    equ   64        fileheader length     b/hed
cbsec     equ   512       bytes/disksector      b/sec
cbalc     equ   cbsec*3   allocation unit       b/alc
cadrv     equ   480       a.units/drive         a/drv   2cons
cafre     equ   480       a.units free          a/fre   2cons
cdwpt     equ   0         write protect flag    d/wpt
cdnum     equ   1         drive number          d/num
ssbits    equ   6         for 64 byte headers & buffers
ssize     equ   1<<ssbits       :=2^6=64        b/buf
cscr      equ   1024            chars/screen    c/scr
nbuf      equ   cscr/ssize      :=16
bmag      equ   (ssize+4)*nbuf  buffer space
uarea     equ   256             user area
tibrp     equ   $440            combined tib & return stack
rpmin     equ   $40             initial min for rp vs cmd stg
chans     equ   16        number of channels supported (must be even)

p equ ')'!128
prevnum setnum  0
previmm setnum  0

* vocabularies
vocnfa  equ  $81a0 1st (dummy) entry
voc     setstr fth current vocabulary
lastvoc setstr  Z  voc-link
fthlink setstr  Z  4th
fplink  setstr  Z  fp
hidnlink setstr Z  hidden
qdoslink setstr Z  qdos
edilink setstr  Z  editor
piflink setstr  Z  pointer-i.f.
milink  setstr  Z  minerva special
rootlink setstr Z  base
locvlink setstr Z  local variables
asmlink setstr  Z  assembler
anslink setstr  Z  ansi-std compatibility

* string-macros

jnx    setstr { jmp ([nx])}
.quit  setstr {dc.w pquitq-Z,fetch-Z,execute-Z}

* assembler macros

create MACRO Xname Xaddr vf vc
 local b i l s t v
v setstr [voc]
 ifstr {[vf]} <> {V:} goto novoc
voc setstr {[vc]}
novoc maclab
Z[prevnum] equ [previmm]
t setstr {[Xname]}
l setnum [.len(t)]
s setnum [l]-1
prevnum setnum [prevnum]+1
      dcb.b  (*+1+[l]-Z)&1+1,Z[prevnum]![l]
 ifstr {[.left(t,1)]} <> {`} goto ord
b setnum $5B!$80
 ifnum [s] = 0 goto singb
t setstr {[.right(t,[s])]}
endb maclab
b setnum [b]-$80
singb maclab
        dc.b   [b]
 ifnum [s] = 0 goto dclfa
s setnum [s]-1
ord MACLAB
        dc.b   '[.left(t,[s])]'
s setnum 0
 ifstr {[.right(t,1)]} = {`} goto endb
        dc.b   '[.right(t,1)]'!$80
dclfa MACLAB
        dc.w   [[voc]link]-Z
[.lab]  dc.w   [Xaddr]-Z
prevlab setstr [.lab]
[voc]link setstr [.lab]-[l]-3
lastlink setstr [[voc]link]
previmm setnum $80
voc setstr [v]
 ENDM

string MACRO A B
 local e l s
e setstr {[.ext]}
s setstr {'[a]'}
l setstr {[.lab]}
 ifnum   [.nparms] < 2 GOTO stg
 ifstr   {[b]}   <> CR GOTO stg
s setstr {[s],10}
stg maclab
 ifstr {[e]} <> {} goto sst
e setstr w
sst maclab
 ifstr {[l]} <> {} goto slb
l setstr l[.l]
slb maclab
[l] dc.[e] e[l]e-s[l]s
s[l]s dc.b [s]
e[l]e ds.b 0
      ds.w 0
 ENDM

asmlab MACRO name do v voc
 local d
d setstr {[do]}
 ifstr {[d]} <> {} goto cword
d setstr {[name]}
cword maclab
 ifstr {[.ext]} = L GOTO asm2lab
c[.l] create {`[name]]} doconstant {[v]} {[voc]}
        dc.w [d]-Z
 GOTO ende
asm2lab
c[.l] create {`[name]]} dotwoconstant {[v]} {[voc]}
        dc.l [d]-Z
ende maclab
 ENDM

defuser MACRO name v voc
[.lab] create {[name]} douser {[v]} {[voc]}
        dc.w   [.udisp]
u[.lab] equ    [.udisp]
.udisp  setnum [.udisp]+2
 ENDM

def2user MACRO name
[.lab] defuser {[name]}
.udisp setnum [.udisp]+2
 ENDM

* standard layout for QDOS

go      bra.s   install
        dc.l '[.vers]'
        dc.w $4afb
        dc.w 2,'F6'

* system initialisation
install trap    #0
        lea     thntry(pc),a3
        moveq   #0,d0
        move.l  d0,(a3)
        trap    #1
        lea     mtinftab(pc),a2
        movem.l d1/d2/a0,(a2) fr vorzeitigen abbruch
        move.l  $b8(a0),d0
        ble.s   thg_nix ? no things
thg_fnd move.l  d0,a2
        asr.l   #1,d0
        bls.s   thg_nix ?
        bmi.s   thg_nix ?
        move.l  (a2),d0
        bne.s   thg_fnd ?
        lea     $2a(a2),a1
        tst.b   (a1)+
        bne.s   thg_nix ? len
        lea     thgnam+1(pc),a0
        moveq   #5,d0
thg_nam cmp.b   (a1)+,(a0)+
        dbne    d0,thg_nam
        bne.s   thg_nix ?
        move.l  16(a2),a1
        cmp.l   #'THG%',(a1)+
        bne.s   thg_nix ?
        moveq   #-1,d0
        cmp.l   (a1)+,d0
        bne.s   thg_nix ?
        move.l  (a1),a4 th.entry
        move.l  a4,(a3)+ into 4th-vari
        and.w   #$dfff,sr
        lea     hotnam(pc),a0 name
        moveq   #$28,d0 th.uthg thg (a0)+
        moveq   #-1,d1  job
        moveq   #0,d2   parm
        moveq   #-1,d3  time
        jsr     (a4)    >
        bne.s   hot_fnd ? not useable
        move.l  a1,(a3) put hk.thing into 4th-vari
        moveq   #$29,d0 th.fthg
        moveq   #-1,d1  job
        jsr     (a4)    >
        bra.s   hot_fnd
thg_nix and.w   #$dfff,sr
hot_fnd moveq   #0,d7
        move.w  (a7)+,d7
        bgt.s   pif_chn ?
        jsr     iowdw(pc)
        bne     jobremv ?
        moveq   #1,d7
        move.l  a0,-(a7)
pif_chn move.l  (a7),a0
        moveq   #0,d3
        moveq   #112,d0 io.pinf
        trap    #3
        lea     wmanvec(pc),a2
        move.l  a1,(a2) wman entry
        moveq   #14,d0  sd.cure
        trap    #3
        lea     4+syscreen(pc),a1
        jsr     pifoutl(pc)     > (waiting!)
        bpl.s   pif_fnd         ? pif installed
        lea     pifv-2(pc),a1   else empty
        move.w  #pifv-4-Z,(a1)  pif voc.
pif_fnd lea     insxtp(pc),a2
        lea     winhnd(pc),a1
        move.l  a0,d1
        moveq   #9,d0   sd.extop
        trap    #3      > a1 4th table
        moveq   #0,d0
        trap    #1      qdos-data
        swap    d2
        move.b  d2,d0
        lsl.w   #8,d0
        move.b  #'.',d2 clear the 'nation'
        swap    d2
        cmp.l   #'1.10',d2
        smi     d0
        seq     d4      ? JS
        neg.b   d0      hi.w (emu 255) / 0 any / 1 pre-JS
        bne.s   nemu    ? pre-JS
        move.l  124(a0),d3 sv.chtop
        move.l  d3,a2
        lsr.b   #1,d3
        bcs.s   ckjsrom ? again
        cmp.l   #'JSL1',$46(a2)
        seq     d0      lo.w 0 any / 255 minerva-flag
        beq.s   nmirom  ? minerva
ckjsrom swap    d0
        cmp.l   #'SMSQ',(a0)
        seq     d0
        and.b   #-2,d0  flag -2 bei qxl
        bne.s   ckjxql
        not.b   d4
        bne.s   nemu    ? no JS
        tst.b   $a1(a0)
        sne     d0
ckjxql  ext.w   d0      proc-flag
        bne.s   hiproc  ? qxl or 68010+ of atari-ql
        move.w  d0,a2
        move.l  #$fc0000,a4
        cmp.l   (a2)+,(a4)+
        bne.s   hiproc  ?
        cmp.l   (a2)+,(a4)+
        seq     d0
hiproc
nemu    swap    d0
nmirom  lea     procftab(pc),a2
        move.l  (a7),a1
        lea     sys(pc),a3
        sub.w   #sys-Z,a3
        movem.l d0/d1/d2/a0/a1/a3,(a2) emu/miflg job romver sys dft.chan 4thbase
        tst.b   d0
        bmi.s   jdtput          ? minerva
        lea     minervav-2(pc),a1   else empty
        move.w  #minervav-4-Z,(a1)  minerva voc.
jdtput  moveq   #8,d0   mt.susjb
        moveq   #0,d3   no wait
        move.l  d3,a1   no flag
        trap    #1
        move.l  a0,-(a2) put jdt into 4th-vari
        move.l  d1,d2
        moveq   #(43+16+80+jobunlend-jobunl+timemend-timem)>>3,d1
        lsl.w   #3,d1
        moveq   #24,d0    alchp
        trap    #1
        move.l  d0,d3
        bne     jobremv   ? leave if err.om
* dummy heap-mem to safely removing the timer interrupt with the f6-job
        move.l  a0,a1           keep mem base in a0
        move.w  #$4879,(a1)+   00:pea
        move.w  $c2,a2
        move.l  -12(a0),d0      cpl: pea {close-entry}
        beq.s   hep_adr         ? qxl special...
        move.l  d0,a2          02:close-adr
        move.l  12(a2),a2       {close-entry} set to mm_rechp
hep_adr move.l  a2,(a1)+
        move.w  #$4ef9,(a1)+   06:jmp
        pea     (a1)            tos{ptr to addr of new close-routine
        addq.l  #4,a1          08:adr
        move.l  a0,(a1)+       12:new "close" entry
        move.l  a0,-12(a0)      virtual handler addr a1 is now mem+12 = a0+12
        pea     (a1)            tos:{timelinkptr {closeaddr
        addq.l  #4,a1           16:adr timelink
        move.l  d2,(a1)+        20:owner-id
        lea     timadr(pc),a2
        lea     timem(pc),a0
        move.l  a0,(a2)         addr to increment
        lea     timelink+4(pc),a2
        pea     timer(pc)
        move.l  (a7)+,(a2)       poll-routine into linkfield
        pea     timelink-timem(a1) tos{poll-link {timeaddr {destaddr
        moveq   #(timemend-timem)/2-1,d0
timr    move.w  (a0)+,(a1)+     24:+ timer
        dbra    d0,timr
        move.l  a1,a2           save heap-ptr
        move.l  (a7),a0         tos:{poll-link { {
        moveq   #28,d0          mt_lpoll
        trap    #1
        move.l  (a7)+,a1        poll-link {timeaddr destaddr
        move.l  (a7)+,a0        timelinkaddr {destaddr
        move.l  a1,(a0)         linkaddr into heapmem
        move.l  (a7)+,a1        destaddr tos{
        move.l  a2,(a1)         adr jobunl
        move.l  a2,a1           heap-ptr back
        moveq   #(jobunlend-jobunl)/2,d0
        lea     jobunl(pc),a2
jrmov   move.w  (a2)+,(a1)+     xx:jobunl
        dbra    d0,jrmov
        bsr     retrap          > trap redirection table to a1)+
        move.l  a7,a4           init 4th
        bsr     winoutl         >
        movem.l (a7),d0-d1/d3-d6/a0-a4
        lsl.l   #2,d7
        add.l   d7,a7           top of channels
        lea     -chans*4(a7),a5 channel table base
        subq.l  #4,d7           did we just have one channel?
        cmp.w   #4,d7
        bgt.s   notone          ?
        beq.s   twoch
        move.l  d0,d1           out-cons := in-cons
        addq.l  #4,d7
twoch   move.l  d1,d3           work := out-cons
        addq.l  #4,d7           and pretend it was there all along
notone  addq.l  #4*2,d7         put back and include channel 2
        moveq   #-1,d2          channel 2 is initially closed (?printer)
        movem.l d0-d6/a0-a4,(a5) set down what seems to be going
        add.l   a5,d7
        move.l  sp,a2           ptr to command string
chclear move.l  d2,-(a7)        set remaining channels closed
        cmp.l   sp,d7
        bne.s   chclear         ?
        move.l  a5,a0           {limit} data top
        moveq   #-18,d0         err.ov
* 4th-regs: {d6[os]} d7[up] a2[w] a3[nx] a4[ip] a5[sp] a6[bp] a7[rp]
        lea     sys(pc),[bp]
        sub.w   #sys-Z,[bp]     Z=sys+8000 disp into 64K-system
        sub.l   [bp],a5
        move.w  a5,limit+2-Z([bp]) datatop rel(a6) to limit
        lea     -bmag(a5),a1       buffer space
        move.w  a1,first+2-Z([bp])        bot
        move.w  a1,prev+2-Z([bp])
        move.w  a1,use+2-Z([bp])
        move.l  a1,a5
        sub.w   nuser+2-Z([bp]),a5 u0 & r0
        move.l  a5,[up]
        lea     -tibrp(a5),a7   tib
        move.l  a7,a1           s0
        movem.L [up]/a1/a5,oup-Z([bp])
        move.w  a7,otib-Z([bp])
        add.l   [bp],a5         prepare true rp
        add.l   [bp],a7         s0
        moveq   #0,d0
        move.l  a0,d1           {limit}
        sub.l   a7,d1
        lsr.l   #2,d1
        subq.w  #1,d1
        ble     jobremv
btclr   move.l  d0,-(a0)
        dbra    d1,btclr        datatop
        move.l  a7,a1           s0 = tib
        move.w  (a2)+,d2        command stg
        move.w  #tibrp-rpmin-2,d0
        chk     d0,d2
        bvc.s   cmdmov          ? stg within limits
        move.w  d0,d2
cmdtib  move.b  (a2)+,(a1)+
cmdmov  dbra    d2,cmdtib
        sf      (a1)+
        sf      (a1)
        exg     a5,a7
        jmp     inicold(pc)

iowdw   bsr.s   opncon  >
        beq.s   iow_ret ?
        bsr.s   windft  >
opncon  lea     syscreen(pc),a1
        move.w  $c6,a2
        jsr     (a2)    > ut.con
        move.l  d0,d3
iow_ret rts

windft  moveq   #0,d2
        lea     syscreen+12(pc),a1
        move.l  d2,(a1)
        move.l  #$02000100,-(a1)
        subq.l  #4,a1
        move.l  sysvari(pc),a0
        move.l  120(a0),a0
        move.l  4(a0),a0
        move.l  16(a0),d1
        move.w  #1,d1
        move.l  d1,a0
        moveq   #108,d0  io.flim
        trap    #3
        move.l  d0,d3
        beq.s   wft_ret
        not.l   d0
wft_ret rts

winoutl lea     wdw_siz(pc),a2
        move.w  d7,d5
        dbmi    d5,wochan
        rts
wochan  sub.w   #12,a7
wolop   move.l  (a4)+,d0
        ble.s   wonxt   ? don't link qdos-channel 0
        move.l  d0,a0
        move.l  a7,a1
        moveq   #-1,d3  try always
        moveq   #9,d0   sd.extop
        trap    #3      init a pif channel
        pea     -12(a1)  (this is for "ptr_pif" which also
        cmp.l   (a7)+,a7 (would work with a buried window
        bne.s   wonxt   ?
        bsr.s   pifwsav
wonxt   dbra    d5,wolop
        add.w   #12,a7
        rts

pifwsav moveq   #0,d1
        move.l  d1,a1
        moveq   #126,d0 iop.wsav
        trap    #3
        lea     4(a7),a1
pifoutl moveq   #-1,d3
        moveq   #1,d2
        moveq   #0,d1
        moveq   #122,d0 iop.outl
        trap    #3
        addq.l  #1,d0
        rts

insxtp  move.w  d1,d3           keep for pex-channel
        lsl.w   #2,d1           id => disp
        move.l  120(a6),a2      qdos
        move.l  (a2),a4         cdt 0
        move.l  4(a4),a5
        move.l  a5,(a1)+        hnd into 4th-vari
        move.l  196-24(a5),d0   pt.ptrok-ch.lio points to the pif ok-code
        lea     24(a3),a4       own hnd
        move.l  a4,(a1)+
        move.l  a0,d2           parm-cdt
        lea     0(a2,d1.w),a4   table
        sub.l   (a4),d2         qdos-cdt
        move.l  d2,(a1)+        pif-disp or zero
        move.l  d0,a2           pex switching
        asr.l   #1,d0
        bls.s   winxtp
        bmi.s   winxtp
        cmp.l   #'PIF'<<8,-(a2) check pex-flag
        bne.s   winxtp
        move.b  #1,8(a2,d3.w)   'peon' 1st channel
winxtp  moveq   #0,d0
        rts

adrer   equ  0
illeg   equ  4
divz    equ  8
chk     equ 12
tpv     equ 16  TRAPV
privi   equ 20  24 TRACE
ilv7    equ 28
t05     equ 32  36 T06,T07,T08,T09,T0A,T0B,T0C,T0D,T0E,T0F

cton    dc.w  -1 flag set on aerr entry
tvtregs dcb.l 22,0

* in:  a1 new table address
retrap  addq.l  #8,a1
        move.l  a1,a2
        moveq   #18,d0
        lea     go(pc),a6
        lea     rtecode(pc),a0  nur rte bei leerer tabelle
rteins  move.l  a0,(a2)+
        dbra    d0,rteins
* insert new routines
        lea     n_adrer(pc),a0  1st routine
        move.l  a0,(a1)
        lea     n_illeg(pc),a0
        move.l  a0,illeg-adrer(a1)
        lea     n_chk(pc),a0
        move.l  a0,chk-adrer(a1)
        move.l  mtinftab(pc),d1 current job
        moveq   #7,d0
        trap    #1
        rts

n_chk   st      1(a7)          for the qdos word {chk}
        rte

n_illeg move.w  (a7),-([sp])   to replace qdos trap #0
        bset    #5,(a7)        ret supervisor
        addq.l  #2,2(a7)       to _after_ illeg. instruction
        rte

* 68010+ not tested, 68040 oke (qxl)
n_adrer move.w  procftab(pc),-(a7)
        addq.l  #2,a7
        bpl.s   proc00          ? 6800x
        tas     8(a7)           soft re-run
        move.l  10(a7),-(a7)    stack-typ & error address & extra status
        move.l  10(a7),-(a7)
proc00  move.l  a0,-(a7)
        lea     cton+1(pc),a0   ;;tvtregs-1(pc),a0
        sf      (a0)+           flag error source
        movem.l d0-d7/a0-a6,(a0)
        movem.l (a7)+,d3/d4/d5  A0 & aerr-extra
        move.l  d3,32(a0)       A0
        movem.l -2(a7),d1/d2    xxSR & PC
        ext.l   d1
        move.l  usp,a1
        move.l  a1,d0
        movem.l d0-d2/d4/d5,60(a0) USP xxSR PC extra 2.l
        lea     next(pc),[nx]
        bclr    #0,d0
        move.l  d0,a1
        move.l  a1,usp
        movem.l (a0),d0-d7/a0/a1
        pea     adrcold(pc)
        bne.s   adrrcld         ? cold if rp error
        pea     ([bp])
        lea     sys(pc),[bp]
        sub.w   #sys-Z,[bp]
        cmp.l   (a7)+,[bp]
        bne.s   adrrcld         ? cold if baseptr lost
        addq.l  #4,sp           drop cold
        pea     adrwarm(pc)     push warm
adrrcld move.l  (a7)+,2(a7)     move routine to rte-posn
        bclr    #5,(a7)         back to user state
rtecode rte

adrwarm bsr   adrregs
        lea     0([bp],a1.l),[rp]
        bsr   adrmon  >
        moveq   #27,d0  message
        jmp     cputerr(pc)

m setstr {d0-d4/d6/d7/a0/a2/a3}
p setstr {d4/d6/d7/a0}
* RET: d5.l +ve no / -ve break pressed; d5.w +ve no / -ve altkey
*(this routine must not change the processor mode)
tbreak  movem.l [m],-(a7)
        move.w  d5,d1
        moveq   #0,d5
        move.b  d1,d5   hi.bit flag
        move.l  sysvari(pc),a2
        move.l  $4c(a2),d1 keyboard queue
        ble.s   nxkbr   ? nix
        move.l  120(a2),a0 sv_chbas
        move.l  d1,a2
        ror.b   #1,d1
        bcs.s   nxkbr   ? not an address
        lea     -104+8(a2),a3   JS+ disp to ch_owner
        sub.w   2+pifdsp(pc),a3 pif cdt-disp
        move.l  mtinftab(pc),d1 f6 job-id
        cmp.l   (a3)+,d1
        beq.s   nxbpts  ? own channel
        cmp.l   (a3),d1 pre-JS
        beq.s   nxbpts  ?
        move.l  a2,a3
        sub.w   2+pifdsp(pc),a3
        move.l  (a0),a0
        move.l  4(a0),a0
        cmp.l   $68(a0),a3 pt_dumq
        bne.s   nxkbr   ? not the pif aux. queue
nxbpts  movem.l (a2),[p] save ptrs
nxbaky  not.b   d1
        seq     d3
        ext.w   d3
        move.w  226,a3
        jsr     (a3)    >io_qout
        bmi.s   nxnbr
        move.b  d5,d3
        sub.b   d1,d3
        bne.s   nxbaky  ? not the break-key
        lea     quit+2(pc),[ip]
        lea     origin+4(pc),a1 warmstart
        moveq   #-1,d5  flag break pressed
        move.w  d3,d5   flag altkey
        bmi.s   nxkbr   ? {warm} on altkey
        lea     next(pc),a1 {quit}
        bra.s   nxkbr   - continue
nxnbr   movem.l [p],(a2)  rst ptrs
nxkbr   movem.l (a7)+,[m]
        rts

* "address error" - error routines
adrregs trap    #0      system stack should be safe
        jsr     calwarm(pc)
        lea     0([bp],a0.l),[sp]
        and.w   #$dfff,sr
        rts

* "fatal error" - might be a last chance,
* at least to checking the offending registers
adrcold bsr.s   adrregs
        lea     0([bp],a1.l),[rp]
        bsr.s   adrmon  >
        lea     colder(pc),a1   warning message
        jmp     aercold(pc)

* display the regs after a trapped address error
adrmon  lea     tvtregs-1(pc),a2
        tas     (a2)+
        bne.s   arrret  ? not an exeption trap call
        moveq   #6,d6
        bsr.s   adrrout >print d0-d7
        moveq   #6,d6
        bsr.s   adrrout >a0-a7
        moveq   #2,d6
adrrout moveq   #10,d1  <regs) and sr,pc,aerr-extra
        bsr.s   arrbyt  >
adrrlop move.l  (a2)+,d2
        bsr.s   arrnum  >
        dbra    d6,adrrlop
        move.l  (a2)+,d2
arrnum  bsr.s   arrval
        moveq   #' ',d1
        bra.s   arrbyt  -
arrval  move.l  deftch(pc),a0
        moveq   #1,d3
        moveq   #6,d4
arrdlp  bsr.s   arrdig
        dbra    d4,arrdlp
arrdig  rol.l   #4,d2
        moveq   #15,d1
        and.b   d2,d1
        eor.b   d1,d2
        move.b  arrtab(pc,d1.w),d1
arrbyt  moveq   #5,d0
        trap    #3
arrret  rts
arrtab dc.b '0123456789abcdef'

;;fbrkret move.l  (a7)+,d5
;        move.l  (a7)+,a1
;        rts

n_DIVZ  ; useless
n_privi ; check & emulate if statusreg involved
n_TRACE ; ?debug
n_T06
n_T07
n_T08
n_T09
n_T0A
n_T0B
n_T0C
n_T0D
n_T0E  ; tt-sondermll abfangen
n_T0F   rte

Xcache  move.l  sysvari-Z([bp]),a0
        moveq   #0,d0
        move.b  200(a0),d0
        and.b   202(a0),d0
        sne     d0
        neg.b   d0
        move.w  d0,-([sp])
        [jnx]

* extop wdw-parm to mem (a1)+ : sizes origin border.col .wdt
wdw_siz lea     24(a0),a2       ptr auf sd.xymin
        move.l  (a2)+,d6        xmin|ymin
        move.l  (a2)+,d4        xsiz|ysiz
        move.l  (a2),d3         borwd|xxx & ptr auf xypos
        move.w  (a2),d3
        add.w   d3,d3
        move.l  d3,d2
        swap    d2              2*b|1*b
        sub.l   d2,d6           b>xmin
        add.l   d2,d2           4*bwd.x/2*bwd.y
        add.l   d2,d4
        move.l  d4,(a1)+        b>x/ysize    xw/yw :  8/10
        move.l  d6,(a1)+        b>x/ymin     x0/y0 : 12/14
        move.w  70(a0),d3       bcolr           bc : 16
        swap    d3
        move.l  d3,(a1)+        borwd           bw : 18
        moveq   #0,d0
        rts

* -- install 

* wmov (16-bit-)vari im datenstack
; grenzwerte aus flim
XM equ 0  max breite
YM equ 2  max hhe
XO equ 4  min x-ursprung
YO equ 6  min y
; arbeitswerte aus hit-area
XW equ 8  breite
YW equ 10 hhe
X0 equ 12 links
Y0 equ 14 oben
; border aus cdt
BC equ 16 farbe
;BW equ 18 border
; min. fenstergre aus cdt   ; => primrfenster
*       ;=> cx(a1): d1:outsiz d5:outmax d6:xydisp d7:xdisp a2:outorg
CX equ 20 curwdt+4*border       =>    breit outl
CY equ 22 curhgt+2*border       =>    hoch  outl
; aktualisierte amx. werte
WL equ 24 aktuell max ursprung  =>    rechts max
WA equ 26 links & oben          =>    unten max
;WW equ 28 max. mae dto. fr    =>    xdisp
;WH equ 30 breite & hhe         =>    ydisp
; anfangsmae zur endjustage
;WS equ 32 mae und              =>    xdisp|0000
WO equ 36 ursprung in border    =>    outorgx|y
;HS equ 40 hit-area mae
;HO equ 44 dto ursprung
;BB equ 48 4*b|2*b zum rechnen
; aus sd.pxenq
WC equ 52 cursor
wmx equ 56 ende fensterdaten
;
SM equ wmx  -ve pixelstufung
SV equ sm+2 +ve
SW equ sv+2 keyrow verzgerung
;
mbrd  equ sw+2
mblen equ 12 : 0/2:ursprung 4/6:mae 8:borwd 10:dummy(bcolr)
;
mlen   equ mbrd+16*mblen+8 bereichsgre & reserve
winc   equ 1     stufung der ursprungs-/ma-vernderung
wdel   equ 1     min. keyrow-verzgerung
;wdelmx equ 15    max.

contab dc.w ctbend-*-2
       dc.b 'scr' hilfsfenster
ctbend ds.b 0
       ds.w 0

* extop: anfangsdaten nach 8(a1)+ bringen
wdw_prm lea     mbrd(a1),a4
        move.b  17(a0),(a4)+
        spl     (a4)+           -ve bei secundrfenster
        move.l  (a1)+,d5        max breite/hhe xm/ym von flim
        move.l  (a1)+,d7        min ursprung    xo/yo
        bsr     wdw_siz > d2:4*b|2*b d3:bc|bw d4:xw|yw d6:x0|y0 a1:CX a2:borwd>
        move.l  d2,d3           border*xx sichern
        add.l   6(a2),d2        curs.mae von sd.xinc/yinc
        move.l  d2,(a1)+        b>x/yinc        cx/cy : 20 /22
        sub.l   d4,d5           max ursprung in primr-outline
        add.l   d7,d5           mit outline-ursprung
        move.l  d5,(a1)+        b>maxorg        wl/wa : 24/26
        move.l  d4,(a1)+        b>maxsiz        ww/wh : 28/30
        move.l  -(a2),(a1)+     ws: mae und
        move.l  -(a2),(a1)+     wo: ursprung ohne border zur justage
        move.l  d4,(a1)+        hs: copie mae mit border
        move.l  d6,(a1)+        ho: dto ursprung
        move.l  d3,(a1)+        bb: 4*b|2*b border zum rechnen
        moveq   #0,d0
        rts

* fenstermae und border holen
wdwbrdx movem.l 24(a0),d1/d2/d3
        move.w  70(a0),d3
        movem.l d1-d3,(a1)
        moveq   #0,d1
        moveq   #0,d0
        rts
;;* borderbreite nach outline eintragen
;insbrdx move.b  d1,71(a0)       bcolr
;        clr.w   d1
;        move.l  d1,d2
;        add.l   d2,d2
;        swap    d1
;        move.w  d1,d2           2*b|1*b
;        lea     24(a0),a2
;        add.l   d2,(a2)+
;        add.l   d2,d2           4*b|2*b
;        sub.l   d2,(a2)+
;        move.w  d1,(a2)         borwd
;        rts
* extop fr primrfenster zum justieren zugehriger secundrfenster
wmvpwdx moveq   #-2,d0
        tst.b   17(a0)
        bpl.s   wmpret  ? nicht primrfenster
        movem.w wo(a1),d4/d5 wdw-x/yorg alt
        movem.w 24(a0),d6/d7            neu
        sub.w   d4,d6   xdisp
        sub.w   d5,d7   ydisp
        swap    d6
        move.w  d7,d6
        move.l  d6,d7   ww : d6 : xdisp|ydisp
        clr.w   d7      ws : d7 : xdisp|0000
        movem.l -16(a0),d5/a2 outl siz/org neu  => wo : a2 : outl origin
        move.l  d5,d1   => cx : d1   : outl mae
        add.l   a2,d5   => wl : d5   : grenzen rechts & unten
        movem.l d1/d5/d6/d7/a2,cx(a1)
* cx(a1): d1:outsiz d5:outmax d6:xydisp d7:xdisp a2:outorg
        moveq   #0,d0
wmpret  rts

* secundr- innerhalb primrfenster justieren
* REIN: d1:sec.wd-daten a1:memptr  RAUS: d1:bcolr|borwd a1)+ wdef-parm
wmvjstx moveq   #-2,d0  err.nj
        tst.b   17(a0)
        bmi.s   wmpret  ? nicht secundrfenster
        move.l  d1,a2
        move.l  mtinftab(pc),d1 : job-id
        move.l  a0,a4
        sub.l   pifdsp(pc),a4
        cmp.l   8(a4),d1
        bne.s   wmjret  ? fremder besitzer
* cx(a1): d3:outsiz d5:outmax d6:xydisp d7:xdisp a4:outorg
        movem.l cx(a1),d3/d5/d6/d7/a4
        movem.l (a2),d1/d2/a5 ursprung & mae & borwd|bcolr
        move.l  a5,d4
        move.l  d4,d0
        swap    d0
        add.w   d0,d0
        move.w  d0,d4
        swap    d4
        add.l   d4,d4   4*b|2*b
* d3:breit|hoch d4:4b|2b.neu d5:max rechts|unten  d6:xdisp|ydisp  d7:xdisp|0
* a4:hitorg     a5:borwd|xx
        move.l  38(a0),d0 wdt|hgt cursor
        add.l   d4,d0   min. wdw in cursorgre
        add.l   d4,d2   aktuelle mae mit border
        lsr.l   #1,d4   2*b|1*b
        sub.l   d4,d1   aktueller ursprung ohne border
        sub.w   d0,d5   untere grenze fr neuen ursprung
        move.l  a4,d4   outl-org
        add.w   d6,d1   ydisp
        blt.s   wmjxom  ? min bei yo -ve
        cmp.w   d4,d1   outl-org
        bge.s   wmjcxo  ? obere grenze passt
wmjxom  move.w  d4,d1   outl-org oberer-ursprung
wmjcxo  cmp.w   d5,d1   yorg-unten
        ble.s   wmjyo   ? passt
        move.w  d5,d1   max.
wmjyo   move.w  d1,d4   x|y
        add.l   d7,d1   xdisp
        blt.s   wmjyom  ? min bei xo -ve
        cmp.l   d4,d1   hitorg
        bge.s   wmjcyo  ? linke grenze passt
wmjyom  move.l  d4,d1   outl-org min. linker ursprung
wmjcyo
* d3:breit|hoch  d4:4b|2b  d5:max rechts|unten  d6:xdisp|ydisp  d7:xdisp|0
* a4:hitorg      a5:borwd|xx
        cmp.w   d3,d2
        ble.s   wmjcys  ? hhe passt
        move.w  d3,d2
        move.w  a4,d1
wmjcys  move.w  d2,d3   gltige hhe
        cmp.l   d3,d2
        ble.s   wmjxs   ? breite passt
        move.l  d3,d2
        move.l  a4,d0
        move.w  d1,d0
        move.l  d0,d1
wmjxs   move.l  d2,(a1)+
        move.l  d1,(a1)+
        move.l  a5,d1      borwd
        move.w  70(a0),d1  bcolr
        moveq   #0,d0
wmjret  rts

* trap-aufrufe
outl3w  lea     xw(a4),a1
outl3   moveq   #0,d2
;outl3b
        move.l  d7,d0           13 wdef oder 122 outl
        moveq   #0,d1
tp3w    trap    #3
        not.l   d0
        beq.s   tp3_ret
        not.w   d0
tp3_ret rts

* secundrfenster: mit maen aus hits/hito innerhalb flim verndern
* primrfenster nach <enter>
* dto. und fenster als neue outline, secundrfenster mitgenommen
gowmov  moveq   #-7,d0      <wmov entry
        move.l  d0,qf.error-Z([bp])
        moveq   #8,d0       mt_jusjb
        move.l  mtinftab(pc),d1
        moveq   #20,d3      wait to key de-bouncing
        trap    #1
        jsr     isopenc(pc)
        tst.w   ([sp])+
        bne.s   wmv_och ?       ;;beq     next        ? no (own) channel
wmv_jnx [jnx]
wmv_och move.l  d3,d0
        ble.s   wmv_jnx ?       ;;ble     next        ? not open
        move.l  d3,a0                window
        move.l  mtinftab-Z([bp]),d1  job
        movem.l d6/d7/a3-a5,-(a7) d1:job-id d4:kanal-id a0:sys a1(a6):parmptr
        lea     -mlen([sp]),a4 wmov-daten und 16*borwd
        move.w  #-winc,sm(a4)
        move.w  #winc,sv(a4)
        move.w  #wdel,sw(a4)
        move.l  a0,a5           a5:hauptfenster
        move.l  d1,d5           job sichern
        moveq   #122,d7         outl code vorbereiten
        moveq   #8,d2           k.wake
        moveq   #124,d0         pick
        moveq   #-1,d3          warten
        trap    #3              job holen
        moveq   #108,d0         flim
        moveq   #0,d2
        move.l  a4,a1
        bsr.s   tp3w            >
        lea     contab(pc),a0   a0:hilfsfenster
        move.l  d5,d1           job
        moveq   #0,d3           open einfach
        moveq   #1,d0           open berhaupt
        trap    #2
        tst.l   d0
        bne     wmv_ret         ? err.om
        moveq   #-1,d3          warten
        moveq   #41,d0          sd.setin
        moveq   #0,d1           nur zur
        trap    #3              pif-anmeldung
        move.l  a0,d4           d4:hilfsfenster
        move.l  a5,a0           a0:hauptfenster
        lea     wc-4(a4),a1     fr cursorposn
        moveq   #10,d0          sd.pxenq
        bsr     tp3w            >
        move.l  a4,a1           ablage
        lea     wdw_prm(pc),a2  fensterdaten
        moveq   #9,d0           sd.extop
        bsr     tp3w            >
wmj_clo bne     clos            ?
        move.l  d4,a0           : hilfsfenster
        moveq   #126,d0         wsav
        moveq   #0,d1
        move.l  d1,a1
        bsr     tp3w            >
        bne.s   wmj_clo         ?
        bsr     outl3w          > d7:neues fenster fixiert
        bne.s   wmj_clo ?
        move.l  a5,a0           :hauptfenster
* ursprung, mae & borwd der secundrfenster
        jsr     wcollect(pc)    > mae einsammeln
        lea     xm(a4),a1       uere grenzen
* ?? bei secundrfenster mit d2:=2 (?) : NEE!
        bsr     outl3          > d7:outl ganzer bildschirm
        bne.s   wmj_clo ?
        moveq   #13,d7          wdef statt outl
        bsr     outl3w          >
        bne.s   wmj_clo
        moveq   #122,d7         outl wieder outl
        move.l  d4,a0           :hilfsfenster
        moveq   #127,d0         wrst
        moveq   #0,d2
        move.l  d2,a1
        trap    #3              fensterinhalt erneuern
        moveq   #0,d1           rel. ursprung
        move.l  d1,-(a7)
        move.l  xw(a4),d2       format
        move.l  d2,-(a7)
        move.l  d1,a2           ohne adresse
        move.l  sp,a1
        moveq   #109,d0         svpw
        trap    #3              bild sichern
        addq.l  #8,sp
        tst.l   d0
        bne.s   wmj_clo         ? err.om
        move.l  d1,a2           bildadresse
        move.l  xw(a4),d6       maximalmae sichern
        bsr.s   wsel           >>> fenster schubsen
        move.l  a0,d4           :hilfsfenster-id sichern
        move.l  a5,a0           a0:hauptfenster
        bsr     outl3w          > wdef nach esc, sonst outline neu
        move.l  xw(a4),d2       aktuelle breite
        bsr.s   wszs            > gegen maximum
        swap    d2
        move.l  d2,d6           breite als curs.max.
        moveq   #110,d0         rspw
        moveq   #0,d2           mem auflsen
        move.l  d2,-(a7)        ursprung
        move.l  d1,-(a7)        format ganzes fenster
        moveq   #0,d1           rel. im ursprung
        move.l  sp,a1           (a2 von svpw)
        trap    #3
        addq.l  #8,sp
        pea     wmv_rcp(pc)     hilfskanal zu und secundrfenster justieren
        movem.w bc(a4),d1/d2
wsl_sbd moveq   #-1,d3
wsl_brd moveq   #12,d0          bordr
        trap    #3
        rts

xbrd    st      d1
        moveq   #1,d2
        bra.s   wsl_brd

wsl_xit moveq   #0,d1
        moveq   #0,d2
        bra.s   wsl_sbd

wszs    bsr.s   wmin
        swap    d2
        swap    d6
wmin    move.w  d2,d1
        cmp.w   d6,d1
        bls.s   min_ret
        move.w  d6,d1
min_ret swap    d1
        rts

kynix   addq.l  #4,sp           <falsche taste
        and.w   #$dfff,sr       user
wsel    moveq   #1,d3
        bsr.s   xbrd            > border markieren
kysel ;;moveq   #1,d0           dummy fbyte
      ;;trap    #3              delay
rosel   moveq   #1,d0           keyrow 1
      ;;moveq   #127,d3         max (ca) 2 sec
      ;;and.w   sw(a4),d3       inkey-wartezeit
        bsr.s   kyro            > fragen
        moveq   #%11010110,d4   <spc> und cursor-maske
        and.b   d5,d4           {s<en}
        rol.b   #2,d5           "<" im sign-bit
        beq.s   kysel           ? keine taste
        asr.b   #3,d5           ENTER   (dann nur: lsr.b #1)
        bcs.s   wsl_xit         ? fertig mit neuer outline
        asr.b   #3,d5
        bcs.s   kquit           ? ESC
        bpl.s   nwdf            ? oder "<" (weil meine esc-taste kaputt ist)
kquit   moveq   #13,d7          wdef
        bra.s   wsl_xit         new sizes, old outline
nwdf    moveq   #7,d0
        bsr.s   kyro            >
        lsr.b   #1,d5
        subx.w  d2,d2           SHIFT
        move.b  d4,d2           %ssssssss.0db0.r0ul
        beq.s   rosel           ?
        and.b   #3,d5           step-multiplikator
        trap    #0              supv
        move.l  a4,a3           mem
        lea     curtab(pc),a1   table of actions
        moveq   #17,d0
kytab   move.l  (a1)+,d1
        cmp.w   d1,d2
        dbeq    d0,kytab
        swap    d1
        move.w  sv(a3),d2
        jsr     -4(a1,d1.w)     > action
        and.w   #$dfff,sr
        moveq   #-1,d3
        moveq   #12,d0          bordr
        moveq   #0,d1
        moveq   #0,d2           wegnehmen
        trap    #3
        bsr     outl3w          > outline erneuern
        bne.s   rosel
        movem.l xm(a4),d0/d1/d2/d5 xm xo xw x0
        sub.l   d2,d0
        add.l   d1,d0           xm-xw+xo
        sub.l   d5,d1
        movem.l d0/d1,wl(a4)    max ursprung & mae erneuert
        bra.s   wsel            und mit border weiter

* REIN: d0 keyrow a0 aktueller con-kanal
* RAUS: d5.b code VERDIRBT: d1 ERHLT: d4 d6 d7 a0 a2 a4-a6
* darf nur im USER-mode aufgerufen werden.
kyro    lsl.w   #8,d0           keyrow
        addq.b  #2,d0           ipc-kommando
        movem.l d0/d7/a0/a3,-(a7)
        move.l  #$09010000,-(a7)
        trap    #0              (supv)
;;moveq   #1,d0           fbyte fr die
;;trap    #3              tasten-wartezeit
        moveq   #0,d0
        trap    #1
        move.l  usp,a3
        moveq   #17,d0
        trap    #1
        move.w  d1,d5
        move.l  76(a0),d7       sv_keyq
        ble.s   kyrnky          ? none
        move.l  d7,a0           i/o-queue
        lsr.b   #1,d7
        bcs.s   kyrnky          ?adressenfehler
        add.w   #12,a0
        move.l  (a0),-(a0)      clear
kyrnky  and.w   #$dfff,sr
        addq.l  #8,sp
        movem.l (a7)+,d7/a0/a3
        rts

curtab  dc.w wm-*,2         ursprung
        dc.w hm-*,4   
        dc.w wp-*,16  
        dc.w hp-*,$80 
        dc.w bm-*,$ff02      begrenzung
        dc.w am-*,$ff04
        dc.w bp-*,$ff10
        dc.w ap-*,$ff80
        dc.w wmm-*,6         dto., diagonal
        dc.w wpm-*,20
        dc.w wmp-*,$82
        dc.w wpp-*,$90
        dc.w bmm-*,$ff06
        dc.w bpm-*,$ff14
        dc.w bmp-*,$ff82
        dc.w bpp-*,$ff90
        dc.w cu-*,$40        winzfenster
        dc.w kynix-*         rest

* ursprung links
wm      move.w  sm(a3),d2       left
wp      lsl.w   d5,d2
        lea     x0(a3),a1       right
        add.w   (a1),d2         num
        move.w  xo(a3),d1       min l
        move.w  wl(a3),d0       max
        bra.s   wwithin

* ursprung oben & diagonal
wpm     bsr.s   wp
        bra.s   hm
wmm     bsr.s   wm
hm      move.w  sm(a3),d2       up
        bra.s   ckh
wpp     bsr.s   wp
        bra.s   hp
wmp     bsr.s   wm
hp      move.w  sv(a3),d2       down
ckh     lsl.w   d5,d2
        lea     y0(a3),a1
        add.w   (a1),d2
        move.w  yo(a3),d1       min top
        move.w  wa(a3),d0       max
        bra.s   wwithin

* grenze rechts
bm      move.w  sm(a3),d2       left
bp      lsl.w   d5,d2
        lea     xw(a3),a1       right
        add.w   (a1),d2
        move.w  cx(a3),d1       min = cursor size
        move.w  xm(a3),d0       limit width
        sub.w   x0(a3),d0       origin
        add.w   xo(a3),d0       min left
        bra.s   wwithin

* grenze unten & diagonal
bpm     bsr.s   bp
        bra.s   am
bmm     bsr.s   bm
am      move.w  sm(a3),d2       up
        bra.s   cka
bpp     bsr.s   bp
        bra.s   ap
bmp     bsr.s   bm
ap      move.w  sv(a3),d2       down
cka     lsl.w   d5,d2
        lea     yw(a3),a1
        add.w   (a1),d2
        move.w  cy(a3),d1       min = cursor size
        move.w  ym(a3),d0       max height
        sub.w   y0(a3),d0       origin
        add.w   yo(a3),d0       min. top
* d2 auf bereich d1 bis d0 justiert in (a1) ablegen
wwithin tst.w   d2
        bpl.s   valin           ?
        clr.w   d2              don't wrap
valin   cmp.w   d2,d0           d0:max d1:min d2:num - ret:d0 { d1<=d2<=d0 }
        bls.s   wwput           ? max <= num
        move.w  d2,d0           n1
        cmp.w   d2,d1                                                         
        bls.s   wwput           ? min <= num
        move.w  d1,d0           min
wwput   move.w  d0,(a1)
        rts

* schrupf-fenster im cursorformat
cu      move.l  cx(a3),xw(a3)
        rts

* alle f6-kanle : fensterdaten einsammeln
wcollect movem.l d7/a0/a4,-(sp)
        move.l  [bp],a3
        add.w   climit-Z([bp]),a3
        moveq   #chans-1,d6
        moveq   #-1,d3
        add.w   #mbrd,a4
        lea     wdwbrdx(pc),a2  fensterdaten holen
wco_lop move.l  a4,a1
        move.l  (a3)+,d0
        ble.s   wco_err ? kein kanal
        cmp.l   d0,d4
        beq.s   wco_err ? hilfskanal
        move.l  d0,a0
        moveq   #-1,d1
        moveq   #9,d0
        trap    #3
        addq.l  #1,d0
        bmi.s   wco_err
        tst.l   d1
        beq.s   wco_nxt
wco_err st      (a4)
wco_nxt add.w   #mblen,a4
        dbra    d6,wco_lop
        movem.l (sp)+,d7/a0/a4
        rts

* secundrfenster justieren
wmv_rcp move.l  a5,a0   hauptfenster
        lea     wmvpwdx(pc),a2
        move.l  a4,a1   datenptr
        moveq   #0,d1   kontrolle
        moveq   #-1,d3
        moveq   #9,d0   extop
        trap    #3
        addq.l  #1,d0
        bmi.s   wmvclo  ? falscher besitzerjob (oder sonstwas)
        tst.l   d1
        ble.s   wmvclo  ? extop nicht ausgefhrt
        moveq   #-1,d3
        move.l  [bp],a3
        add.w   climit-Z([bp]),a3
        moveq   #chans-1,d6
        move.l  a4,d7
        add.w   #mbrd,a4
wmvjlop move.l  (a3)+,d0
        ble.s   wmvjnxc ? kein kanal
        cmp.l   d0,a5
        beq.s   wmvjnxc ? wmov-fenster
        cmp.l   d0,d4
        beq.s   wmvjnxc ? hilfskanal
        move.l  d0,a0
        move.l  d7,a1   wdef-daten
        tst.b   (a4)    alte daten
        bmi.s   wmvjnxc ? nicht fenster
        lea     wmvjstx(pc),a2 0justagedaten holen
        move.l  a4,d1   kontrolle
        moveq   #9,d0   extop
        trap    #3
        addq.l  #1,d0
        bmi.s   wmvjnxc ? irgendwas falsch
        cmp.l   a4,d1
        beq.s   wmvjnxc ? nicht ausgefhrt
        move.l  d1,d5   borwd|bcolr
        move.l  d7,a1   daten
        move.l  d1,d2
        swap    d2
        moveq   #13,d0
        trap    #3
        tst.l   d0
        beq.s   wmvjnxc
        moveq   #122,d0 io_outl
        moveq   #0,d1
        moveq   #2,d2   iop..mov
        trap    #3
        move.l  d5,d1           ;
                ;2;move.l  d7,a1
                ;2;lea     insbrdx(pc),a2  ;move.l  d5,d2
        move.l  d1,d2
        swap    d2
        moveq   #12,d0 sd_bordr ;moveq #13,d0  ;
                ;2;moveq   #9,d0 ;;moveq   #13,d0  sd_wdef
        trap    #3
wmvjnxc add.w   #mblen,a4
        dbra    d6,wmvjlop
        move.l  d7,a4
        move.l  wc(a4),d2 curs x/y
        move.l  d2,d1
        swap    d1
        move.l  a5,a0
        moveq   #23,d0  sd_pixp
        trap    #3
* close aux. window
wmvclo
clos    move.l  d0,d7
        move.l  d4,a0   hilfsfenster
        moveq   #2,d0   schlieen
        trap    #2
        move.l  d7,d0
wmv_ret move.l  d0,qf.error-Z([bp])
        movem.l (a7)+,d6/d7/a3-a5
        jmp     Xqkey(pc) ;;[jnx]

* +++ edline for expect

qxp     move.l  (a7)+,[nx]
        move.w  ([sp])+,d0
        move.w  d0,uspan([bp],[up].l)
        move.l  [bp],a0
        add.w   ([sp])+,a0
        subq.w  #1,d0
        bmi.s   qxpr
        lea     -2(a0),a1
qxpm    move.b  (a0)+,(a1)+
        dbra    d0,qxpm
        move.b  #' ',(a1)+
        sf      (a1)
qxpr    [jnx]

* kbd editting to substitute expect
Xqexpect neg.w  ([sp])     erase buffer area
        pea     ([nx])
        lea     qxp(pc),[nx]
Xedline clr.w   -([sp])    in-cons (-ve len to erase the buffer area)
        jsr     cdashwd(pc) > a0: id
        tst.w   ([sp])+
        movem.w ([sp])+,d2/a2 maxcount buffer
        bne.s   edlstg    ? window
        lea     2(a2),a1
        jsr     jexpect(pc) >
        addq.w  #1,d3
        ble     putnul    ?
        sub.l   [bp],a1
        sub.w   d1,a1
        subq.w  #2,a1
        move.w  a1,-([sp])
        move.w  d1,-([sp])
        [jnx]

edlstg  moveq   #0,d4
        move.w  d2,d3
        bpl.s   edlbuf ?
        neg.w   d3
        move.w  d3,d2
        lea     0([bp],a2.w),a1
edlcbf  move.b  d4,(a1)+  clr buffer & count.w
        dbra    d3,edlcbf
edlbuf  move.b  1([bp],a2.w),d4
        sf      0([bp],a2.w)
        movem.l d6/d7/a3,-(a7) regs
        lea     2(a6,a2.w),a2 1st char ptr
        subq.l  #8,[sp]
        move.l  [sp],a1   window data
        moveq   #-1,d3    no timeout
        move.w  d2,d7     buf.len
        cmp.w   d2,d4
        ble.s   edlen     ? stg fits
        move.w  d4,d7     max($len,buffer)
edlen   addq.w  #1,d7     + cursor
        moveq   #-1,d6    max.timo hi.w
        move.w  d3,d6     & std timo
        moveq   #11,d0    sd.chenq
        pea     edl_tim(pc) exit on timeout
        bsr.s   edl_qtrp  trap rel(a6)
        move.l  d6,d3     timeout back
        move.l  4([sp]),d5
edl_lerr moveq  #0,d6     start/error with cursor at end of stg
edl_lop bsr.s   edl_cur   go to curpos
        move.w  d4,d2     len=num of bytes
        lea     0(a2,d4.w),a1
        move.b  #32,(a1)
        move.l  a2,a1     string
        moveq   #7,d0     < io.sstrg  d2.count d3.timo a0.id   a1.buffer
        bsr.s   edl_qtrp  > d1.sent   d2.cons  d3.cons a0.cons a1.updt
        moveq   #32,d1
        moveq   #5,d0     io.sbyte
        bsr.s   edl_qtrp
        moveq   #19,d0    sd.pcol
        bsr.s   edl_qtrp
        move.w  d4,d1     e.o.l.
        swap    d1        packed posn
        cmp.b   #198,d6   cur up
        bne.s   edl_acur  ? not (this works with minerva only)
        pea     edl_lerr(pc) on error retry
        bsr.s   edl_cur   > go to start o.l.
        addq.l  #4,a7     drop error entry
        moveq   #0,d1     to start of stg
edl_acur move.w d4,d1     len
        lea     0(a2,d4.w),a1  last char
        move.w  d7,d2     max.len
        swap    d3        max.timo
        moveq   #4,d0     io.edlin < d1.hi,lo cursor,len d2.w.buflen a1.e.o.l
        trap    #3                 < & d3.timo a0.id
        addq.l  #1,d0     > d1.l.updt d2.cons d3.cons a0.cons a1.updt
        bgt.s   edl_nde   ? last char
        bne.s   edl_nxt   ? not <break>
        moveq   #15,d0    sd.curen
        bsr.s   edl_qtrp
        moveq   #4,d0     err.nc restored
edl_xit subq.l  #5,d0
        rts               => edl_tim

edl_cur move.w  d5,d2     row
        swap    d5
        move.w  d5,d1     col
        swap    d5
        moveq   #16,d0    sd.pos
        bra.s   edl_qtrp  - trap#3

edl_nxt addq.l  #4,d0     err.bo if e.o.l.
        bne.s   edl_xit   ?
edl_neu move.w  d1,d4
        subq.w  #1,d4     new len
        swap    d3        min timo
        bra.s   edl_lop

* general trap-call, on err ret one level back
edl_qtrp trap   #3
        not.l   d0
        bpl.s   edl_tret  ? error
        moveq   #0,d0     ok
        rts
edl_tret not.l  d0
        addq.l  #4,a7
        rts

edl_nde moveq   #-10,d6
        add.b   -(a1),d6  <enter>
        bne.s   edl_neu   ? new input
        addq.l  #4,a7     drop error routin
        sf      (a1)+
        subq.w  #1,d1     limiting char
        bpl.s   edl_ret   ? stg not empty
        moveq   #0,d4     (auch nicht leerer)
edl_tim move.w  d4,d1     <on timeout)
edl_ret sub.w   d1,d7
        bra.s   edl_rmd
edl_rml sf      (a1)+
edl_rmd dbra    d7,edl_rml
        addq.l  #8,[sp]
        move.b  d1,-1(a2)
        sub.l   [bp],a2
        move.w  a2,-([sp])
        move.w  d1,-([sp])
        movem.l (a7)+,d6/d7/a3
        [jnx]

Xpfindq pea     ([nx])
        bra.s   cpfq
Xlpfindq move.w ([sp]),-([rp])  >rr
        move.w  locvocv-2-Z([bp]),-([sp])
        pea     Xdashd(pc)
cpfq    moveq   #0,d0
        moveq   #32,d4
        moveq   #26,d5  ;;;moveq   #26+'a',d5
        move.w  ([sp])+,[w] top nfa
        moveq   #-1,d1
        move.w  uwidth([bp],[up].l),d3
        subq.w  #1,d3   limit of char count
        swap    d3
        move.w  [w],d3  1st nfa
        bra.s   findent -
findlink move.l d3,d2
        swap    d2
        tst.b   (a0)
        bpl.s   fndfalse ?
        moveq   #31,d0
        and.b   (a0),d0  ;;
        beq.s   fndfalse ?
        cmp.w   d0,d2
        bge.s   fndwdt  ? width ok
        move.w  d2,d0
fndwdt  lea     1(a0,d0.w),[w]
findvoc move.l  [w],d1
        ble.s   fndfalse  ? memory corruption
        lsr.w   #1,d1
        bcs.s   fndfalse  ? no more / address err.
        add.w   d1,d1
        move.w  ([w]),[w]
        cmp.w   [w],d3
findent beq.s   fndfalse  ? exit searching loop
        move.w  [w],d3
        move.w  d3,d2
        add.w   d2,d2
        beq.s   fndfalse  ?
        add.l   [bp],[w]  top.nfa
        move.l  [w],a0  ;;
        move.w  ([sp]),a1
        add.l   [bp],a1   string
        move.b  ([w])+,d0
        cmp.b   #$81,d0
        bne.s   fndtry    ? proceed
        cmp.b   #$a0,([w])
        bne.s   fndtry    ? more in this voc
        tst.w   vv2nd-Z([bp])
        beq.s   fndfalse  ? no 2nd order vocsearch
        move.w  5([w]),d2 searchvoc-pfa
        lea     4([bp],d2.w),[w] ptr to last word of searchvoc
        add.w   d2,d2
        bne.s   findvoc ;;tas 6([w]) ;? next voc
fndfalse clr.w  ([sp])
        rts
fndtry  moveq   #$3f,d2   mask off precedence bit
        and.b   d0,d2     smudge & count
        sub.b   (a1)+,d2  len
        bne.s   findlink  ?
findscan moveq  #127,d2
        and.b   ([w]),d2  char
        moveq   #127,d1
        and.b   (a1)+,d1
        eor.b   d2,d1
        beq.s   findchk   ? char =
        cmp.b   d4,d1     u-case
        bne.s   findlink  ? char =/=
        or.b    d1,d2
        sub.b   #'a',d2 ;;;
        cmp.b   d5,d2
        bcc.s   findlink  ? > 'z'
findchk tst.b   ([w])+
        bpl.s   findscan  ? next char
        addq.l  #4,[w]    pfa
        sub.l   [bp],[w]
        move.w  [w],([sp])
        move.w  d0,-([sp])
        move.w  #1,-([sp])
        rts

* aufruf: >rr vqfindq (ohne header) => rdup ...
Xqfindq move.w  ([sp]),-([rp])    rdup
        move.w  ([sp])+,-([rp])         (name) >r
        move.w  vnvocs-Z([bp]),-([rp])  #vocs >r
        pea     ucontext([bp],[up].l)   context >r
        clr.w   -([sp])                 0
qvf_lop move.l  ([rp]),[w]              context
        move.w  ([w])+,d0               @
        beq.s   qvf_xit                 ? ready
        move.l  [w],([rp])              next voc
        tas     6([bp],d0.w)            6+ @
        bne.s   qvf_nxt                 ? already done
        move.w  6([rp]),([sp])          name
        move.w  0([bp],d0.w),-([sp])    context @ @ ..@..
        jsr     cpfq(pc)                > (find)
        tst.w   ([sp])                  dup 0bra
        bne.s   qvf_xit                 ? found
qvf_nxt subq.w  #1,4([rp])
        bgt.s   qvf_lop                 +loop
qvf_xit move.w  ([sp]),-([sp])
        bne.s   qvf_ret                 -dup
        addq.l  #2,[sp]
qvf_ret addq.l  #8,[rp]                 rdrop voc.addr, count, name
        [jnx]

*clear vocs' fnd-flags
Xfndclr move.l  [bp],a0
        add.w   uvocdashlink([bp],[up].l),a0
        move.w  #vocnfa,d2
fdclop  move.w  (a0),d0
        beq.s   fdcjnx  ? ready
        cmp.w   -4(a0),d2
        bne.s   fdcjnx  ? error
        sf      4(a0)
        lea     0([bp],d0.w),a0
        move.w  a0,d0
        ror.b   #1,d0
        bcc.s   fdclop  ? next voc.ptr
fdcjnx  [jnx]

* {stack abcd..}
Xwstak  move.l  [w],a1                  <lit-entry
        bra.s   sstack  -
Xxstak  move.l  udp-2([bp],[up].l),a1   <direct execution
        add.l   [bp],a1 string source
sstack  pea     ([nx])  lo-level return
XCstak  moveq   #0,d1
        moveq   #1,d2
        move.b  (a1)+,d1
        move.l  a1,a2   base indices where to copy from
        or.w    d1,d2
        add.l   a1,d2   ip to continue with
        move.l  [sp],a0 monitor no. of items popped
        move.l  [sp],a1 working data pointer
;** might be afforded in non-QL systems:
;        sub.w   d1,[sp] interrupt- and multitask-protect
;        sub.w   d1,[sp] the datatstack area by safe stackptr
        move.l  [rp],d4 to restoring when ready
        moveq   #27,d3  marker bits on "|"
        bra.s   stkplop - start collecting
stkput  moveq   #31,d0
        and.b   (a2)+,d0
        cmp.w   d3,d0
        bpl.s   stkflop - ready to copy
        add.b   d0,d0   index to disp.
        addq.l  #2,a0
        move.w  -2(a1,d0.w),-([rp])
stkplop dbra    d1,stkput
        bra.s   stkret  - ready
stkftch moveq   #31,d0
        and.b   (a2)+,d0 read index
        add.b   d0,d0   fetch selected item(s)
        move.w  -2([rp],d0.w),-(a0)
stkflop dbra    d1,stkftch
stkret  move.l  a0,[sp] adjust datastack
        move.l  d4,[rp] restore returnstack
        rts
Xrstak  move.l  [ip],a1                 <compiled runtime
        bsr.s   XCstak  >
        move.l  d2,[ip]
        jmp     ([nx])

Xkeyrow move.w  ([sp])+,d0
        lsl.w   #8,d0
        addq.b  #2,d0
        move.w  d0,-([sp])
        clr.l   -([sp])
        move.w  #$0901,-([sp])
        move.l  [sp],d1
        sub.l   [bp],d1
        dc.w $4afc         (supv) & sr to tos
        move.w  d1,-([sp])
        bsr.s   ipcomcal >
        moveq   #0,d0
        trap    #1
        move.l  76(a0),d1
        ble.s   kyronky ? no keyqueue
        move.l  d1,a0
        lsr.b   #1,d1
        bcs.s   kyronky ? aerr
        add.w   #12,a0
        move.l  (a0),-(a0)
kyronky move.w  ([sp])+,8(a7)
        move.w  ([sp]),sr
        addq.l  #8,[sp]
        [jnx]

Xbell   pea     xdrop(pc)   {7}
        lea     pieps-Z([bp]),[w]
        sub.l   [bp],[w]
        move.w  [w],-([sp])
ipcomcal movem.l d5/d7/a3,-(a7)
        move.l  [bp],a3
        add.w   ([sp])+,a3
        moveq   #17,d0
        trap    #1
        movem.l (a7)+,d5/d7/a3
        move.b  d1,-([sp])
        sf      -([sp])
        rts

Xipcom  pea     ([nx])
        bra.s   ipcomcal

bkjaql  dc.l 0,$28,$60,$120,$18000,$19000,$20000,$28180,-1
bkjaqx  dc.l $680,$689,$96a,$96c,-1
* areae of non executable code
bkjpc   move.l  (a0)+,d3
        bmi.s   bkjpr   ? adr1 > pc >= adr2
        move.l  (a0)+,d1
        cmp.l   d3,d2   lower bound
        bcs.s   bkjpc   ? pc < adr1
        cmp.l   d1,d2   upper bound
        bcc.s   bkjpc   ? pc >= adr2
        moveq   #1,d1   adr1 <= pc < adr2
bkjpr   rts
* job zur adressenkontrolle & breaktasten-abfrage
breakjob moveq  #-1,d1
        moveq   #1,d3
        moveq   #8,d0
        sub.l   a1,a1
        trap    #1
        move.l  jdttab(pc),a0
        lea     sys(pc),a6     bp
        sub.w   #sys-Z,a6   up a0 a1 a2 nx ip sp bp rp sr&pc
        movem.l $20+4*7(a0),d0/d1/d2/d3/d4/d5/d6/d7/a1/a2/a5
        move.l  a5,d2
        move.w  a2,d2
        swap    d2          d2:=pc
        move.l  a1,a5       a5:=rp
        move.l  d7,a2       a2:=bp
        lea     quit+2(pc),a4  IP
        lea     docold(pc),a1  PC cold restart
        lea     bkjaql(pc),a0
        bsr.s   bkjpc   > valid address area
        bgt.s   bkjqxc  ? cold restart
        move.b  emuflag(pc),d3
        addq.b  #2,d3
        bne.s   bkjnqx  ? no qxl-system
        lea     bkjaqx(pc),a0
        bsr.s   bkjpc   >
        bgt.s   bkjqxc  ? cold
bkjnqx  moveq   #0,d7   ernum
        lea     tstjtop(pc),a0
        cmp.l   a0,d2
        bpl.s   bkjkyq  ? PC above control area
        lea     tstjbot(pc),a0
        cmp.l   a0,d2
        bmi.s   bkjkyq  ? PC below control area
        lea     next(pc),a0
        move.l  a0,d3
        lea     tstjnx(pc),a0
        cmp.l   a0,d2
        bcs.s   bkjnnx  ? PC below inner (std. 4th-regs) control area
        cmp.l   d3,d4
        bne.s   bkjrgs  ? cold if nx lost
        cmp.l   a6,a2
        bne.s   bkjrgs  ? or baseptr
bkjnnx  move.l  d0,d1
        lea     adrwarm(pc),a1 address error warmstart
bkjqxc  ror.b   #1,d1
        bcs.s   bkjrgs  ? if up odd
        ror.b   #1,d5
        bcs.s   bkjrgs  ? or ip
        ror.b   #1,d6
        bcs.s   bkjrgs  ? or sp
        move.l  a5,d1
        ror.b   #1,d1
        bcs.s   bkjrgs  ? or rp
bkjkyq  move.w  vbreak(pc),d5
        bmi.s   bkjjbk  ?
        trap    #0
        move.w  sr,-(sp)
        or.w    #$0200,sr
        jsr     tbreak(pc) >
        and.b   #$df,(sp)
        move.w  (sp)+,sr
        swap    d5
        not.w   d5
bkjjbk  bne.s   bkjret
bkjrgs  move.l  a1,a2
        lea     tvtregs(pc),a1
        movem.l d0-d7/a0-a7,(a1)
        sub.l   a1,a1
        move.l  mtinftab(pc),d1
        moveq   #-1,d3
        moveq   #8,d0
        trap    #1      lock f6-job
        move.l  a4,$20+4*8+4*4(a0)   ip=jobA4 quit/xx
        move.l  a6,$20+4*8+4*6(a0)   bp jobA6
        move.l  a2,$62(a0)           pc jobPC next/docold/adrwarm
        bclr    #5,$60(a0)           sr jobSR user-mode
        moveq   #9,d0   un-lock
        trap    #1
bkjret  jmp     breakjob(pc)

* kontrolljob installieren
instbjob moveq  #1,d0   cjob
        moveq   #-1,d1
        moveq   #20,d2
        moveq   #120,d3
        sub.l   a1,a1
        trap    #1
        tst.l   d0
        bne.s   ibjerr
        move.w  #$4ef9,(a0)+
        lea     breakjob(pc),a1
        move.l  a1,(a0)+
        move.w  #$4afb,(a0)+
        move.l  d0,(a0)
        moveq   #10,d0  activ
        moveq   #1,d2
        moveq   #0,d3
        trap    #1
        moveq   #9,d0   wait
        moveq   #127,d3 initiierung abwarten
        sub.l   a1,a1
        trap    #1
ibjerr  rts

* fetch (cold) last <bs> up s0 r0 tib width warning fence dp voc-link
*         as    d0  d1  d2  d3 up  a0   a1   a2     a3    a4  a5
inicold bsr.s   instbjob        >
        lea     versad(pc),a1   version message
        move.l  deftch(pc),a0
        jsr     utmtext(pc)     >
        lea     tcpums(pc),a1   timer message
aercold moveq   #-1,d0   {exit} safety: leads to aerr exception trap
        move.l  d0,-(a7)
        move.l  d0,-(a7)
        move.l  deftch(pc),a0   <"address error" exception entry
        jsr     utmtext(pc)     >
        bsr.s   calwarm         >
        moveq   #0,[os]         clear disp to base ptr
        move.L  odp-Z([bp]),d0
        move.L  d0,udp-2([bp],[up].l)
        jsr     calsetexb(pc)
docold  trap    #0              safely..
        and.w   #$dfff,sr       ..always (usr)
        bsr.s   calwarm                    > restore ptr's
        lea     0([bp],a0.l),[sp]          & datastack
        lea     0([bp],a1.l),[rp]          & retnstack
        jsr     itimecal(pc)               cpu timing
        move.w  #forthv-2-Z,[os]
        move.w  [os],ucontext([bp],[up].l) forth
        move.w  [os],ucurrent([bp],[up].l) definitions
        moveq   #0,[os]                    clear disp to base ptr
        jsr     calretexb(pc)              >      :   a0   a0 a1  a1    a2
* init: last bschar u0.l s0.l r0.l tib width warning fence dp.l voclink os-l
        movem.l ofnc(pc),a0/a1/a2
        movem.l a0-a2,ufence([bp],[up].l)    d1:=up
        st      upromptq([bp],[up].l)        prompt on
        move.w  #ctt-Z,uocc4th([bp],[up].l)  ctrl.table
        move.l  bank-Z([bp]),[os]          actual base segment
        move.l  [os],usysos([bp],[up].l)     os restored to the base system
* fetch (warm) last <bs>  up.l  s0.l r0.l tib width warning fence dp
*         as    d0.  d0. [up].l a0.l a1.l a2.  a2.
dowarm  trap    #0
        and.w   #$dfff,sr
        pea     next(pc)
calwarm lea     sys(pc),[bp]               get safe
        sub.w   #-$8000,[bp]               new basereg
        movem.l olast(pc),d0/[up]/a0-a2    re-initiate system ptrs
        move.w  #-1,utimo([bp],[up].l)     i/o-wait
        movem.l d0/[up]/a0-a2,ulast([bp],[up].l) last.bs.up.s0.r0.tib.width
        move.w  ouup(pc),uup([bp],[up].l)  user-'here'
        move.w  #'  ',unumfil([bp],[up].l) .r leading chr
        lea     abort+2(pc),[ip]           jmp into abort
        lea     next(pc),[nx]
        rts

*store system state left by empty
Xemptys move.w  ulast([bp],[up].l),d0   last @ dup
        move.w  d0,olast-Z([bp])        $c +origin !
        move.w  d0,-([sp])
        lea     Xpfa(pc),[w]
        jsr     Cprim(pc)               pfa
        move.w  ([sp])+,d0
        subq.w  #4,d0                   lfa dup
        move.w  d0,ofnc-Z([bp])         $22 +origin !
        move.w  d0,ufence([bp],[up].l)  fence !
        move.l  udp-2([bp],[up].l),odp-Z([bp]) dp 2- 2@ $24 +origin 2!
        move.w  uvocdashlink([bp],[up].l),ovocl-Z([bp])
        [jnx]                            voc-link @ $28 +origin !

Xascih  pea     ([nx])          a>h
        lea     ascih(pc),[nx]
        move.w  #16,-([sp])
Xdigit  move.w  ([sp])+,d1 base
        moveq   #-'0',d0
        add.w   ([sp]),d0
        bmi.s   dig_fls ? sicher keine ziffer
        cmp.b   #9,d0   obergrenze bei ziffernzeichen
        ble.s   dig_chr ? fertig
        and.b   #-33,d0 auch kleine buchstaben gelten
        subq.b  #7,d0   ascii-sprung ausgleichen
        cmp.b   #9,d0
        ble.s   dig_fls ? chr in der lcke
dig_chr cmp.w   d1,d0
        bpl.s   dig_fls ? ziffer auerhalb des wertebereiches
        move.w  d0,([sp])
        move.w  #1,-([sp]) flag 'ne' erzeugen
        [jnx]
dig_fls clr.w   ([sp])  'eq' fr milungene wandlung
        [jnx]

Xpnumberq pea   ([nx])          ( dn1 ptr1 -- dn2 ptr2
Cpnumberq move.w ([sp])+,a0
        lea     1([bp],a0.w),a0
        move.l  ([sp]),d4 accu
        move.w  ubase([bp],[up].l),d0
        moveq   #0,d1
        move.w  udpl([bp],[up].l),d2
        moveq   #9,d3
pnqnxd  bgt.s   pnqsng  ? double
        subq.w  #1,d2
pnqsng  move.w  #$0d0,d1 -'0'
        add.b   (a0)+,d1
        bmi.s   pnqrdy  ? ready not a digit
        cmp.b   d3,d1
        ble.s   pnqnum  ? test digit
        and.b   #-33,d1
        subq.b  #7,d1
        cmp.b   d3,d1
        ble.s   pnqrdy  ? ascii gap not a digit
pnqnum  cmp.b   d0,d1
        bpl.s   pnqrdy  ? hi ovf not a digit
        move.l  d4,d5   accu
        swap    d5      hi.w
        mulu    d0,d5   hi.prd
        swap    d5
        clr.w   d5
        mulu    d0,d4   lo.prd
        add.l   d5,d4
        add.l   d1,d4   accumulate digit
        addq.w  #1,d2
        bra.s   pnqnxd  -
pnqrdy  move.w  d2,udpl([bp],[up].l)
        move.l  d4,([sp])  accu
        subq.l  #1,a0
        sub.l   [bp],a0
        move.w  a0,-([sp]) ptr
        rts

Xbnumberb ;( ptr -- dn|fp ff | -- tf )
        bsr.s   Cascibase     >>        { char|num flag base
        move.w  ([sp])+,-([rp]) >r      push systembase
        moveq   #0,d0           ok flag
        tst.w   ([sp])+
        bmi.s   m13zn           ? 0<bra    { single char code
        tst.w   ([sp])+
        bne.s   m13xn           ? -branch  { integer
        moveq   #1,d1           stg.type count.b
        bsr     Cjcndtof        > $>f
        move.w  cfperr-Z([bp]),d0 fperr
        beq.s   m13zn           0branch    { success
        clr.w   cfperr-Z([bp])
        bra.s   m13yn           branch     { no number
m13xn   move.w  ([sp])+,d1                 ptr{
        clr.l   -([sp])                    {accu
        moveq   #'-',d0
        sub.b   1([bp],d1.w),d0 dup 1+ c@ "-"
        move.w  d0,-([rp])      = >rr   {=/= >rr}
        bne.s   bnbpve          ? +ve
        addq.w  #1,d1            add flag{1+}
bnbpve  moveq   #-1,d0          -1 initial dpl
        move.w  d1,-([sp])              {accu ptr
m13n    move.w  d0,udpl([bp],[up].l) dpl !
        bsr     Cpnumberq       (number)
        moveq   #0,d0           ok-flag & initial dpl if double
        move.w  ([sp]),d2       dup     {accu ptr
        moveq   #' ',d1
        sub.b   0([bp],d2.w),d1 c@ (bl+1) -
        beq.s   m14n            0branch { 0<branch single ready
        add.b   #14,d1                  { "." }
        beq.s   m13n            = 0branch to fetch double
        subq.b  #2,d1                   { "," }
        beq.s   m13n            = 0branch to fetch double
        addq.l  #2,[rp]         rdrop   { drop signflag
        addq.l  #6,[sp]         fdrop   { drop d.accu & ptr
m13yn   moveq   #1,d0           1       { error
m13zn   move.w  d0,-([sp])              {accu ff | tf
        move.w  ([rp])+,ubase([bp],[up].l) r> base!
        [jnx]
m14n    addq.l  #2,[sp]         drop    {accu
        tst.w   ([rp])+         r>
        bne.s   m13zn           0branch { -branch }
        neg.l   ([sp])          minus
        bra.s   m13zn

baseasci dc.b '{''"!%#&\$'
basecode dc.b 255,12,5,6,4,2,10,8,0,16
 ds.w 0
Xascibase pea   ([nx])          ( ptr1 -- ptr2 base flg asci
Cascibase lea   1([bp]),[w]
        add.w   ([sp]),[w]
        move.b  ([w])+,d2
        move.w  ubase([bp],[up].l),d1 preset to current base
        cmp.w   #2,d1
        bpl.s   asbsval             ? 1 < base < 129
        moveq   #10,d1              decimal
asbsval move.w  d1,d0
        moveq   #basecode-baseasci-1,d3
asbscmp cmp.b   baseasci(pc,d3.w),d2
        dbeq    d3,asbscmp
        beq.s   asbsbset            ? base char found
        move.w  ucontext([bp],[up].l),d2
        cmp.w   #fp-Z+6,d2
        beq.s   asbsfp
        cmp.w   #minerva+6-Z,d2
        bne.s   asbsnfp             ? fp not in context
asbsfp  moveq   #0,d1
        bra.s   asbsnfp             fp-number
asbsbset move.b basecode(pc,d3.w),d1 base
        bmi.s   asbchr
        addq.w  #1,([sp])           drop base-char
        move.w  d1,ubase([bp],[up].l) temp. base (coded)
        bne.s   asbsnfp             ?
        move.b  -2([w]),-([w])      prepare fp conversion
asbsnfp move.w  d1,d2               fp-flag
asbcret movem.w d0-d2,-([sp])       or ascii-char, ascii-flag, old base
        rts
asbchr  moveq   #-1,d1              ascii-flag -ve
        move.w  d1,udpl([bp],[up].l) single
        moveq   #0,d2
        move.b  ([w]),1([sp])       char
        move.b  d2,([sp])
        bra.s   asbcret

Xskip ;(ad n chr -- ad+ n+)  fnd 1st char =/= chr, skip ctrl.chars
        move.w  ([sp])+,d0      char
        moveq   #0,d1
        move.w  ([sp])+,d1      count
        lea     -1([bp]),a0
        add.w   ([sp])+,a0      ad1
skp_rtr subq.w  #1,d1
        addq.l  #1,a0
        bmi.s   skp_nde         ? alle
skp_lop cmp.b   (a0)+,d0
        dbne    d1,skp_lop      ready if =/=
        cmp.b   #' ',-(a0)
        bcs.s   skp_rtr         ? ignore ctrl.chars
skp_nde sub.l   [bp],a0
        move.w  a0,-([sp])
        addq.w  #1,d1
        move.w  d1,-([sp])      remaining char count
        [jnx]

Xscan ;(ptr1 count char -- ptr2 disp) fnd 1st char = c
        move.w  ([sp])+,d0      char
        moveq   #0,d1
        move.w  ([sp])+,d1      cnt1
        ble.s   scn_xit
        subq.w  #1,d1
        move.l  [bp],a0
        add.w   ([sp])+,a0      adr1
scn_lop cmp.b   (a0)+,d0        count & compare chars
        dbeq    d1,scn_lop      until match
        addq.w  #1,d1
        bgt.s   scn_fnd         ? found
        addq.l  #1,a0           else compensate
scn_fnd subq.l  #1,a0           dbra count compensation
        sub.l   [bp],a0
        move.w  a0,-([sp])
scn_xit move.w  d1,-([sp])
        [jnx]

;buffer deferred
Xpbufq  move.w  vuse-Z([bp]),d4 use @
        move.w  d4,-([rp])      >r
        move.w  d4,-([sp])      r
m31b    bsr.s   Cplusbuf        +buf
        tst.w   ([sp])+
        beq.s   m31b            0branch
        move.w  ([sp])+,vuse-Z([bp])    use !
        move.w  0([bp],d4.w),d0 r @
        bpl.s   m32b            0< 0branch
        move.w  d4,-([sp])      r
        addq.w  #2,([sp])       2+
        and.w   #$7fff,d0
        move.w  d0,-([sp])      r @ $7fff and
        clr.w   -([sp])         0
        lea     Xrbyw(pc),[w]   r/w
        jsr     Cprim          >>
m32b    move.w  ([rp])+,d4      r (=: r> )
        move.w  ([sp])+,0([bp],d4.w)    !
        move.w  d4,vprev-Z([bp])        r prev !
        addq.w  #2,d4
        move.w  d4,-([sp])      r> 2+
        [jnx]

Xplusbuf pea    ([nx])          +buf
Cplusbuf moveq   #4,d0
        add.w   cbbybuf-Z([bp]),d0
        add.w   ([sp])+,d0
        cmp.w   climit-Z([bp]),d0
        bne.s   M30
        move.w  cfirst-Z([bp]),d0
M30     move.w  d0,-([sp])              buf
        sub.w   vprev-Z([bp]),d0        flg
        move.w  d0,-([sp])
        rts

;block deferred
Xpblockq move.w ([sp])+,d4              block no.
        add.w   uoffset([bp],[up].l),d4 offset @ +
        move.w  d4,-([rp])              >r
        move.w  vprev-Z([bp]),d1        prev @
        move.w  d1,-([sp])              dup
        move.w  0([bp],d1.w),d2         @       prev. blk. no.
        sub.w   d4,d2                   r -
        add.w   d2,d2                   dup +   mask off update-bit
        beq.s   m33b                    0branch already the prev block
m34b    bsr.s   Cplusbuf                +buf
        tst.w   ([sp])+                 0=      next block
        bne.s   m35b                    -branch is not the prev one
        move.w  ([rp]),([sp])           drop r
        lea     dfdbuffer-Z([bp]),[w]   buffer
        jsr     Cdefer(pc)      >>
        move.w  ([sp]),-([sp])          dup
        move.w  ([rp]),-([sp])          r
        move.w  #1,-([sp])              1
        lea     Xrbyw(pc),[w]           r/w
        jsr     Cprim           >>
        subq.w  #2,([sp])               2-
m35b    move.w  ([sp]),d0               dup
        move.w  0([bp],d0.w),d0         @
        sub.w   ([rp]),d0               r -
        add.w   d0,d0                   dup +
        bne.s   m34b                    -branch
        move.w  ([sp]),vprev-Z([bp])    dup prev !
m33b    addq.l  #2,[rp]                 rdrop
        addq.w  #2,([sp])               2+
        [jnx]

Xsource pea     ([nx])
Csource move.w  ublk([bp],[up].l),d0    blk @
        beq.s   srctib                  0branch
        move.w  d0,-([sp])              blk @
        lea     dfdblock-Z([bp]),[w]    block
        jsr     Cdefer(pc)            >>
        move.w  cbbybuf-Z([bp]),-([sp]) b/buf @
        rts
srctib  move.w  utib([bp],[up].l),-([sp]) tib @
        move.w  vtibmax-Z([bp]),-([sp])   tib-max @
        subq.w  #2,([sp])                 2-
        rts

Xcommentb move.w #'))',-([sp])
          bra.s Jcomments       -
Xcomments clr.w -([sp])
Jcomments pea   Xfdrop(pc)
;;        bra.s   Cpwordq         -
;;Xpwordq pea     ([nx])
Cpwordq bsr.s   Csource       >>source
        addq.l  #2,[sp]         drop
        move.l  ([sp]),d0
        swap    d0              ptr
        add.w   uin([bp],[up].l),d0 in @ + swap
        move.l  d0,([sp])
        bsr.s   Cenclose      >>ptr n1 n2 n3
        move.w  ([sp])+,d0
        add.w   d0,uin([bp],[up].l) in +!
        rts

Xword   pea     ([nx])
Cword   bsr.s   Cpwordq       >>(word) ptr n1 n2
        move.w  ([sp])+,d0      n2
        move.w  ([sp])+,d1      n1
        sub.w   d1,d0           over-  d0:=n2-n1
        move.L  udp-2([bp],[up].l),d2 here
        lea     0([bp],d2.L),a0
        move.b  d0,(a0)+        c!
        lea     0([bp],d1.w),a1
        add.w   ([sp])+,a1      1st char
        moveq   #' ',d3         blank
        subq.w  #1,d0
        bmi.s   wordmty         ? empty
wordnx  move.b  (a1)+,(a0)+
wordmv  dbra    d0,wordnx
wordmty move.b  d3,(a0)+        trailing delimiters
        move.b  d3,(a0)+
        rts

Xblword move.w  #'  ',-([sp])   bl
Xwordh  bsr.s   Cword           word
        move.w  d2,-([sp])      here
        [jnx]

Xenclose pea    ([nx])
Cenclose move.w ([sp])+,d0 (c1 1st=/=char, n2 next chr after n1, n3:=1+n2
        move.w  ([sp]),[w] adr1 remains unchanged
        add.l   [bp],[w]
        move.w  [w],d1
        addq.w  #1,d1     adr+1
encldskip cmp.b ([w])+,d0
        beq.s   encldskip ?
        move.w  [w],-([sp]) adr2 1st=/=char
        sub.w   d1,([sp]) n1:= disp adr1 to adr2 of 1st char =/= c1
encword move.b  ([w])+,d2
        beq.s   encend    ?
        cmp.b   d2,d0
        bne.s   encword   ?
encend  move.w  [w],-([sp])
        sub.w   d1,([sp]) n2:=disp to 1st = after 1st =/=
        tst.b   d2
        beq.s   encnull   ? leave {x}
        addq.w  #1,[w]
encnull sub.w   d1,[w]    n3:=disp to start next
        move.w  [w],-([sp])
        rts

Xclose  pea     ([nx])
Cclose  move.w  ([sp])+,d3
        jsr     mkchp(pc) >
        moveq   #-1,d1  (also for open)
        move.l  d3,d0
        bmi.s   noclose
        move.l  d1,(a2) clear id
        moveq   #2,d0   io.close
        cmp.w   d3,d0
        bge.s   noclos  ? ignore -ve and prevent closeing QDOS 0-2
clcch   moveq   #chans-1,d2
clchk   cmp.l   (a0)+,d3
        dbeq    d2,clchk
        bne.s   tstclos
        add.b   usriow-Z([bp]),d2
        cmp.b   #chans-1,d2
        bne.s   noclose
        move.l  d1,-(a0) close duplicate workchannel
        bra.s   clcch
tstclos movem.l mtinftab-Z([bp]),d1/a0/a1
        move.l  d3,a0
        lsl.w   #2,d3
        move.l  120(a1),a1
        move.l  0(a1,d3.w),a1
        move.l  a1,d3
        ble.s   noclos  ? no address
        lsr.w   #1,d3
        bcs.s   noclos  ? zero or odd
        cmp.l   8(a1),d1
        bne.s   noclos  ? not an own channel
        trap    #2
noclos  moveq   #0,d0   <extop from: dashwindow
noclose rts

Clopen  move.w  ([sp])+,d3 (name link-id chan.no.)
        jsr     mkchp(pc) >a2 := chp
        moveq   #-1,d1
        bra.s   lopn_nt
Xopen   move.w  ([sp]),-([sp])
        clr.w   2([sp]) ( name.adr d.acs.code chan.no - d.ernum ) sets d1:=-1
        bsr.s   Cclose  >
lopn_nt moveq   #-3,d0
        move.l  ([sp])+,d3 open-typ/link-id ( name.adr d.chan.id - d.ernum
        move.l  [bp],a0
        add.w   ([sp])+,a0 name ptr.
        bmi.s   opnerr
        moveq   #1,d0   io.open
        trap    #2
opnerr  move.l  d0,qf.error-Z([bp])
        move.l  d0,-([sp])
        bne.s   opnext  ?
        move.l  a0,(a2)
opnext  [jnx]

Csysmsg move.w  ([sp]),d0
err_ql  add.w   d0,d0
        bpl.s   err_sys ? 4th system msg
        cmp.w   #-54,d0
        blt.s   err_nms ? msg#
        move.l  sysvari-Z([bp]),a1
        move.l  330(a1),a1
        tst.b   emuflag-Z([bp])
        ble.s   err_njm  ?
        cmp.w   #-44,d0
        bgt.s   err_jm
        moveq   #-30,d0
err_jm  move.w  #$3894,a1 JM messagetable
        addq.w  #2,d0
err_njm neg.w   d0
        add.w   0(a1,d0.w),a1
        bra.s   err_out -
err_sys cmp.w   #64,d0
        bgt.s   err_noms ? msg#
        move.w  e(pc,d0.w),d0
        beq.s   err_noms ? msg#
        bmi.s   err_ql   ? qdos
        subq.w  #1,d0
        beq     outcpu   ? .cpu
        lea     1+e(pc,d0.w),a1
err_out moveq   #127,d2
        and.w   (a1),d2  len
        cmp.w   (a1)+,d2
        bne.s   err_noms ? erroneous adr
        sub.l   [bp],a1  adr => ptr
        clr.w   ([sp])   clear flag
        jsr     tprompt(pc)
        beq.s   err_msg ?
        moveq   #4!3,d0
err_msg jmp     msgtype(pc)
err_nms neg.w   ([sp])
err_noms [jnx]

* message: ptr < 0 qdos-msg. by ut.err : = 0 by number  : > 0 own text
e dc.w -19,mptyad-e,-3,adrsad-e,-8,hovfad-e,-11   0-6
  dc.w sovfad-e,-16,colder-e,0,0,0,0,0,1,versad-e 7-16
  dc.w compad-e,execad-e,-21,nfinad-e       17-20
  dc.w fncdad-e,loadad-e,edisad-e,vocsad-e
  dc.w tcpums-e,exvcad-e,trapad-e,0,0,0,0,0 25-32

mptyad string {empty stack}                 :  1
adrsad string {addressing mode}             :  3
hovfad string {hld digit storage ovf}       :  5
sovfad string {stack overflow}              :  7
colder string {fatal error - don''t retry!} :  9 & address error trap
versad string {[.vers] F6 version [.date]}  : 16
compad string {compilation only}            : 17
execad string {executing only}              : 18
nfinad string {definition not finished}     : 20
fncdad string {protected dictionary}        : 21
loadad string {use only when loading}       : 22
edisad string {off editing screen}          : 23
vocsad string {?vocabulary}                 : 24
tcpums string {- mpu effective timing: }    : 25
exvcad string {execution vector undef''d}   : 26
trapad string {system address error}        : 27
thgnam string {THING}
hotnam string {HOTKEY}
memnam string {mem}

Cexbrac moveq   #%11000000,d0
        move.w  ustate([bp],[up].l),d1
        beq.s   goXcarb             ? interpreting
        bpl     Xqexec              ? not compiling to execute
        moveq   #5,d1               start execution of compiled words
        add.L   udp-2([bp],[up].l),d1
        and.w   #-2,d1
        move.L  d1,udp-2([bp],[up].l)   compiling:
        move.w  #retexb-Z,-4([bp],d1.L) restore dp and last
        move.w  #semis-Z,-2([bp],d1.L)  terminate dummy colon-definition
        move.L  uhead-2([bp],[up].l),[w] pfa
        add.l   [bp],[w]                address
        jmp     docolon(pc)             execute
goXcarb bsr.s   calsetexb               prepare compiling for direct execution
        addq.L  #2,udp-2([bp],[up].l)
        move.w  #lbrac-Z,0([bp],d1.L)   compile state to executing
        move.w  d0,ustate([bp],[up].l)
        [jnx]

Cretexb pea     ([nx])
calretexb move.w utail([bp],[up].l),ulast([bp],[up].l)
        move.L  uhead-2([bp],[up].l),udp-2([bp],[up].l)
        rts

Csetexb pea     ([nx])
calsetexb move.w ulast([bp],[up].l),utail([bp],[up].l)
        moveq   #1,d1
        add.L   udp-2([bp],[up].l),d1
        and.w   #-2,d1
        move.L  d1,uhead-2([bp],[up].l)
        move.L  d1,udp-2([bp],[up].l)
        rts

* calc. sign d0.w for d5 * d4, set d4 & d5 to abs
qml_sgd move.l  d5,d0
;eor.l   d4,d0
;smi     d0
;ext.w   d0
;tst.l   d5
        bpl.s   qsg_d5p
        neg.l   d5
qsg_d5p eor.l   d4,d0
        smi     d0
        ext.w   d0
        tst.l   d4
        bpl.s   qsg_pve
        neg.l   d4
qsg_pve bsr.s   qml_cal
        eor.b   d3,d0
        beq.s   qsg_pos
        neg.l   d2
        negx.l  d4
qsg_pos rts

* unsigned 64-bit-product d2|d4 := d4 * d5 & d3 ovf, d0(sgn) unchanged
* IN: d4 d5       OUT: d2 d3 d4      CHG: d1 - d5
qml_cal move.w  d4,d1   md.l
        move.w  d4,d2   md.l
        mulu    d5,d2   p.ll              mt.l*md.l
        swap    d5      mt.h
        mulu    d5,d1   p.hl         mt.h*md.l
        swap    d4      md.h
        move.w  d4,d3   md.h
        mulu    d5,d4   p.hh      mt.h*md.h
        swap    d5      mt.l
        mulu    d5,d3   p.lh         mt.l*md.h
        swap    d2      p.ll.h
        add.w   d2,d1   p.ll.h+p.hl.h =: p.l.h
        moveq   #0,d5
        addx.l  d5,d4   p.hh+cy
        add.l   d3,d1   p.lh+p.l
        move.w  d1,d2   p.lh+p.l.h
        swap    d2      p.lo
        addx.w  d5,d5   fetch arithmetic cy
        swap    d1      p.hl.h
        addx.w  d1,d4   p.hh+cy
        swap    d4      p.hh.h
        addx.w  d5,d4   p.hh.h+cy
        svs     d3      ovf.hi
       roxl.b  #1,d3    ;;asl.w   #1,d3   accumulate ovf to last cy
        ext.w   d3
        ext.l   d3      flag any error
        swap    d4      p.hi
        rts

Xsbd    move.w  ([sp])+,d3 <set-baud
        movem.l d6/d7,-([sp]) ;q;
        move.l  sysvari-Z([bp]),a0
        move.w  #19200,d4
        moveq   #7,d0
        and.b   160(a0),d0 sv.tmode
        moveq   #0,d5
        moveq   #3,d6  ;q;
        and.b   d3,d6
        move.w  d3,d7
        eor.b   d6,d3
        cmp.w   d3,d4
        blt.s   isb_get    ? on error read only
        beq.s   isb_set    ? 19200
        moveq   #7,d5
        moveq   #75,d2     min baud
        cmp.w   d7,d2  ;q;d3,d2      new
        bgt.s   isb_get    ? less
        beq.s   isb_set    ? set to 75 baud
isb_num add.w   d2,d2      try next
        cmp.w   d3,d2
        dbeq    d5,isb_num ? valid
        beq.s   isb_set
isb_get move.b  d0,d5      old val on err
isb_set move.b  d5,160(a0) new sv.tmode (emu)
        move.w  d4,d1
        lsr.w   d5,d1
        or.b    d6,d5      ;q;
        lsr.w   d0,d4
        subq.w  #7,d0
        bne.s   isb_trp
        moveq   #75,d4
isb_trp movem.l ([sp])+,d6/d7 ;q;
        move.w  d4,-([sp]) old baudrate
        moveq   #18,d0     mt.baud
        trap    #1
        [jnx]

Xfnt    jsr     ccdt(pc)        d2:pif d3:id a0:cdt
        tst.w   ([sp])+
        move.l  ([sp])+,a2      cdt
        ble.s   fntrrt          ? no window
        add.w   d2,a2           cdt wdw.parm
        move.w  ([sp]),d3
        move.l  #$fff4fff0,-([sp])  top -12 min -16
        jsr     cminmax(pc)     >
        cmp.w   ([sp]),d3
        bne.s   fntrrt          ? drop code
        jsr     cmemvec(pc)     >
        move.l  ([sp])+,d0
        bmi.s   fntxit          ?
        move.l  d0,a0           fount baseaddr.
        movem.l 42(a2),d2/a1    current founts
        move.w  (a0)+,d1        2nd ptr
        beq.s   fnt1st          ? missing
        move.w  d1,d0           1st ptr
        not.w   d0
        beq.s   fntput          ? missing
        ror.w   #1,d0
        bcc.s   fntxit          ? error
        lea     -2(a0,d1.w),a1  2nd new
fnt1st  move.w  (a0),d1
        not.w   d1
        beq.s   fntput
        move.l  a0,d2           1st new
fntput  movem.l d2/a1,42(a2)
        subq.l  #2,[sp]
fntrrt  addq.l  #2,[sp]
fntxit  [jnx]

Cffetch lea     6([bp]),[w]     <fp @
        and.w   #-2,([sp])      even
        add.w   ([sp])+,[w]
        bra.s   fload

Cflit   addq.l  #6,[ip]         <fp lit
        move.l  [ip],[w]
fload   move.l  -([w]),-([sp])
        move.w  -([w]),-([sp])
        [jnx]

Cfstore move.l  [bp],[w]        <fp !
        and.w   #-2,([sp])      even
        add.w   ([sp])+,[w]
        move.w  ([sp])+,([w])+
        move.l  ([sp])+,([w])+
        [jnx]

;;Xjbcndtof moveq #1,d1
;;        bra.s   Xjcndtof
Xcndtof moveq   #2,d1           < $>f
Xjcndtof pea    ([nx])
Cjcndtof movem.l d6/d7/a3/a4,-(a7)
        move.l  d1,a0
        add.w   ([sp])+,a0      string
        moveq   #0,d7
        move.b  -1([bp],a0.w),d7 buf.end
        move.w  d7,d0
        subq.w  #1,d0
        bmi.s   cnnum           ? no strg
        add.l   a0,d7
        lea     0([bp],a0.l),a1
        moveq   #',',d1
cndp    cmp.b   (a1)+,d1
        dbeq    d0,cndp
        bne.s   cnndp           ?
        addq.b  #2,-(a1)        convert ',' to '.'
cnndp   move.l  [sp],a1
        sub.l   [bp],a1         result
        subq.l  #6,[sp]         buffer
        move.w  $100,a2         cn.dtof
        jsr     (a2)            >
        bne.s   cnerr
        cmp.b   #'%',0([bp],a0.l)
        bne.s   cnnum           ? no %
        clr.w   -([sp])         f.p. 100
        move.l  #$08076400,-([sp])
        subq.l  #6,a1
        moveq   #16,d0          ri.div
        move.w  284,a2
        jsr     (a2)            > num. => percent
        beq.s   cnerr           ? ok
        addq.l  #6,[sp]
cnerr   addq.l  #6,[sp]
cnnum   movem.l (a7)+,d6/d7/a3/a4
        move.w  d0,cfperr-Z([bp])
        bne.s   cnret           ? ok
        and.b   #15,([sp])
        move.w  #-2,udpl([bp],[up].l)
cnret   rts

* ! entry with proc.flags set from the opcode in D0
* D0=0 ri.execb with A2:=op.table(bp) A0:=variptr(bp)
XriXd0  movem.l d6/d7/a3/a4,-(a7) <ri.vec)
        move.w  a2,a3   ptr to opcode list for ri.execb
        move.w  $11c,a2 ri.exec
        bne.s   rixex   ? single opcode
        move.w  $11e,a2 ri.execb
rixex   move.w  a0,a4   ptr to ri.variable area(a6)
        add.l   [bp],a3
        moveq   #0,d7
        btst    d7,d0
        beq.s   rixstd  ? even if no minerva special code
        and.b   miflag-Z([bp]),d0 mask
        beq.s   rixmir  ? no minerva
rixstd  move.l  [sp],a1
        sub.l   [bp],a1
        jsr     (a2)    >
rixnmi  movem.l (a7)+,d6/d7/a3/a4
        move.w  d0,cfperr-Z([bp])
        bne.s   rixer
        lea     0([bp],a1.l),[sp]
        and.b   #15,([sp]) ..fail safe
rixer   [jnx]
rixmir  moveq   #-19,d0 err.ni
        bra.s   rixnmi  -

Xqflt   move.l  ([sp])+,d5 : q>f
        moveq   #-1,d2
        bra.s   XXcqflt

Xfsing  move.w  ([sp])+,a0 : s>f
        move.l  a0,-([sp])
CXflong moveq   #0,d5      : d>f
        moveq   #0,d2
XXcqflt move.l  ([sp])+,d3 < 32bit to f.p.
        moveq   #$3f,d0
        move.l  d5,d4     lo.val
        bne.s   cfnh      ? 64bit or zero
        and.l   d3,d2
        bmi.s   cfnh      ? 64bit hi.zero lo. 32nd set
        moveq   #$1f,d0   else 32
        exg     d5,d3
cfnh    move.l  d3,d2
        or.l    d5,d2
        beq.s   cfnk      ? null
cfne    add.l   d3,d3
        addx.l  d5,d5
        dbvs    d0,cfne
        roxr.l  #1,d5
        move.w  #$0800,d4 exp. null
        move.b  d0,d4
cfnk    move.l  d5,-([sp])
        move.w  d4,-([sp])
        [jnx]

Xfpq    moveq   #63,d2  : f>q
        bra.s   lfltnt
XXlflt  moveq   #31,d2  : f>d
lfltnt  or.w    #$0800,d2
        moveq   #0,d5   lo.l of quad
        moveq   #0,d1
        move.w  ([sp])+,d0
        move.l  ([sp])+,d4
        beq.s   clfn      ? zero
        smi     d1        sign
        move.l  d4,d3     mnt
        moveq   #0,d4
        addq.b  #1,d1     0:-ve 1:+ve for exp.adjustmt
        sub.w   d1,d0
        cmp.w   #$0800,d0
        blt.s   clfn      ? zero if < 1
        lsl.l   d1,d3     mnt sign-adjusted
        move.l  d3,d4     saved
        move.w  d2,d3     max. exp
        sub.w   d0,d3
        bgt.s   clfc      ? valid
        beq.s   clfn      ? exp 0 equal to zero
        moveq   #1,d4     set
        ror.l   #1,d4     +/- ovf
        sub.l   d1,d4     $80000000 min .. max $7fffffff
        sub.l   d1,d5      00000000             ffffffff
        bra.s   clfn      - ret limit
clfc    tst.b   d1        sign
        beq.s   clfmn     ? -ve
        bra.s   clfsn
clfs    lsr.l   #1,d4
        roxr.l  #1,d5
clfsn   dbra    d3,clfs
clfn    lsl.b   #2,d2
        bpl.s   clfdbl
        move.l  d5,-([sp])
clfdbl  move.l  d4,-([sp])
        [jnx]
clfm    asr.l   #1,d4
        roxr.l  #1,d5
clfmn   dbra    d3,clfm
        bra.s   clfn      -ve

* {tl=} 1.dptr 1.len 2.dptr 2.len -- f
Xlstgcmp move.w ([sp])+,d1
        move.l  ([sp])+,a1
        move.w  ([sp])+,d3
        move.l  ([sp])+,a0
        bra.s   stgcntr
* {t=} 1.strg 1.len 2.strg 2.len
Xstgcmp movem.w ([sp])+,d1/d2/d3/d4
        lea     0([bp],d4.w),a0 1.stg
        lea     0([bp],d2.w),a1 2.stg
stgcntr move.w  d3,d0   2l 2s 1l 1s
        sub.w   d1,d0   1.len - 2.len
        move.w  d0,-([sp])
        bpl.s   stgone  ? 1l > 2l
        exg     d1,d3
stgone  move.w  vpjokerq-Z([bp]),d2  joker 2.stg
        moveq   #0,d4
        move.b  1+vpupperq-Z([bp]),d4 case mask
        moveq   #0,d0   eq
        bra.s   stgnxc  -
stglop  move.w  d4,d0
        and.b   (a0)+,d0 1.
        move.w  d4,d5
        and.b   (a1)+,d5 2.
        cmp.b   d2,d5
        beq.s   stgnxc  ? joker
        sub.w   d5,d0   =
stgnxc  dbne    d1,stglop
        beq     Xsgn    ? 1 =?= 2
        move.w  d0,([sp])
        jmp     Xsgn(pc)

Xdashtx move.w  2([sp]),-([sp])
        bsr.s   dstxtc    > memptr len stgptr count
        neg.b   d5
        ext.w   d5
        move.w  d5,2([sp])
stgeqx  addq.l  #2,[sp]
        [jnx]

Xstgeq  move.l  ([sp])+,a0 memaddr
        moveq   #0,d0
        move.w  ([sp]),d0  maxlen
        pea     stgeqx(pc) |> drop disp
        bra.s   slongnt    >

Xmatchl pea     ([nx])
        moveq   #0,d0
        move.w  ([sp])+,d0 maxlen
        move.l  ([sp])+,a0 memadr
slongnt moveq   #0,d5
        move.w  ([sp])+,d5 stgcount
        move.l  ([sp])+,a2 stgadr
        move.w  ([sp])+,d3 joker
        bra.s   dstxntr

Xmatch  pea     ([nx])
dstxtc  moveq   #0,d5      <-text) entrypoint
        move.w  ([sp])+,d5 stgcount
        move.l  [bp],a2
        add.w   ([sp])+,a2 stgptr
        moveq   #0,d0
        move.w  ([sp])+,d0 maxlen
        move.l  [bp],a0
        add.w   ([sp])+,a0 memptr
        move.w  vpjokerq-Z([bp]),d3  joker
* entry from {s=} & {s==}: d0.w maxlen d3.w joker d5.w stglen a0 memadr a2 stgadr
dstxntr move.b  1+vpupperq-Z([bp]),d1 mask case sensitive or not
        move.l  d7,-(a7)   save up
        move.l  d6,-(a7)   & os
        pea     (a0)       & memadr
        moveq   #0,d2      "not found"
        cmp.w   d5,d0      exit if
        bcs.s   matchlen   ? count > max mem
        move.w  d5,-([rp])
        beq.s   matchfnd   ? zero length "found"
        moveq   #0,d7      clear for joker compare
        subq.w  #1,d0      maxlen
        subq.w  #1,d5      stg
        swap    d5         keep stg count
        move.w  d0,d5      put mem count
        move.w  d0,([rp])
        move.l  a0,d6      keep bottom
        subq.l  #1,d6      prepare
matchlp addq.l  #1,d6      next
        move.l  d6,a0      mem
        move.l  d5,d0
        swap    d0         stg count
        move.l  a2,a1      stg
matcmp  move.b  (a0)+,d4   mem
        move.b  (a1)+,d7
        cmp.w   d3,d7      joker
        beq.s   matchgo    ? set
        eor.b   d7,d4
        and.b   d1,d4
matchgo dbne    d0,matcmp  stg
        dbeq    d5,matchlp mem
matchfnd seq    d2
        neg.b   d2         flg
        sub.w   ([rp])+,d5 stg comparison
        seq     d5         for -text
        moveq   #0,d0
matchlen add.l  a0,d0
        sub.l   (a7)+,d0   disp
        move.l  (a7)+,d6   os back
        move.l  (a7)+,d7   up
        move.w  d2,-([sp])
        move.w  d0,-([sp])
        rts

Cquery  move.w  utib([bp],[up].l),a1
        move.w  vtibmax-Z([bp]),d2
        subq.w  #2,d2
        pea     Crvtmax(pc)     <>
        bra.s   jexpect         -
Xexpect pea     ([nx])
        movem.w ([sp])+,d2/a1    (adr maxcnt --)
jexpect lea     utimo([bp],[up].l),a0 <edline)
        move.w  (a0),-([sp])
        move.w  #-1,(a0)
        moveq   #2<<3!4!2,d0    io.fline wait stdin
        jsr     iocomm(pc)      > don't count {out}
        beq.s   expa1ok         ? timeout or no.err
        bsr.s   experr          > restore i/o
expa1ok sf      (a1)
        sf      -(a1)
        move.w  d1,uspan([bp],[up].l) f.83 compatibility
exprtim move.w  ([sp])+,utimo([bp],[up].l)
        rts

experr  move.l  [bp],a0
        add.w   climit-Z([bp]),a0
        move.l  deftch-Z([bp]),(a0)
        move.l  (a0)+,(a0)
        addq.l  #1,a1
        move.w  #1,stdio-Z([bp])       any err., reset in-/out-cons
        st      upromptq([bp],[up].l)  and kbd prompt
        rts

Xrbyw   move.l  ([sp]),d2
        move.w  ([sp])+,d2 flag ( 0/1 )
        moveq   #0,d1
        move.w  ([sp])+,d1        (use @ ) =: block
        move.w  #$42<<3!4!0/2,d0  fs.posab wait dr0
        asl.w   #2,d1             block.b14->X
        addx.w  d0,d0             if bit 14 was set, change to dr1
        lsr.w   #2,d1
        mulu    cbbybuf-Z([bp]),d1
        bsr     iocomm  >        fileptr to fpos (d2:=0 on err)
        move.w  ([sp])+,a1 r/w ptr
        beq.s   rwcnt   ok or err.nc
        cmp.w   #-10,d3 err.ef
        bne.s   rwerr   rwerr     ?
        swap    d2
        bne.s   rwnext  ? don't fstrg past eof
rwcnt   moveq   #7,d0   io.sstrg
        lsr.b   d2,d0   if flag was 1, convert to 3=io.fstrg
        move.w  cbbybuf-Z([bp]),d2
        moveq   #-1,d3
        bsr     trap3   >
        beq.s   rwnext
        cmp.w   #-10,d3
rwtst   bne.s   rwerr   ? <ert) ? ok or err.nc
rwnext  [jnx]

rwerr   move.l  d3,d0
        lea     2([bp]),[ip]
        add.w   vquit-Z([bp]),[ip]
        moveq   #1,d3
        pea     ([nx])    <r/w
        jsr     mkchp(pc) > ch.id
        move.l  d3,a0
        move.w  $CC,a2
        jmp     (a2)    ut.err

CXnswap move.w  ([sp]),d1 swap tos and nn'th item
        ble.s   xrolnxt
        lea     xnswapx(pc),[w]
        bra.s   xroljmp

CXroll  move.w  ([sp]),d1
        beq.s   xrolnxt ? don't roll nothing
        lea     xrolup(pc),[w]
        bpl.s   xroljmp
        lea     xroldn(pc),[w]
        not.w   d1
xroljmp move.w  d1,d0
        add.w   d0,d0
        lea     2([sp],d0.w),a0
        jmp     ([w])
xrolup  addq.w  #1,d1   roll bot up
        move.l  a0,a1
        move.w  (a0)+,([sp])
xrolop  move.w  -(a1),-(a0)
        dbra    d1,xrolop
xrolnxt addq.l  #2,[sp]
        [jnx]

xnswapx move.l  ([sp])+,d0
        move.w  (a0),-([sp])
        move.w  d0,(a0)
        [jnx]

xroldn  move.l  ([sp]),d0 roll top under
        lea     2([sp]),a0
        lea     2(a0),a1
xroldnl move.w  (a1)+,(a0)+
        dbra    d1,xroldnl
        addq.l  #2,[sp]
        move.w  d0,(a0)
        [jnx]

CX2wi   movem.l ([sp])+,d0/d1/d2
        move.l  d1,d4
        cmp.l   d2,d0   d0:max d1:min d2:num
        ble.s   twput   ? max <= num
        exg     d2,d0
        move.l  d0,d4
        cmp.l   d0,d1
        ble.s   twput   ? min <= num
        move.l  d2,d4
        move.l  d1,d0   min
twput   move.l  d0,-([sp])
        [jnx]

Cdashtrailing moveq   #32,d2
        move.w  ([sp]),d1
        ble.s   dashtnxt
        lea     1([bp],d1.w),a0
        add.w   2([sp]),a0
        cmp.b   #10,-(a0)
        beq.s   dashtnx         ? drop <nl> from file input
        subq.w  #1,d1
dashtlop cmp.b  -(a0),d2
dashtnx dbcs    d1,dashtlop     ? drop trailing blanks and ctrl's
        addq.w  #1,d1
        move.w  d1,([sp])
dashtnxt [jnx]

* fetch ptr from stack; hk.vec in d3.w - ret a0 hk.vec a3 hk.link d5 xx
hbfvec  move.w  ([sp])+,d2
        move.w  ([sp]),d5       stg ptr for hot@
        move.w  ([sp])+,a1      item
        add.l   [bp],a1         ptr to chars/key/item
        move.l  a1,a2           copy for char. move
        move.l  (a7)+,-([sp])
        movem.l d6/d7/a3/a4/a6,-(a7)
        move.l  ([sp])+,-(a7)
        moveq   #0,d0           err.nf
        move.l  hkthg-Z([bp]),d4
        ble.s   hvc_nix         ? no hotkeys
        move.l  d4,a3
        ror.w   #1,d4
        bcs.s   hvc_nix         ? no address (Cy & N)
        move.l  0(a3,d3.w),a0   hk-vector (hk.gtbuf hk.sstbf hk.set)
        moveq   #1,d0
hvc_nix rts

Chbfs   moveq   #$2c,d3
        bsr.s   hbfvec
        ble.s   hbf_nix
        jsr     (a0)
        tst.w   d0
        beq.s   hbf_nix
        moveq   #1,d0
        bra.s   hbf_nix

Chbff   moveq   #$30,d3
        bsr.s   hbfvec          > d0 err d4  a0 hk.vec a1/a2 ptr a3 hk.link
        ble.s   hbf_stg         ? no hotkeys
        move.w  d2,d4
hbf_get move.b  d4,d0           0 actual, -ve previous
        smi     d0              0 / -1
        jsr     (a0)            > string to/from a1)+, len d2.w
        addq.b  #1,d4
        bmi.s   hbf_get         ? fetch next $
        moveq   #0,d0
        tst.w   d2
        ble.s   hbf_stg ?       $ empty or erroneus length
        move.w  d2,d0
        subq.w  #1,d2
hbf_sto move.b  (a1)+,(a2)+
        dbra    d2,hbf_sto
        cmp.b   #10,-(a2)
        bne.s   hbf_stg         ? no <nl>
        add.w   d2,d0
hbf_stg move.w  d5,-([sp])      stg ptr
hbf_nix move.w  d0,-([sp])      ff or stg len
        movem.l (a7)+,d6/d7/a3/a4/a6
        [jnx]

Xcmemvec pea    ([nx])
cmemvec moveq   #-1,d3
        move.w  ([sp])+,d3
        swap    d3
        lea     memnam(pc),a0
        moveq   #-1,d1
        moveq   #1,d0
        trap    #2
        move.l  d0,-([sp])
        bgt.s   mmvret
        bne.s   mmverr
        moveq   #2,d0
        trap    #2
mmverr  st      ([sp])          -ve on error
mmvret  rts

* cache control for the qxl
Xdcache move.w  ([w])+,d0
        bpl.s   ddcache
xdctst  clr.w   -([sp])
        move.l  ([sp])+,d0
ddcache move.w  #cchoffnm-Z,-([sp])
        tst.w   d0      flag 0/1
        beq.s   Xbasic  ?
        move.w  #cchonnm-Z,([sp])
        bra.s   Xbasic  -

Xlngb   moveq   #-7,d0
        move.l  sysvari-Z([bp]),a0
        tst.l   $180(a0)        (sv.lng)
        beq.s   bsret           ? no lightning
*(n.i.) entry: dc.w dojump-Z dc.l Xdobasiz-Z dc.w nameptr-Z
Xdobasic move.w ([w])+,-([sp])
Xbasic  moveq   #-1,d3          <basic
        lea     chknam(pc),a2
        move.w  ([sp])+,a1      name
bsproc  trap    #0
        move.w  sr,-(a7)        save int's
        movem.l d5-d7/a3/a4/a6,-(a7)
        move.l  sysvari-Z([bp]),a0
        move.l  $68(a0),a0
        move.l  (a0),a0
        move.l  $68+joba6(a0),d6 1st basic cdt
        sub.l   [bp],d6         disp to ref.     D6+org.A6=dest.A6
        jsr     (a2)            > (d6=>d3)
        rol.l   #8,d5           use-byte
        move.l  4(a0,a6.l),d1   call
        lea     d1lq-Z([bp]),a2
        move.l  d3,a1
        movem.l d1/d5/a0/a1,(a2) store call-address/use.b/n.t.ptr/disp to bp
        bmi.s   bscerr          ? addr not valid
        subq.b  #8,d5
        bne.s   bscerr          ? not a proc
        move.l  d1,a2
        lsr.l   #1,d1
        bls.s   bscerr          ? zero or odd
        tst.w   d0
        bmi.s   bscerr          ? not found
        move.l  [sp],-(a7)      save data stack
        move.l  sysvari-Z([bp]),a0 ( lng might have a
        move.l  $180(a0),a0        ( bug at: clr.w $1aa(a0)
        add.l   d3,[bp]         dest.A6
        sub.l   d3,[sp]         org.A5 rel dest.A6
        move.l  [sp],a3         parameter fetching
        move.l  [sp],a1         pretend ri-stack
        moveq   #0,d7           (safety)
        or.w    #$0200,sr ;q;  (usr) & lock interrupts
        and.w   #$dfff,sr ;q;
        jsr     (a2)            >
        trap    #0              back to stored regs
        move.l  (a7),a1
        addq.l  #4,a7
        move.l  a1,[sp]
bscerr  movem.l (a7)+,d5-d7/a3/a4/a6
        and.b   #$df,(a7)       user
        move.w  (a7)+,sr        back
bsret   move.w  d0,-([sp])
        [jnx]

m setstr d2/d6/d7/a4
chknam  move.w  sr,d0
        trap    #0
        move.w  d0,-(sp)
        movem.l [m],-(sp)
        swap    d5
        moveq   #-1,d0    hi.w ret-flag & zhler vorbereiten
        not.l   d6
        beq.s   ckn_nrl   ? a1 abs.adr
        not.l   d6
        add.l   a6,a1
ckn_nrl move.l  a6,d3     eigene ref(a6) sichern
        add.l   d6,a6     ziel ref(a6)
        move.w  (a1),d1
        add.w   d1,d0     len als zhler
        blt.s   ckn_ernf  ? string leer oder zu lang
        lea     2(a1),a3
        moveq   #'(',d4   grenzenmarke (z.b. psion-funktionen)
ckn_lcse cmp.b  (a3)+,d4  gltige lnge ermitteln
        dbeq    d0,ckn_lcse ? bis '(' oder ende
        not.w   d0
        add.w   d1,d0     len des namen
        swap    d1
        move.w  d0,d1
        clr.w   d0        zum test
        movem.l 24(a6),d2/d4/d7  nt.bot nt.top  nl
        btst    d0,d2     nt laufptr
        bne.s   ckn_nfnd
        btst    d0,d4     nt obergrenze
        bne.s   ckn_nfnd
        btst    d0,d7     nl nur basis immer geradzahlig
        bne.s   ckn_nfnd
        addq.l  #2,d2
        lea     -8(a6,d2.l),a0  nt laufadr
        sub.l   d2,d4
        lsr.l   #3,d4     nt zhler
        move.w  d4,d6
        swap    d4        anzahl merken
        move.w  d6,d4
        add.l   a6,d7
        moveq   #-33,d6   maske
ckn_lnam move.l d7,a2     nl basis
        addq.l  #8,a0
        add.w   (a0),a2   name
        cmp.b   (a2)+,d1  len
ckn_nxnm dbeq   d4,ckn_lnam
        bne.s   ckn_nfnd
        move.w  d1,d0
        subq.w  #1,d0
        lea     2(a1),a3  chrs
ckn_cchk move.b (a2)+,d2
        move.b  (a3)+,d5
        eor.b   d5,d2
        and.b   d6,d2
        dbne    d0,ckn_cchk ? gefunden -1 als flag
        bne.s   ckn_nxnm    ? neuer versuch bei ungleichen zeichen
        sub.w   d1,a2
        subq.l  #1,a2
        sub.l   d3,a2     name rel(a6)
        move.w  -(a0),d5  typ bernehmen
        sub.l   d3,a0     nt rel(a6)
ckn_nfnd swap   d1        len: hi.w name lo.w bergabe
        not.w   d0
        beq.s   ckn_fdnm
ckn_ernf moveq  #-7,d0    err.nf
ckn_fdnm move.w d4,d6     zhlerrest
        swap    d4        max
        bmi.s   ckn_nidx  ? index egal
        sub.w   d6,d4     nt-index
ckn_nidx exg    d3,a6     a6 eigene ref.
        moveq   #-1,d2
        cmp.l   4(sp),d2
        beq.s   ckn_rrl   ? nicht rel(a6) restaurieren
        sub.l   a6,a1     $-ptr
ckn_rrl sub.l   a6,d3     d3 ziel-a6 rel(a6)
        addq.w  #1,d1
        and.w   #-2,d1    gerade lnge zur freigabe
        swap    d5
        movem.l (sp)+,[m]
        move.w  (sp)+,sr
        tst.w   d0
        rts

Xftd    pea     ([nx])          f>$
CXftd   moveq   #-32,d1
        and.b   ([sp]),d1       safe exponent & error flag
        eor.b   d1,([sp])
        move.l  [sp],a1         num.
        sub.l   [bp],a1
        move.L  udp-2([bp],[up].l),a0  $ to here
        movem.l d7/a0/a3/a4,-(a7)
        move.w  $F0,a2
        jsr     (a2)            >
        moveq   #-17,d2
        tst.w   d1
        bne.s   ftderr  ?
        move.w  d0,d2
ftderr  move.w  d2,cfperr-Z([bp])
        lea     0([bp],a1.l),[sp]
        movem.l (a7)+,d7/a1/a3/a4
        sub.l   a1,a0
        move.w  a1,-([sp])      ptr
        move.w  a0,-([sp])      len
        move.l  a1,d0           for L<I
        rts

Ctimecal bsr.s Ctical  >
        move.l  d0,-([sp])
        moveq   #30,d3  div
        move.w  procftab(pc),d0
        bmi.s   itiqxl  ? qxl & 68010+
        not.b   d0
        beq.s   itiemu  ? emu & 68000
        moveq   #54,d2  mul
        swap    d0
        cmp.w   #12,d0  < 8 MHz
        bmi.s   itimul  ? nicht GC
itiemu  sub.w   #35,d0  < 22 MHz
        bmi.s   itical  ? GC & 68000
itiqxl  moveq   #0,d0   <qxl oder ab 23 Mhz
        moveq   #24,d2  mul
itimul  move.l  d2,-([sp])
        move.l  d3,-([sp])
itical  move.w  d0,-([sp]) */-flag
        rts

Cxtical pea     ([nx])
Ctical  trap    #0        supv
        lea     timem(pc),a0
        moveq   #0,d0     count
        moveq   #-51,d1   1 sec.
        move.l  (a0),d2
        sub.l   d1,d2
        move.l  d1,(a0)
ti_cal1 cmp.l   (a0),d1   expecting the next tick
        beq.s   ti_cal1   to calibrating the timer
ti_cal2 addq.l  #1,d0        8  ;   12  ;  8
        tst.l   (a0)        12  ;   24  ;  6
        bmi.s   ti_cal2   10/ 8 ; 18/12 ; 10/6
        move.l  d0,d1     =>30  ;=>54   ;=>24
        add.l   d0,d0     68000 ; 68008 ; 68010
        add.l   d1,d0     #cycles*10/sec for the 68000 cpu
        move.l  d2,(a0)+
        move.l  d0,(a0)
        and.w   #$dfff,sr user
        rts

* job-remove qdos-call unlinks the timer interrupts
jobunl  movem.l d0/a0/a1,-(a7)
        move.l  16+16(a0),a0
        moveq   #29,d0  rpoll
        trap    #1
        movem.l (a7)+,d0/a0/a1
        rts
jobunlend

Cxsavsto move.w ulast([bp],[up].l),d0 last & fence
        move.w  d0,olast-Z([bp])
        moveq   #0,d1
        move.L  udp-2([bp],[up].l),d1   here (codespace)
        move.w  uvocdashlink([bp],[up].l),d2
        move.w  uup([bp],[up].l),d3
        lea     ofnc(pc),a0
        move.w  d0,(a0)+        last => fence
        move.l  d1,(a0)+        here => dp
        move.w  d2,(a0)+        voc-link
        move.w  d3,(a0)         usertop
        lea     vquit(pc),a0
        cmp.w   #quit-Z,(a0)
        bne.s   savnq           ? new quit
        move.w  #loadquit-Z,(a0)
savnq   lea     tical(pc),a0                                          
        move.l  (a0),-([sp])    save timecount                        
        clr.l   (a0)            cleared for new start                 
        sub.l   [bp],a0                                               
        move.w  a0,-([sp])      to restore timecount                  
        lea     go(pc),a2       job base
        move.l  [bp],a0         disp to job base
        add.w   d1,a0
        sub.l   a2,a0
        lea     savehead(pc),a1                                       
        move.l  a0,(a1)         flen                                  
        neg.w   d1
        sub.w   #(4*chans+8)!$8000,d1
        move.w  vdspc-Z([bp]),d2
        cmp.w   d2,d1
        bls.s   savnd      ;;   ? no reduced dataspace
        move.w  d2,d1
savnd   move.w  d1,8(a1)        dataspace
        move.l  a2,-([sp])      jobbaseptr                            
        move.l  a0,-([sp])      flen (codespace)
        sub.l   [bp],a1
        move.w  a1,-([sp])      savehead
        [jnx]

Csavwdw lea     syscreen(pc),a1
;;        bra.s   swwntr
;Xwdata  move.l  [bp],a1         !wdat
;        add.w   ([sp])+,a1      (s. wd-size)
;        subq.w  #1,([sp])
swwntr  move.w  ([sp])+,d2      pifdisp or 0
        move.l  ([sp])+,a0      cdt
        bmi.s   swwjnx  ;;
        add.w   d2,a0           parameterbase
        move.b  $47(a0),(a1)+   border colour
        move.w  $20(a0),d0
        move.b  d0,(a1)+        border width
        sf      (a1)+
        move.b  $46(a0),(a1)+   ink
        tst.w   d2
        bne.s   pifswdw         ? p.e.-controlled window
        move.w  d0,d1
        add.w   d0,d0           border x-pix.
        swap    d0
        move.w  d1,d0                  y-pix.
        move.l  $1c(a0),d1      window sizes
        add.l   d0,d1
        add.l   d0,d1           + double border
        move.l  d1,(a1)+
        move.l  $18(a0),d1      origin
        sub.l   d0,d1           -border
        move.l  d1,(a1)
swwjnx  [jnx]
pifswdw move.l  -$10(a0),(a1)+  sd.outs window sizes
        move.l  -$0c(a0),(a1)   sd.outo origin
        [jnx]

Xmovmem move.w  ([sp])+,d2
        move.w  ([sp])+,d3
        bmi.s   mmnxt
        subq.w  #1,d2
        bmi.s   mmnxt
        move.l  ([sp])+,a0
        move.l  ([sp])+,a1
mmolop  move.w  d2,d1
mmilop  move.b  (a1)+,(a0)+
        dbra    d1,mmilop
        dbra    d3,mmolop
        move.l  a1,-([sp])
        move.l  a0,-([sp])
mmnxt   [jnx]

CXqesc  bsr.s   jqesc   <?esc
        cmp.w   #27,d1
        beq     equset
        add.w   d1,d1
        beq.s   putnul
        move.w  #27,-([sp])
        pea     Xeq(pc)
        pea     Xd1ret(pc)
        bra.s   jxkey

Xkey    pea     Xd1put(pc) (-- key | -ALTkey | $8000 timout | $8001 error)
        bra.s   jxkey

xkyerr  move.w  #$8000,d1
        not.l   d3
        beq.s   xkyret  ? err.nc
        jsr     experr(pc) > restore i/o
        addq.w  #1,d1   any other error
xkyret  rts

Xqkey   pea     Xd1put(pc)      <?key {key} with zero timeout
jqesc   pea     exprtim(pc)     <?esc)
        lea     utimo([bp],[up].l),a0
        move.w  (a0),-([sp])
        clr.w   (a0)
jxkey   moveq   #$e<<3!4!2,d0   <key) io.cursen wait stdin
        jsr     iocomm(pc)      >
        moveq   #1<<3!4!2,d0    io.fbyte wait stdin
        moveq   #-1,d2
        not.w   d2
xkyalt  jsr     iocomm(pc)      > (d3 ernum d2.l:=0 on error)
        tst.l   d2
        beq.s   xkyerr          ? any err.
        move.b  d1,d2
        not.b   d1
        bne.s   xkyput          ? no alt-key
        not.w   d2
        bpl.s   xkyerr          ? 2nd ALT
        moveq   #1<<3!0!2,d0    io.fbyte nowait stdin
        bra.s   xkyalt          fetch key value after ALT
xkyput  move.w  d2,d1
        bpl.s   xkyret
        neg.b   d1
        rts

* prepare {flush}
Cflushdat moveq #0,d0
        move.w  climit-Z([bp]),d0
        sub.w   cfirst-Z([bp]),d0
        moveq   #4,d1
        add.w   cbbybuf-Z([bp]),d1
        divu    d1,d0
        move.w  d0,-([sp])
putnul  clr.w   -([sp])
        [jnx]

Cediwork moveq  #$40,d0
        and.b   uoffset([bp],[up].l),d0
        rol.b   #2,d0
        move.w  d0,-([sp])
        [jnx]

Cbye    moveq   #0,d3
jobremv move.l  mtinftab(pc),d1
        moveq   #5,d0
        trap    #1
        rts

Clpsto  move.l  [sp],d0
        sub.l   [bp],d0
        move.w  d0,clsp-Z([bp])
        [jnx]

Clspcmp move.l  [sp],d0 check items on stack when {load}ing
        sub.l   [bp],d0
        move.w  clsp-Z([bp]),-([sp])
        sub.w   d0,([sp])
        beq.s   lspnew
        move.w  ([sp]),-([sp])
lspnew  move.w  d0,clsp-Z([bp])
        [jnx]

Xdonul  bsr.s   Cnxblk  > blk+
        tst.w   ([sp])+
        bgt.s   dnljnx  ? next block
        move.l  [bp],[ip]
        add.w   ([rp])+,[ip] tib or
        beq     Xqexec  ? new screen
dnljnx  [jnx]

Xnxblk  pea     ([nx])
Cnxblk  move.w  #-1,-([sp])     ( -- f ( -1:tib 0:new screen +ve:next block
        move.w  ublk([bp],[up].l),d0
        beq.s   Xnxinul         ? t.i.b. input
        addq.w  #1,d0           next blk
        move.w  d0,ublk([bp],[up].l)
        ext.l   d0
        divu    cbbyscr-Z([bp]),d0
        swap    d0
        move.w  d0,([sp])       blk no. in current screen
Xnxinul clr.w   uin([bp],[up].l)
        rts

Xdstrip tst.w   ([sp])+
        beq     Xdrop
Xxstrip jsr     ccdt(pc)
        tst.w   ([sp])+
        move.l  ([sp])+,a0
        ble.s   xstnxt
        add.w   d2,a0
        movem.l $3a(a0),d0/d1/d2/d3
        exg     d0,d1
        move.b  d2,d4
        rol.l   #8,d3
        move.b  d3,d2
        move.b  d4,d3
        ror.l   #8,d3
        movem.l d0/d1/d2/d3,$3a(a0)
xstnxt  [jnx]

Cchkchn move.l  a0,a1
        move.w  ([sp]),d2       keep the no.
        moveq   #-6,d3
        bsr.s   chidcal
        exg     d3,d0
        bmi     goXqerr ? chan. not open
        addq.l  #4,[sp]
        move.b  d2,(a0)
        move.b  d2,(a1)
        [jnx]

CXchid  pea     ([nx])
chidcal bsr.s   chncal
        subq.l  #2,[sp]
        move.l  0([bp],d0.w),([sp])
        rts

Xchp    pea     ([nx])
chncal  move.w  ([sp])+,d0
        lsl.l   #2,d0
        add.w   climit-Z([bp]),d0
        move.w  d0,-([sp])
        rts

CXisochc pea    ([nx])
        bsr.s   isopenc   a0 cdt
        beq.s   isocret   ? not open
        move.l  8(a0),d0
        cmp.l   mtinftab(pc),d0
        beq.s   isocret
        clr.w   ([sp])
isocret rts

CXisopen pea    ([nx])
isopenc move.w  ([sp]),d3
        clr.w   ([sp])
        jsr     mkchp(pc) > a0 cdt, d3 chan
        ble.s   isopenf   ? zero or not opened
        bsr.s   chkopn    >
        bne.s   isopenf   ? channel lost
        move.w  #1,([sp])
isopenf tst.w   ([sp])
        rts

CXdwd   pea     ([nx])    (ndert: d0:pif d1:xx d3:0 a0:id a2:xx)
cdashwd bsr.s   isopenc   > f: 0 not a window, 1 std. >1 pif-window
        ble.s   dswnxt    ? not open or qdos-channel 0
        move.l  (a2),a0
        lea     noclos(pc),a2
        moveq   #9,d0
        moveq   #0,d3
        trap    #3
        not.l   d0
        ble.s   dswnwd    ? window
        clr.w   ([sp])
        rts
dswnwd  move.w  pifdsp+2-Z([bp]),d0
        add.w   d0,([sp])
dswnxt  rts

chkopn  move.l  sysvari-Z([bp]),a0
        cmp.w   114(a0),d3 sv.chmax
        bhi.s   chkoret   ? wrong number
        move.l  d3,d1
        lsl.w   #2,d1
        move.l  120(a0),a0 sv.chbas
        add.w   d1,a0
        swap    d1
        move.l  (a0),a0
        cmp.w   16(a0),d1
chkoret rts

CXccdt  pea     ([nx])
ccdt    bsr     chidcal >
        moveq   #-1,d0  prepare "no channel"
        move.l  ([sp]),d3
        bsr.s   chkopn  >
        bne.s   cdtret  ? id no longer exist
        move.l  4(a0),d1  handler
        lea     pifdsp+4-Z([bp]),a1
        move.l  -(a1),d2  pif-dsp
        cmp.l   -(a1),d1
        beq.s   pifcdt   ? window
        cmp.l   -(a1),d1
        bne.s   cdtpush  ? not a window
pifcdt  move.w  d2,d0
cdtpush addq.w  #1,d0
        move.l  a0,([sp]) (d2: pif  d3: id)
cdtret  move.w  d0,-([sp])
        rts

Xnewch  moveq   #9,d1  protect in-cons, out-cons, print, work screen & file
        moveq   #0,d0  ff on full table
nxtnch  move.w  d1,d2
        lsl.w   #2,d2
        add.w   climit-Z([bp]),d2
        move.w  16([bp],d2.w),d2
        dbmi    d1,nxtnch
        bpl.s   nchret  ?
        addq.b  #4,d1
        move.b  d1,d0  chan > 1
nchret  move.w  d0,-([sp])
        [jnx]

Cwsiz   bsr     cdashwd ( chan -- y x hgt wdt tf | ff )
        tst.w   ([sp])+
        ble.s   wsz_nwd ?
        lea     wsz_dat(pc),a2
        moveq   #9,d0
        moveq   #1,d3
        trap    #3
        not.w   d0
        bpl.s   wsz_nwd ?
        move.l  d1,-([sp])
        move.l  a1,-([sp])
        neg.w   d0
        move.w  d0,-([sp])
        [jnx]
wsz_nwd clr.w   -([sp])
wsz_ret [jnx]
wsz_dat lea     $18(a0),a2 (ret: d1 origin  a1 sizes)
        movem.l (a2)+,d1/a1 x y w h
        move.w  (a2)+,d5    b
        move.w  d5,d0
        add.w   d0,d0
        swap    d0
        move.w  d5,d0
        sub.l   d0,d1      origin
        add.l   d0,d0
        add.l   d0,a1      sizes
        moveq   #0,d0
        rts

Xnumerr moveq   #0,d0      0 ?error <zqerror)
        bra.s   tstqerr    -
Cqqerr  move.l  ([sp]),d0
        swap    d0
        move.l  d0,([sp])
Xqerror move.w  ([sp])+,d0 code
tstqerr tst.w   ([sp])+    flag
Xqerr   bne.s   goXqerr    ?
Xernix  [jnx]

goXqerr move.w  verror-Z([bp]),d1
        lsr.w   #1,d1
        bls.s   Xernix     ? error off
cputerr move.w  d0,-([sp])
        jmp     calerr(pc)

Xqcomp  moveq   #$11,d0
        tst.w   ustate([bp],[up].l)
eqXerr  beq.s   goXqerr
        [jnx]

Xqexec  moveq   #$12,d0
        tst.w   ustate([bp],[up].l)
        bra.s   Xqerr

Xqpairs moveq   #$13,d0
        cmp.w   ([sp])+,([sp])+
        bra.s   Xqerr

Xqcsp   moveq   #$14,d0
        move.l  [sp],d1
        sub.l   [bp],d1
        cmp.L   ucsp-2([bp],[up].l),d1
        bra.s   Xqerr

Xqloading moveq #$16,d0
        tst.w   ublk([bp],[up].l)
        bra.s   eqXerr

Xqstack moveq   #1,d0
        move.l  [bp],d1
        add.l   us0-2([bp],[up].l),d1
        cmp.l   [sp],d1 empty stack
        blt.s   goXqerr ?
        moveq   #7,d0
        moveq   #.lumpplus,d1 protect pad & pad data
        add.w   d1,d1
        add.l   [bp],d1
        add.l   udp-2([bp],[up].l),d1
        cmp.l   [sp],d1 dictionary ptr
        bgt.s   goXqerr ?
        [jnx]

Xlatest move.w  ucurrent([bp],[up].l),[w]
        move.w  0([bp],[w].w),-([sp])
        [jnx]

Cstocsp move.l  [sp],d0
        sub.l   [bp],d0
        move.L  d0,ucsp-2([bp],[up].l)
        [jnx]

Xxshift movem.w ([sp])+,d0/d1 (n1 c1 -- n2 ovf)
        tst.w   d0            (c1 +ve LSL, c1 -ve LSR)
        bpl.s   sleft   ?
        neg.w   d0
        swap    d1
        lsr.l   d0,d1
        swap    d1
        bra.s   spush   ?
sleft   lsl.l   d0,d1
spush   move.l  d1,-([sp])
        [jnx]

Xndup   move.w  ([sp])+,d0
        ble.s   ndupnix ?
        subq.w  #1,d0
        move.w  d0,d1
        add.w   d0,d0
        lea     2([sp],d0.w),[w]
ndupl   move.w  -([w]),-([sp])
        dbra    d1,ndupl
ndupnix [jnx]

doctrl  tst.b   ctflag+1-Z([bp])        <ctrlwa
        beq.s   ndupnix ? no action
        move.w  ([ip])+,-([sp])
Xctrl   tas     ctflag-Z([bp])
        beq.s   ctr_emt ? emit true char
        move.w  ([sp]),d1
        move.b  d1,ctflag-Z([bp])
        ble     CTn     ? 127 < chr < 255 or chr=0
        cmp.w   #127,d1
        sne     d0
        and.b   d0,d1
        cmp.w   #32,d1
        bcc     CTn     ? 32 < chr < 127
        moveq   #0,d2      provide for {out}
        move.w  d2,([sp])  drop char & set flag to 'ok'
        move.w  d1,-([sp])
        lea     -2([bp]),[w]
        add.w   uocc4th([bp],[up].l),[w]
        move.w  #docases-Z+1,d3
        sub.w   ([w])+,d3
        cmp.w   2([w]),d3
        beq.s   Xdocases
        jmp     nodferd(pc)

ctr_emt lea     dfdemit(pc),[w]
        jmp     dodefer(pc)

;;
;Xpcselp move.w  ([sp])+,d0
;        move.l  [bp],[w]
;        add.w   ([sp])+,[w]
;        bra.s   cpcselp

*case: runtime
Xdocases move.w  ([w]),d0
;cpcselp
        move.w  ([sp])+,d3 <(csel)  d0:max [W]:ip d3:idx
pcselntr subq.w #2,d0      <(case)  disp
        move.w  d3,d1   this for {cc-4th}, and d2 untouched
        addq.w  #2,d3   1+
        add.w   d3,d3   2*
        cmp.w   d0,d3   min
        ble.s   pcsmin  ?
        move.w  d0,d3   ptr
pcsmin  subq.w  #4,d3   2
        bpl.s   pcsmax  ? max
        moveq   #0,d3   min
pcsmax  lea     2([w]),a0    cfa-flag
        move.w  4([w],d3.w),[w] ptr @
        tst.w   (a0)
        beq.s   pcspush        ? push a literal
        move.w  [w],d0
        cmp.w   #$8000,d0
        beq.s   nocase
        lsr.w   #1,d0          zero or odd
        bcs.s   nocase         ? not valid
        cmp.L   udp-2([bp],[up].l),[w] still in the dictionary
        blt     next1          ? executeable
nocase  jmp     nodferd(pc)
pcspush move.w  [w],-([sp])
        [jnx]

*case: compiletime
Xdocase lea     pcselntr(pc),a0 continue executing a cfa/fetching a number
        bra.s   pcasntr

*associative: & range: compiletime
Xpasvrq lea     pasvlntr(pc),a0 continue comparing
pcasntr move.w  ([ip]),d0       max
        move.l  [ip],[w]        ip
        moveq   #-2,d3          mask off the {range:}-flag
        and.w   d0,d3
        add.w   d3,[ip]         r+
        move.w  ([sp])+,d3      index/value
        jmp     (a0)            to find

;Xprangeq moveq  #1,d0
;        or.w    ([sp])+,d0
;        bra.s   prngqnt
;;
;Xpasvlq move.w  ([sp])+,d0
;prngqnt move.l  [bp],[w]
;        add.w   ([sp])+,[w]
;        bra.s   cpasvln

*associative: runtime
Xdoassoc move.w ([w]),d0
;cpasvln
        move.w  ([sp])+,d3 <asvl) (val tab maxdisp -- index)
pasvlntr add.w  d0,[w]     <asvr) >r ... r> add tablen to tabposn
        lsr.w   #1,d0           u2/
        scs     d2              range:-flag
        subq.w  #1,d0
        move.w  d0,-([sp])      store top index
        subq.w  #1,d0           2
        bmi.s   pasvmax         ? empty list (?do)
        ext.w   d2
        beq.s   pasvcmp         ? associative:
        add.w   d2,[w]          even
        cmp.w   -([w]),d3       top
        bge.s   pasvmax         ? beyond top val
prngcmp cmp.w   -([w]),d3
        dbge    d0,prngcmp      signed  lo.val <= nn < hi.val
        bge.s   pasvput
        addq.w  #1,d0           adjust range index to +ve, zero if under-range
        bra.s   pasvput         -
pasvcmp cmp.w   -([w]),d3
        dbeq    d0,pasvcmp      ? search
        bne.s   pasvmax         ? not found
pasvput move.w  d0,([sp])
pasvmax [jnx]

X2sgn   moveq   #1,d0
        tst.l   ([sp])
        addq.l  #2,[sp]
        bra.s   sgntr

Xsgn    moveq   #1,d0
        tst.w   ([sp])
sgntr   bgt.s   sgnput  ?
        beq.s   sgnret  ?
        moveq   #-1,d0
sgnput  move.w  d0,([sp])
sgnret  [jnx]

* ( a4.l..a0 d4.l..d0 d.call -- a4.l..a0 d4.l..d0 )
Xqcall  movem.l d6/d7/a3-a6,-(a7)
        pea     qcret(pc)
        move.l  ([sp])+,-(a7)
        movem.l ([sp])+,d0-d4/a0-a4
        move.l  d0,d7   copy for wman subw. draw
        sub.l   a6,a6
        move.l  a3,a5
        rts             >
qcret   movem.l d0-d4/a0-a4,-([sp])
        movem.l (a7)+,d6/d7/a3-a6
        [jnx]

* emit name for id. ( ptr count -- )
XCidot  move.w  uwidth([bp],[up].l),d2
        moveq   #31,d1
        and.w   ([sp])+,d1
        cmp.w   d1,d2
        bpl.s   iddwdt
        move.w  d2,d1
iddwdt  subq.w  #1,d1
        bmi.s   iddmty  ? no name
        move.w  d1,-([rp]) count
iddllp  move.w  ([sp]),d1
        addq.w  #1,([sp])
        moveq   #127,d0
        and.b   0([bp],d1.w),d0
        cmp.w   #32,d0
        bgt.s   iddcse
        tas     d0
iddcse  move.w  d0,-([sp])
        lea     dfdprmp(pc),[w]
        jsr     Cdefer(pc) >
        subq.w  #1,([rp])
        bpl.s   iddllp  ? more
        addq.l  #2,[rp]
iddmty  addq.l  #2,[sp]
        [jnx]

Crvtmax move.w  uspan([bp],[up].l),untib([bp],[up].l)  ;f83
        move.w  vtibmax+2-Z([bp]),vtibmax-Z([bp])
        clr.w   uin([bp],[up].l)
        [jnx]

CXwraps bsr.s   cminmax >
        move.w  d4,([sp])
        [jnx]

CXwi    pea     ([nx])  signed n1 adjusted to nn such that n2<=nn<=n3
cminmax movem.w ([sp])+,d0/d1/d2 max min num
        move.w  d1,d4
        cmp.w   d2,d0
        blt.s   wput    ? max <= num
        exg     d2,d0   d0:num d2:max
        move.w  d0,d4
        cmp.w   d0,d1
        ble.s   wput    ? min <= num
        move.w  d2,d4
        move.w  d1,d0   min
wput    move.w  d0,-([sp])
        rts

CXbounds move.w ([sp])+,d1
        move.w  ([sp])+,d0
        add.w   d0,d1
        move.w  d1,-([sp])
        move.w  d0,-([sp])
        [jnx]

CXwiq   subq.w  #1,([sp])
        move.w  4([sp]),d3
        bsr.s   cminmax >
        cmp.w   ([sp])+,d3
        jmp     equset(pc)

CXalign move.w  ([sp])+,d0
        move.w  ([sp])+,d1
        lsr.w   d0,d1
        lsl.w   d0,d1
        move.w  d1,-([sp])
        [jnx]

Cdo1ptype move.w ([sp]),d1
        addq.w  #1,([sp])
        move.b  0([bp],d1.w),-([sp])
        sf      -([sp])
Xpemit  move.w  ([sp])+,d0
        cmp.w   #32,d0
        blt.s   dpeprt  ?
        cmp.w   #127,d0
        bne.s   dpenxt  ?
        blt.s   dpenxt  ?
dpeprt  moveq   #'.',d0
dpenxt  move.w  d0,-([sp])
        lea     dfdemit(pc),[w]
        jmp     dodefer(pc)

Cat     addq.l  #2,[sp]    {31/2} (col row -- f)  gotoxy
        move.l  ([sp])+,d1 col.w
        move.w  d2,-([sp]) restore flag
        move.l  d1,d2
        swap    d2        col.hi row.lo
        bra.s   cpos

Ctab ; {18/1} ( col -- f ) goto col on current 'row'
        move.l  ([sp])+,d2 drop flag & fetch parm
        move.w  d2,d1
        swap    d2
        move.w  d2,-([sp]) restore flag
        moveq   #16,d0    sd.pos
        bra.s   curcom

Chome   moveq   #0,d1      {30}
cpos    moveq   #16,d0    sd.pos
        bra.s   ccput

Cpage   moveq   #32,d0    sd.clear {12}
        bra.s   ccput

Ccnl    moveq   #1,d2     next row {10}
        moveq   #5,d0     io.sbyte
curcom  add.w   urow([bp],[up].l),d2
        bpl.s   ccput
        clr.w   d2        row not -ve
ccput   move.l  d2,uout([bp],[up].l)
        lsl.w   #3,d0
        or.b    #3,d0     nowait stdout
        pea     ([nx])
        jmp     iocomm(pc)

Ccuru   moveq   #21,d0    sd.prow  {11}
        move.l  uout([bp],[up].l),d2 keep col(=out)
        move.w  #-1,d2    decrement row
        bra.s   curcom

Ccurd   moveq   #22,d0    sd.nrow  {24}
        moveq   #1,d2
        bra.s   curcom

Ccen    move.w  d1,d0         {14} {15}
        bra.s   curtrap

Xcurr   moveq   #20,d0             {6}
        moveq   #1,d2     next col
curtrap lsl.w   #3,d0
        addq.b  #3,d0     no wait stdout
        jmp     iocnext(pc)

CXpos   move.l  d2,-([sp])         {29/0/4} chenq on in-cons
        move.l  d2,-([sp])
        lea     2([sp]),a1         (-- wwd wht col row f)
        sub.l   [bp],a1
        moveq   #11,d0    sd.chenq
        bra.s   curtrap

Xqterminal moveq #$e<<3!0!2,d0  io.cursen nowait stdin
        bsr.s   iocomm          >
        moveq   #0<<3!0!2,d0    io.pend nowait stdin
        bsr.s   iocomm          >
        moveq   #1,d1
        not.l   d3              noerr or err.nc
        bhi.s   Xd1put          ? err.ef
        moveq   #0,d1
Xd1put  move.w  d1,-([sp])
xqtnxt  [jnx]

CXdel   pea     ([nx])          ret to next
        moveq   #0,d2
        bsr.s   cureocal        > cursen on stdout
        moveq   #127,d1
        addq.w  #1,d3
        bmi.s   delnwd          ? (d2=0 on err.)
        bsr.s   bsncount        > cursor back
        moveq   #32,d1          blank
delnwd  moveq   #5<<3!0!3,d0    io.sbyte nowait stdout
        bsr.s   iocomm
bscal   moveq   #-1,d2          decrement out
bsncount move.w #19<<3!0!3,d0   sd.pcol
        bra.s   iocount - cursor back

Xbs     pea     ([nx])
        pea     bscal(pc)
cureocal moveq  #$e<<3!0!3,d0   io.cursen nowait stdout
        bra.s   iocomm  -

Xconstype lea   Xtwodp(pc),a0
        bsr.s   tprompt >
        beq.s   iotype  -
Xtypel  moveq   #4!3,d0
        move.w  ([sp])+,d2
        move.l  ([sp])+,a1
        sub.l   [bp],a1
        bra.s   iotypel -
Xtype   moveq   #4!3,d0
iotype  move.w  ([sp])+,d2
        move.w  ([sp])+,a1
iotypel ble.s   xqtnxt  ? don't send nothing nor > 32K
        move.w  #255,d3 ;;
        cmp.w   d2,d3   ;;
        bpl.s   msgtype ;;
        pea     ([nx])  ;;
        move.w  d2,-(a7) ;
        move.w  d0,-(sp) ;
        move.w  d3,d2   ;;
        lea     longtpe(pc),[nx] ;;
msgtype or.w    #7<<3,d0
iocnext pea     ([nx])
iocount add.w   d2,uout([bp],[up].l)
        bpl.s   iocomm  ?
        clr.w   uout([bp],[up].l)
iocomm  moveq   #3,d3
        and.b   d0,d3   trap#3 {k}ey {w}ait {c}hannel no.
        lea     stdio-2(pc),a0
        move.b  0(a0,d3.w),d3
        bsr.s   mkchp   >
        bmi.s   t3err   ?
        move.l  d3,a0   id
        lsr.w   #3,d0   opcode
        subx.w  d3,d3   preset wait or not
        and.w   utimo([bp],[up].l),d3 mask in timeout
trap3   add.l   [bp],a1
        pea     (a1)
        trap    #3
        move.w  d1,a1
        add.l   (a7)+,a1 err.bp screws a1, this is for 'expect'
        move.l  d0,d3
t3err   move.l  d3,d0
        beq.s   tp3ret  this for timeout
        move.l  d3,cioerr-Z([bp])
        moveq   #0,d2   2ndary error flag
        not.l   d0      err.nc => 'eq'
tp3ret  rts

tprompt tst.w   upromptq([bp],[up].l)
        bne.s   tpret       ?
        move.l  a0,(a7)
tpret   clr.w   -([sp])
        jsr     cdashwd(pc) > chg: d0 d1 d3 a0:id a2
        moveq   #2,d0       nowait stdin
        subq.w  #1,([sp])+  generate 'ne'
        bmi.s   tpxit       ?
        moveq   #0,d3       'eq'
tpxit   rts

Xconsemit lea   Xdrop(pc),a0
        bsr.s   tprompt >
        beq.s   ioemit  ?
Xemit   moveq   #4!3,d0 wait stdout
ioemit  move.w  ([sp])+,d1
        or.w    #5<<3,d0 io.sbyte
        moveq   #1,d2
        bra.s   iocnext -

mknix   moveq   #-1,d3
        rts

*REIN: d3.b chan# RAUS: d3.l ch-id a2 ptr to ch-id storage
mkchp   move.w  limit+2-Z([bp]),a0
        add.l   [bp],a0
        cmp.b   #15,d3  d3: (#(d3).b channel -- d.id) a2: ptr
        bhi.s   mknix   ?
        move.b  d3,iochn-Z([bp])
        lsl.w   #2,d3
        lea     0(a0,d3.w),a2
        move.l  (a2),d3 'mi' if no channel
        rts

longtpe sub.l   [bp],a1 ;;
        move.w  (a7)+,d0
        move.w  (a7)+,d2
        move.l  (a7)+,[nx]
        sub.w   #255,d2
        bvc     iotypel ?
        [jnx]

Cactiv  moveq   #10,d0
        move.w  ([sp])+,d3 wait
        move.w  ([sp])+,d2 prior
        move.l  ([sp])+,d1 job
        pea     ([nx])
        bra.s   Xt1t       go

Xcjob   move.w  #1,-([sp]) runaddr datalen codelen owner -- job )&{a2l?}jdt
Xtrap1a move.w  ([sp])+,d0
        movem.l ([sp])+,d1/d2/d3/a1
        movem.l d1/d2/d3/a0/a1,d1lp-Z([bp])
        bra.s   xt11e
Xt12    move.w  ([sp])+,d0                   <susjb jinf frjob tra prior alchp
        move.l  ([sp])+,d2      2: d2=:d3
        move.l  d2,d3
        bra.s   xt12e
Xt11    move.w  ([sp])+,d0                   <reljb mode baud sclck rechp
xt12e   move.l  ([sp])+,d1      1: d1 a0
        move.l  d1,a0
        movem.l d1-d3/a0,d1lp-Z([bp])
        bra.s   xt11c
Xt10    move.w  ([sp])+,d0                   <free rclck
xt11c   clr.l   a2lp-Z([bp])    a1:=0
xt11e   moveq   #-2,d1                       <cjob
        and.b   d1,a1wp+3-Z([bp]) a0 always even
        and.b   d1,a2lp+3-Z([bp]) a1 also
        pea     ([nx])
        movem.l d1lp-Z([bp]),d1/d2/d3/a0/a1
Xt1t    trap    #1                           <activ
        move.l  (a7)+,[nx]
        move.l  d0,qf.error-Z([bp])
        movem.l d1/d2/d3/a0/a1,d1lq-Z([bp])
        move.l  d1,-([sp])     always
        [jnx]

Xsafesto pea    ([nx])   <safe!)  last @ pfa lfa fence !
        move.w  ulast([bp],[up].l),-([sp])
        lea     svsto2(pc),[nx] lfa fence !
Xpfa    move.w  ([sp]),d0
        moveq   #$1f,d1
        and.b   0([bp],d0.w),d1
        move.w  uwidth([bp],[up].l),d2
        cmp.w   d1,d2
        bpl.s   pfawdt
        move.w  d2,d1
pfawdt  add.w   d1,d0
        or.b    #1,d0
        addq.w  #5,d0
        move.w  d0,([sp])
        [jnx]

Ctraverse move.w ([sp])+,d1
nfantr  move.w  uwidth([bp],[up].l),d2
travloop add.w  d1,([sp])
        move.w  ([sp]),d0
        tst.b   0([bp],d0.w)
        dbmi    d2,travloop ?
        [jnx]

Xnfa    subq.w  #5,([sp])
        moveq   #-1,d1
        bra.s   nfantr

svsto2  move.w  ([sp])+,d0
        subq.w  #4,d0   lfa
        move.w  d0,ufence([bp],[up].l)
        move.w  d0,ofnc-Z([bp])
        and.b   #-2,d0
        ext.l   d0
        move.l  d0,2+ofnc-Z([bp]) dp for cold restart
        move.l  (a7)+,[nx]
        [jnx]

Cfrmt   moveq   #3,d0
        bsr.s   trap2
        move.w  d0,-([sp])
        bne.s   fmt_nxt
        addq.l  #2,[sp]
        movem.w d0/d1/d2,-([sp])
fmt_nxt [jnx]

Cfdel   pea     ([nx])
        moveq   #4,d0
trap2   move.l  [bp],a0
        add.w   ([sp])+,a0
        moveq   #-1,d1
        trap    #2
        move.l  d0,qf.error-Z([bp])
        rts

CXt30   pea     jqerr(pc)
        move.w  ([w]),d0wp-Z([bp])
        bra.s   t3cal

CXt3    pea     ([nx])  ( --)
t3cal   pea     dt3ntr(pc)
t3ch    pea     chidcal(pc) <CXt3lon
        jmp     cdftcal(pc)

CXt3g   pea     ([sp])  (fn1 fn2 fn3 fn4 fn5 -- fn1 .. fn5) error code in {ernum}
        movem.l ([sp]),d0-d5/a0/a1
        movem.l d0-d5/a0/a1,-([sp])
        move.l  [sp],d2
        sub.l   [bp],d2
        move.w  d2,a1wp-Z([bp])
        move.w  ([w])+,d0wp-Z([bp])
        bsr.s   t3cal
        move.l  (a7)+,[sp]
        [jnx]

CXt3lon pea     ([nx])
        bsr.s   t3ch
        move.l  ([sp])+,a0
        moveq   #-1,d4
        bra.s   dt3tnt

dt3ntr  move.l  ([sp])+,a0
        moveq   #1,d4   set a1-flag
* entry with flags/d4 'mi' a1.l:={a1.w|a2.w} 'eq' a1.w unsigned 'gt' a1.w signed
dt3tnt  pea     (a6)    save system base
        movem.l d1lp-Z([bp]),d1/d2
        movem.w d0wp-Z([bp]),d0/d3/a1/a2
        bgt.s   dt3sgd  ? 32K signed
        movem.l a1wp-Z([bp]),a1/a2
dt3sgd  add.l   [bp],a1
        add.l   [bp],a2
        trap    #3
        move.l  (a7)+,a6
        move.l  d1,d1lq-Z([bp])
        movem.l a1/a2,a1lq-Z([bp])
        sub.l   [bp],a2
        sub.l   [bp],a1
        movem.w a1/a2,a1wq-Z([bp])
        move.l  d0,qf.error-Z([bp])
        rts

Xcmovel move.w ([sp])+,d1
        movem.l ([sp])+,a0/a1
        bra.s   jmovel

Cdomove movem.w ([sp])+,d1/a0-a1 ( from to n --- )
        add.l   [bp],a0
        add.l   [bp],a1
        bra.s   fillent -

Xcmove  movem.w ([sp])+,d1/a0/a1  cnt dst src
        add.l   [bp],a0 ;;
        add.l   [bp],a1 ;
jmovel  lea     ccmvu(pc),[w]     a1)+ => a0)+
        cmp.l   a0,a1
        bhi.s   fillent ?
        lea     ccmvd(pc),[w]
fillent cmp.l   a0,a1                  ;;
        beq.s   jwmnxt  ? same address ;;
        subq.w  #1,d1
        bmi.s   jwmnxt  ? don't move nothing nor 32K+
        move.w  a1,d3
        move.w  a0,d2
        ror.w   #1,d3   test wether word-move would be possible
        asr.w   #7,d3
        lsr.w   #1,d2
        scs     d3      -1 both odd, 0 both even, else one odd
        tst.w   ([w])+
        move.l  ([w]),[w]
        jmp     0([bp],[w].l)

* move bytes bottom up
jwcup   add.w   d1,d1   : move> cont'd if odd address(es)
        addq.w  #1,d1
jcmvup  move.b  (a1)+,(a0)+ : cmove>
        dbra    d1,jcmvup
jwmnxt  [jnx]
* move words bottom up
jwmvup  tst.w   d3      : move>
        bne.s   jwcup   ? odd
lwmvup  move.w  (a1)+,(a0)+
        dbra    d1,lwmvup
        [jnx]
* move bytes top down
jwcdn   sub.w   d1,a0
        addq.l  #1,a0
        sub.w   d1,a1
        addq.l  #1,a1
        add.w   d1,d1
        addq.w  #1,d1
jcmvdn  lea     1(a0,d1.w),a0   <cmove and entrypoint of <move
        lea     1(a1,d1.w),a1
        bmi.s   jwmvdn  ? 16-bit move
lcmvdn  move.b  -(a1),-(a0)
        dbra    d1,lcmvdn
        [jnx]
* move words top down
jwmvdn  tst.w   d3
        bne.s   jwcdn   ? odd pointer(s)
        lea     1(a0,d1.w),a0
        lea     1(a1,d1.w),a1
lwmvdn  move.w  -(a1),-(a0)
        dbra    d1,lwmvdn
        [jnx]

Xblanks move.w  #' ',-([sp])
Xfill   movem.w ([sp])+,d0-d1/a0      ( addr n byte --- )
        subq.w  #1,d1
        bmi.s   xfilnx
        add.l   [bp],a0
xfiloop move.b  d0,(a0)+
        dbra    d1,xfiloop
xfilnx  [jnx]

Xerase  clr.w   -([sp])
        bra.s   Xfill

Cchkf   move.w  ([sp])+,d0
        chk     ([sp])+,d0
        svs     d0
        neg.b   d0
        ext.w   d0
        move.w  d0,-([sp])
        [jnx]

Cxqdv   move.w  ([w]),[w]       fetch vector address
        move.w  ([w]),[w]       qdos-vector
        bsr.s   cpad(pc)
        move.w  ([sp])+,a1
        move.l  ([sp])+,d1
        jsr     ([w])
        addq.l  #2,a1
        move.w  a1,-([sp])
        move.w  -2([bp],a1.l),-([sp])
        [jnx]

ascih   move.l  (a7)+,[nx]      <a>h)
        subq.w  #1,([sp])
        bmi.s   ascihnx
        addq.l  #2,[sp]
ascihnx [jnx]

*fr <# #s SIGN #> von shpsnum
shpsign lea     shpgnum(pc),[nx] => #>
Xsign   move.l  ([sp])+,d1      sign
        move.w  ([sp])+,d0
        move.l  d1,-([sp])
        tst.w   d0
        bpl.s   signnx  ?
        moveq   #'-',d1
        bra.s   hldsign -
Xhold   move.w  ([sp])+,d1      hold
hldsign move.L  uhld-2([bp],[up].l),d0
        subq.l  #1,d0
        move.L  d0,uhld-2([bp],[up].l)
        move.b  d1,0([bp],d0.l)
signnx  [jnx]

Xqhld   pea     ([nx])          hld?
        moveq   #-1,d1
Cqhld   move.w  uhld([bp],[up].l),d3
        sub.w   udp([bp],[up].l),d3
        subq.w  #3,d3
        bmi.s   hldrtst
        move.w  d3,d0           for <i
        rts
hldrtst moveq   #-4,d0          protect dictionary space
        move.w  d0,vftherr-Z([bp])
        tst.w   d1
        bpl.s   hldrrt
        move.w  d0,-([sp])
hldrrt  rts

XCpad   pea     ([nx])
cpad    moveq   #.lumpplus,d0
        add.L   udp-2([bp],[up].l),d0
        and.b   #-2,d0
        move.w  d0,-([sp])
        rts

Xbddot  move.w  ([sp])+,d2      (d#)
        move.l  ([sp])+,d1
        moveq   #0,d0
        tst.w   d2
        beq.s   bdduns  ? unsigned
        move.l  d1,d0
        bpl.s   bddpve  ? +ve
        neg.l   d1
bddpve  swap    d0
bdduns  move.w  d0,-([sp])
        move.l  d1,-([sp])
;Xdsnum
        pea     ([nx])          <# #s sign #>
        lea     shpsnum(pc),[nx]
Clsharp bsr.s   cpad            <#
        addq.l  #2,[sp]         pad hld !
        move.l  d0,uhld-2([bp],[up].l)
        clr.w   vftherr-Z([bp]) 0 to 4th-err
        [jnx]

shpgnum move.l  (a7)+,[nx]      von shpsign
Csharpgt addq.l #4,[sp]         #>
        bsr.s   cpad            2drop pad
        move.l  d0,d1           for l<i
        move.l  uhld-2([bp],[up].l),d0
        move.w  d0,([sp])       hld @
        sub.l   d0,d1           over-
        move.w  d1,-([sp])
        [jnx]

Xhasci  pea     ([nx])          h>a
        move.w  ([sp]),d2
        bra.s   hascint

* <# #S sign #>
shpsnum lea     shpsign(pc),[nx] nach Xdsnum
Xsharps moveq   #0,d1   (test)  #s
        bsr.s   Cqhld   >to protect dictionary space
        move.w  d3,d0
        bmi.s   shpserr ? no space left
        pea     ([nx])
        lea     shplop(pc),[nx]
nxshps  bra.s   Xsharp
shplop  tst.l   ([sp])
        dbeq    d3,nxshps
        move.w  d3,d0   for <i
        move.l  (a7)+,[nx]
        [jnx]
shpserr move.l  d1,([sp]) give up conversion
        [jnx]

Xsharp  pea     Xhold(pc)       (must preserve D3)
        move.w  ubase([bp],[up].l),d0
        bsr.s   mbymntr
        move.l  ([sp]),2([sp])
hascint cmp.w   #9,d2
        ble.s   shpasci
        addq.w  #7,d2
shpasci add.b   #'0',d2
        move.w  d2,([sp])
        rts

* signed ovf rmd & dqot check ( dn.dvd - n.rmd dn.ovf )
bynulov moveq   #1,d0     * 0/0=:1 +ve/0 =:+7fff.ffff * -ve/0=:-7fff.ffff
dmmulov moveq   #0,d1     * rmd and ovf to wordlength
        move.l  ([sp])+,d2  ( dn -- n.ov dn.ov )
        beq.s   bynulpsh    ?
        add.l   d2,d2       sign
        subx.l  d1,d1
        add.l   d1,d1       0 +ve     -2 -ve
        moveq   #-2,d0
        ror.l   #1,d0       7fffffff
        sub.l   d1,d0                80000001
        neg.w   d1          0           2
        add.w   #$7fff,d1   7fff     8001
bynulpsh move.w d1,-([sp])  rmd 0 or +/-7fff
        move.l  d0,-([sp])  qot 1. or +/-7fff.ffff
        rts

Xmbymod pea     ([nx])
        move.w  ([sp])+,d0 dvs
mbymntr beq.s   bynulov
        moveq   #0,d1      unsigned
        move.w  ([sp])+,d1 dvd.hi
        divu    d0,d1      q.hi=d1:={rmd.hi|qot.hi}=d.hi/dvs
        move.l  d1,d2      r.hi
        move.w  ([sp])+,d2 dvd.lo
        divu    d0,d2      d.lo  d2:={r.lo|q.lo}={r.hi|d.lo}/dvs
jsdup   swap    d2
        move.l  d2,-([sp]) put r.lo & q.lo
Xd1ret  move.w  d1,-([sp]) q.hi
        rts

Xsdup   pea     ([nx])
        move.l  ([sp])+,d2
        move.w  d2,d1
        bra.s   jsdup

Xdby    move.l  ([sp])+,d1      (dn1 dn2 -- d3q
        moveq   #0,d2
        move.l  ([sp])+,d3
        bpl.s   dbycal
        moveq   #-1,d2
dbycal  movem.l d1-d3,-([sp])
        bsr.s   CXqmbym >
        addq.l  #4,[sp] drop qot.hi
        move.l  ([sp])+,([sp]) & rmd
        [jnx]

* quad integers

Xqsub   lea     8([sp]),[w]
        lea     8([w]),a0
        move.l  -([w]),d0
        sub.l   d0,-(a0)
        subx.l  -([w]),-(a0)
        move.l  a0,[sp]
        [jnx]

Xqadd   lea     8([sp]),[w]
        lea     8([w]),a0
        move.l  -([w]),d0
        add.l   d0,-(a0)
        addx.l  -([w]),-(a0)
        move.l  a0,[sp]
        [jnx]

Xqmplus move.w  ([sp])+,d0
        ext.l   d0
        smi     d1
        ext.w   d1
        ext.l   d1
        move.l  ([sp])+,d2
        add.l   ([sp])+,d0
        addx.l  d1,d2
        move.l  d0,-([sp])
        move.l  d2,-([sp])
        [jnx]

* signed quad by signed double to signed quad rmd & signed double qot
Xqmbym  pea     ([nx])    : qm/mod
CXqmbym move.w  ([sp]),d1   sgn(dvs)
        bpl.s   uqbrpve
        neg.l   ([sp])
uqbrpve lea     4([sp]),[w]
        move.l  ([w])+,d0 qot
        bpl.s   uqbdpve ?
        neg.l   ([w])
        negx.l  -([w])
uqbdpve add.l   d0,d0   dvd
        subx.l  d0,d0
        add.w   d1,d1   dvs
        subx.l  d1,d1
        clr.w   d0
        move.w  d0,vftherr-Z([bp])
        eor.l   d1,d0   hi.w:sgn(qot) lo.w:sgn(dvs)=:sgn(rmd)
        move.l  d0,-(a7) save sign flags
        bsr.s   CXuqmbym >d0:dvd d3:r d1:q.h d2:q.l d4.hi -ve ovf
* +/+ q+ r+ : +/- q1- rf- :: -/- q+ r- :: -/+ q1- rf+
* floor and -ve quot if -ve (dvs eor dvd) * -ve rmd if -ve dvd
        tst.l   d4
        bpl.s   uqbnov  ? ovf
        move.w  #-18,vftherr-Z([bp])
uqbnov  moveq   #0,d5
        move.l  ([rp])+,d4
        bpl.s   uqbpqt  ? +qot
        neg.l   d2
        negx.l  d1
        tst.l   d3
        beq.s   uqbprm  ? rmd 0
        subq.l  #1,d2
        subx.l  d5,d1
        sub.l   d3,d0
        move.l  d0,d3   floor rmd
uqbpqt  tst.w   d4      sgn(rmd)
        bpl.s   uqbprm  ? +ve
        neg.l   d3
uqbprm  movem.l d1-d3,([sp])
        rts

Xudmbym pea     Xtwodp-Z([bp])  um/mod (+qn1 dn2 -- d3r q4q
        bra.s   CXuqmbym

Xuqmbym pea     ([nx])          uqm/mod (+qn1 udn2 -- d3r q4q
CXuqmbym movem.l d5-d7,-(a7)
        moveq   #-1,d1          rmd on ovf
        movem.l ([sp])+,d0/d3/d6 dvs dvd.h dvd.l
        tst.l   d3
        bmi.s   uqbymrs         ?divisor signbit set
        moveq   #32,d7
        moveq   #63,d4
uqbymnm cmp.l   d3,d0
        bhi.s   uqbymrg         ?
        add.l   d0,d0
        bvc.s   uqbnxnm         ?
        bcc.s   uqbnxnm         ?
        roxr.l  #1,d0           rst dvd
        lsr.l   #1,d3
        roxr.l  #1,d6
        add.w   d7,d7
uqbnxnm dbeq    d7,uqbymnm      ? normalize dvs > dvd.h
        bra.s   uqbymrs         ? ovf
uqbymrg sub.w   d7,d4
        moveq   #0,d2           qot.l clear
        moveq   #0,d1           qot.h
uqbymlp add.l   d2,d2           qot.l 2*
        addx.l  d1,d1           qot.h
        add.l   d6,d6           dvd.l 2*
        addx.l  d3,d3           dvd.h 2* + Cy
        bcc.s   uqbymhi         ? next digit
        roxr.l  #1,d3           restore dvd
        roxr.l  #1,d6
        lsr.l   #1,d1
        roxr.l  #1,d2           and qot
uqbymhi move.l  d3,d5           try dvd.h
        sub.l   d0,d5           dvd.h:=dvd.h-dvs
        bcs.s   uqbymcy         ? ovf
        move.l  d5,d3           updt dvd.h
        moveq   #0,d5
        addq.l  #1,d2           qot.l count
        addx.l  d5,d1           qot.h
uqbymcy dbra    d4,uqbymlp      ?
        moveq   #32,d4
        sub.w   d7,d4
        bpl.s   uqbqnrm         ?
        neg.l   d4              normalize back & set hi.w flag
        lsl.l   d4,d3
        clr.w   d4
uqbqnrm lsr.l   d4,d3           adjust rmd
uqbymrs movem.l d1/d2/d3,-([sp]) qh ql rm
        movem.l (a7)+,d5-d7
        rts

Cmtinf  moveq   #0,d0
        trap    #1
        movem.l d1/d2/a0,-([sp])
        [jnx]

Xrpstore move.l [bp],d0
        add.L   ur0-2([bp],[up].l),d0
        move.l  d0,[rp]
        [jnx]

Xumin   move.w  ([sp])+,d0
        cmp.w   ([sp]),d0
        bcs.s   mmput
        [jnx]

Xmin    move.w  ([sp])+,d0
        cmp.w   ([sp]),d0
        bge.s   nomin
mmput   move.w  d0,([sp])
nomin   [jnx]

Xmax    move.w  ([sp])+,d0
        cmp.w   ([sp]),d0
        bgt.s   mmput
        [jnx]

Xumax   move.w  ([sp])+,d0
        cmp.w   ([sp]),d0
        bhi.s   mmput
        [jnx]

CXqsplus move.w  ([sp])+,a0
        add.l   8+mtinftab-Z([bp]),a0
        move.l  a0,-([sp])
        [jnx]

Xtworot move.l  ([sp])+,d1
        move.l  ([sp])+,d2
        move.l  ([sp])+,d0
        movem.l d0/d1/d2,-([sp])
        [jnx]

Xndrop  move.w  ([sp])+,d0
        add.w   d0,d0
        add.w   d0,[sp]
        [jnx]

Xswapb  move.b  ([sp])+,d0
        move.b  ([sp]),-([sp])
        move.b  d0,1([sp])
        [jnx]

Xswapx  move.l  ([sp]),d0
        swap    d0
        move.l  d0,([sp])
        [jnx]

Xtwoswap move.l ([sp])+,d0
        move.l  ([sp]),d1
        move.l  d0,([sp])
        move.l  d1,-([sp])
        [jnx]

Xpick   move.w  ([sp]),d0
        add.w   d0,d0
        move.w  2([sp],d0.w),([sp])
        [jnx]

Xd4mul  move.l  ([sp]),d0
        lsl.l   #2,d0
        move.l  d0,([sp])
        [jnx]

Xbytes  moveq   #0,d0
        move.b  ([sp]),d0
        sf      ([sp])
        move.w  d0,-([sp])
        [jnx]

CXhere  move.L  udp-2([bp],[up].l),d0
        move.w  d0,-([sp])
        [jnx]

Xm2allot move.w #-2,-([sp])
CXallot move.w  ([sp])+,d0
        ext.l   d0
        add.L   d0,udp-2([bp],[up].l)
        [jnx]

CXdefinitions
        move.w  ucurrent([bp],[up].l),uocurrent([bp],[up].l)
        move.w  ucontext([bp],[up].l),ucurrent([bp],[up].l)
        [jnx]

Xfrot   movem.l ([sp])+,d2-d4
        move.w  ([sp])+,d0
        move.l  ([sp])+,d1
        movem.l d0-d4,-([sp])
        addq.l  #2,[sp]
        [jnx]

Xfmdiv  lea     muldivtab-Z([bp]),a2
        sub.l   [bp],a2
        move.l  [sp],a0
        sub.l   [bp],a0
        moveq   #0,d0
        jmp     XriXd0(pc)

Xf2swap movem.l ([sp])+,d3/d4/d5
        movem.l ([sp])+,d0/d1/d2
        movem.l d0-d5,-([sp])
        [jnx]

Xfdot   bsr     CXftd
        move.w  a0,d0   len
        beq.s   fdnx    ? err.
        addq.w  #1,([sp])
        add.l   a0,a1   end
        move.b  #' ',0([bp],a1.l)
        lea     dfdtype(pc),[w]
        jmp     dodefer(pc)

Xfgr    move.w  ([sp])+,d0
        move.l  ([sp])+,-([rp])
        move.w  d0,-([rp])
        [jnx]

Xfrg    move.w  ([rp])+,d0
        move.l  ([rp])+,-([sp])
        move.w  d0,-([sp])
fdnx    [jnx]          <fdot)

Xfroll  bsr.s   cfpick
        bmi.s   frolnul
        addq.w  #2,d1
        lea     6(a1),a0
frolop  move.w  -(a1),-(a0)
        dbra    d1,frolop
Xfdrop  addq.l  #6,[sp]
frolnul [jnx]
;;frolneg subq.w  #2,d1
;        neg.w   d1
;        addq.l  #6,[sp]
;        move.l  [sp],a1
;        lea     6([sp]),a0
;frulop  move.w  (a0)+,(a1)+
;        dbra    d1,frulop
;        movem.w d0/d2/d3,(a1)
;        [jnx]

Xfplusdash moveq #20,d0
        tst.w   ([sp])+
        bmi     XriXd0
        [jnx]

Xfdup   movem.w ([sp]),d0/d2/d3
        bra.s   fspush

Xfswap  movem.w ([sp])+,d1/d4/d5
        movem.w ([sp]),d0/d2/d3
        movem.w d1/d4/d5,([sp])
fspush  pea     ([nx])
        bra.s   fpush

Xfover  moveq   #6,d0
        pea     ([nx])
        bra.s   fpik1

Xfpick  pea     ([nx])
cfpick  move.w  ([sp]),d0
        add.w   d0,d0
        add.w   ([sp])+,d0
        move.w  d0,d1           (no. of cells for froll)
        add.w   d0,d0
fpik1   lea     0([sp],d0.w),a1
        movem.w (a1),d0/d2/d3
fpush   movem.w d0/d2/d3,-([sp])
        rts

* store/fetch/plusstore

Xnever  move.w  ([sp])+,[w]     (break & safety)
        add.l   [bp],[w]
        st      ([w])+
        st      ([w])+
        [jnx]

Xoff    moveq   #0,d0           off
        bra.s   Xoffx
Xon     moveq   #1,d0           on
Xoffx   move.l  [bp],[w]
        add.w   ([sp])+,[w]
        sf      ([w])+
        move.b  d0,([w])
        [jnx]

Xpstoa  move.l  [bp],[w]        +!a
        add.w   ([sp])+,[w]
        move.w  ([sp])+,d0
        add.w   ([w]),d0
        move.w  d0,([w])
        [jnx]

Xtwopstol move.l ([sp])+,[w]    2+!l
        bra.s   ctopsto
Xtwopsto move.l [bp],[w]        2+!
        add.w   ([sp])+,[w]
ctopsto addq.l  #4,[w]
        lea     4([sp]),a0
        moveq   #0,d0
        add.w   d0,d0
        addx.b  -(a0),-([w])
        addx.b  -(a0),-([w])
        addx.b  -(a0),-([w])
        addx.b  -(a0),-([w])
        addq.l  #4,[sp]
        [jnx]

Xpstol  move.l  ([sp])+,[w]     +!l
        bra.s   cpsto
Xbpsto  move.l  [bp],[w]        +!
        add.w   ([sp])+,[w]
cpsto   addq.l  #2,[w]
        lea     2([sp]),a0
        moveq   #0,d0
        add.w   d0,d0
        addx.b  -(a0),-([w])
        addx.b  -(a0),-([w])
        addq.l  #2,[sp]
        [jnx]

Xfourf  addq.w  #4,([sp])       4@
        pea     ([nx])
        lea     nx4f(pc),[nx]
Xtwof   move.l  [bp],[w]        2@
        add.w   ([sp])+,[w]
        bra.s   Xtwofetch

Xcountw move.w  ([sp]),-([sp])  count-w
        addq.w  #2,2([sp])
Xfetch  lea     2([bp]),[w]     @
        add.w   ([sp])+,[w]
fetchlong move.b -([w]),-([sp])
         move.b -([w]),-([sp])
        [jnx]

Xfetchl move.l  ([sp])+,[w]     @l
        addq.l  #2,[w]
        bra.s   fetchlong

nx4f    move.l  (a7)+,[nx]
        bra.s   xqfnx

Xfourfl pea     ([nx])          4@l
        lea     nx4f(pc),[nx]
        addq.l  #4,([sp])
Xtwofetchl move.l ([sp])+,[w]   2@l
Xtwofetch addq.l #4,[w]         <2@)
xqfnx   move.b  -([w]),-([sp])
        move.b  -([w]),-([sp])
        bra.s   fetchlong

Xcfetch move.w  ([sp])+,[w]     c@
cfetchw move.b  0([bp],[w].w),-([sp])
cclrlong sf     -([sp])
ccjnx   [jnx]

pdcount move.l  (a7)+,[nx]
        bne.s   ccjnx
        addq.l  #2,[sp]
Xcount  move.w  ([sp]),[w]      count
        addq.w  #1,([sp])
        bra.s   cfetchw

Xdcount pea     ([nx])          -count
        lea     pdcount(pc),[nx]
        bra.s   Xcount

Xcountl move.l  ([sp]),-([sp])  count-l
        addq.l  #1,4([sp])
Xcfetchl move.l ([sp])+,[w]     c@l
        move.b  ([w]),-([sp])
        bra.s   cclrlong

Xfetcha move.w  ([sp])+,[w]     @a
        add.l   [bp],[w]
        move.w  ([w])+,-([sp])
        [jnx]

X2fetcha move.w ([sp])+,[w]     2@a
        add.l   [bp],[w]
        move.l  ([w])+,-([sp])
        [jnx]

Xdcomma pea     ([nx])
        lea     rdcomma(pc),[nx]
        bra.s   Xcomma
rdcomma move.l  (a7)+,[nx]
        bra.s   Xcomma

Xzerocomma
        move.w  #2,-([sp])
Xcfacomma subq.w #2,([sp])
        addq.w  #1,ccmc-Z([bp])  inc commands counter
Xcomma  move.L  udp-2([bp],[up].l),d0 here
        move.l  d0,[w]          (may be odd!)
        addq.L  #2,d0                 2
        move.L  d0,udp-2([bp],[up].l) allot
        bra.s   stocomma              !

Xccomma move.L  udp-2([bp],[up].l),d0 here
        addq.L  #1,d0                 1
        move.L  d0,udp-2([bp],[up].l) allot
        move.w  ([sp])+,d1
        move.b  d1,-1([bp],d0.L)      c!
        [jnx]

nx4s    move.l  (a7)+,[nx]      <4! 4!l
        bra.s   xtwostore -
X2off   move.w  ([sp])+,d0      2off
        clr.l   -([sp])
        move.w  d0,-([sp])
Xtwosto move.l  [bp],[w]        2!
        add.w   ([sp])+,[w]
Xtwostore move.b ([sp])+,([w])+ <2!l)
        move.b  ([sp])+,([w])+
        bra.s   storelong

Xstore  move.w  ([sp])+,[w]     !
stocomma  add.l  [bp],[w]
storelong move.b ([sp])+,([w])+
        move.b  ([sp])+,([w])+
        [jnx]

Xcsto   move.w ([sp])+,[w]      c!
        add.l  [bp],[w]
cstorelong move.w ([sp])+,d0
        move.b d0,([w])+
        [jnx]

TSTJBOT ; begin of area watched by the secondary job
* where up/nx/ip/sp/bp/rp must be even and within bounds
*       d7 a3 a4 a5 a6 a7

Xfours  pea     ([nx])          4!
        lea     nx4s(pc),[nx]
        bra.s   xtwosto   -

Xstorel move.l  ([sp])+,[w]     !l
        bra.s   storelong

Xfoursl pea     ([nx])          4!l
        lea     nx4s(pc),[nx]
Xtwostorel move.l ([sp])+,[w]   2!l
        bra.s   Xtwostore

Xcstorel move.l ([sp])+,[w]     c!l
        bra.s cstorelong

Xstorea move.w  ([sp])+,[w]     !a
        add.l   [bp],[w]
        move.w  ([sp])+,([w])+
        [jnx]

X2storea move.w ([sp])+,[w]     2!a
        add.l   [bp],[w]
        move.l  ([sp])+,([w])+
        [jnx]

Xddgq   moveq   #-$80,d0        d->q
        add.b   ([sp]),d0
        subx.l  d0,d0
        move.l  d0,-([sp])
        [jnx]

* call a primitive 4th word, entrypoint in [w], and return
Cprim   pea     ([nx])
        lea     cpret(pc),[nx]
        jmp     ([w])
cpret   move.l  (a7)+,[nx]
        rts

Xnosearch clr.w -([sp])
Xpsrchq move.w  ucontext([bp],[up].l),d0
        subq.w  #4,d0
        move.w  ([sp])+,d1
        cmp.w   d1,d0
        beq.s   psrcnxt ?
        move.w  d1,8([bp],d0.w)
psrcnxt [jnx]

Xrvoc   lea     2+ucontext([bp],[up].l),a0
        move.w  (a0),d0
        beq.s   rvocnxt ?
        move.w  d0,-(a0)
rvocnxt [jnx]

Xalso   lea     ucontext([bp],[up].l),a0
        move.w  vnvocs-Z([bp]),d1
        add.w   d1,a0
        add.w   d1,a0
        lea     2(a0),a1
        subq.w  #1,d1
alsonx  move.w  -(a0),-(a1)
        dbra    d1,alsonx
        [jnx]
                                                       
Xprevious lea   ucontext([bp],[up].l),a1
        lea     2(a1),a0
        move.w  vnvocs-Z([bp]),d1
        subq.w  #1,d1
prevnx  move.w  (a0)+,(a1)+
        dbra    d1,prevnx
        [jnx]
                                                       
Xonly   lea     ucontext([bp],[up].l),a0
        move.w  vnvocs-Z([bp]),d1
onlynx  clr.w   (a0)+
        dbra    d1,onlynx
        [jnx]

Xplustext moveq #-1,d3  dummy maxlen  +text (dst src --) append text.w
snmntr  move.w  ([sp])+,a0      srce <sname entry)
        move.w  ([sp])+,a1      dest
        add.l   [bp],a1
        move.b  (a1)+,d2
        lsl.w   #8,d2
        move.b  (a1)+,d2        dest initial count
        add.l   [bp],a0
        move.b  (a0)+,d1
        lsl.w   #8,d1
        move.b  (a0)+,d1        srce additional length
        cmp.w   d1,d3
        bcc.s   ptxlen
        move.w  d3,d1
ptxlen  subq.w  #1,d1
        bmi.s   ptxnx           ? nothing to append
        moveq   #0,d0
        add.w   d0,d0
        addx.b  -(a0),-(a1)
        addx.b  -(a0),-(a1)     accumulate new len
        addq.l  #2,a0           1st char to append
        lea     2(a1,d2.w),a1
ptxlop  move.b  (a0)+,(a1)+
        dbra    d1,ptxlop
ptxnx   [jnx]

Xsname  movem.w ([sp])+,d2/d3/d4  s m d !name (dst max src --)
        lea     0([bp],d4.w),a0
        sf      (a0)+
        sf      (a0)
        move.w  d3,d1
        ble.s   ptxnx           ? no length
        movem.w d2/d4,-([sp])     s d
snmclr  sf      (a0)+
        dbra    d1,snmclr       clear full length
        bra.s   snmntr          - move strg

Xnumfil move.l  unumfil([bp],[up].l),d0 .(r)
        move.w  ([sp])+,d0
        sub.w   ([sp]),d0
        bra.s   nmfntr -
Xemitm  move.l  ([sp])+,d0      m-emit
        bra.s   nmfntr  -
Xspace  move.w  #1,-([sp])      space
Xspaces moveq   #' ',d0         spaces
        swap    d0
        move.w  ([sp])+,d0
nmfntr  subq.w  #1,d0
        bmi.s   emmjnx  ?
        move.w  d0,-([rp])
        swap    d0
        move.w  d0,-([sp])
emmlop  move.w  ([sp]),-([sp])
        lea     dfdemit-Z([bp]),[w]
        jsr     Cdefer(pc) >
        subq.w  #1,([rp])
        bpl.s   emmlop
        addq.l  #2,[rp]
        addq.l  #2,[sp]
emmjnx  [jnx]

;;Xlseal  move.w  #locvoc+4-Z,-([sp])
Xpsealp move.w  ([sp])+,d0      ptr to ptr to voctop
        subq.w  #2,d0           ptr to vocnfa
        move.w  d0,2([bp],d0.w)     to ptr to voctop
        [jnx]

XCdovoc move.w  ucontext([bp],[up].l),uocontext([bp],[up].l)
        addq.w  #2,([sp])
        move.w  ([sp])+,ucontext([bp],[up].l)
        [jnx]

XCncase movem.w ([sp]),d0/a0
        subq.w  #1,d0
        bmi.s   ncsnxt
        add.l   [bp],a0
        moveq   #$7f,d1
ncslop  and.b   d1,(a0)+
        dbra    d0,ncslop
ncsnxt  [jnx]

Xbtst   move.w  ([sp])+,d1
        move.l  ([sp])+,d0
        clr.w   -([sp])
        btst    d1,d0
        beq.s   btsjnx
        addq.w  #1,([sp])
btsjnx  [jnx]

Xbset   move.w  ([sp])+,d1
        move.l  ([sp])+,d0
        bset    d1,d0
        move.l  d0,-([sp])
        [jnx]

Xbclr   move.w  ([sp])+,d1
        move.l  ([sp])+,d0
        bclr    d1,d0
        move.l  d0,-([sp])
        [jnx]

Xdepth  move.L  us0-2([bp],[up].l),d0
        add.l   [bp],d0
        sub.l   [sp],d0
        lsr.w   #1,d0
        move.w  d0,-([sp])
        [jnx]

Xneqbra move.l  ([sp]),d0   over = IF drop ...
        cmp.w   ([sp])+,d0
        bne.s   XXbranch ?  leave item on tos to try again
        addq.l  #2,[sp]     drop
        addq.l  #2,[ip]     enter true-part
        [jnx]
XXbranch add.w  ([ip]),[ip]
        [jnx]

Xistobody move.w ([sp])+,d0     pfa
        bra.s   btobody
Xbisq   move.w  ([ip])+,d0
        cmp.w   vdodebug-Z([bp]),d0 ;;#dodebug-Z,d0
        bne.s   isbody
        move.w  ([ip])+,d0
isbody  addq.w  #2,d0
btobody move.w  ([sp])+,d3       new pfa/value/1st word
        lea     -2([bp],d0.w),a0 deferred cfa
        lea     istab(pc),a1
        move.w  (a0)+,d4        >body
tryis   move.l  (a1)+,d2       exec & cfa @
        beq     nodferd         ? none
        cmp.w   d4,d2
        bne.s   tryis          ? next
        moveq   #0,d1
        swap    d2
        jmp     -4(a1,d2.w)

Xdftcfa move.w  ([sp]),a1
        move.w  -2([bp],a1.l),d1 cfa @
        clr.w   -([sp])
        lea     istab(pc),a1
        moveq   #(dftnd-istab)/4-1,d3
dftcmp  move.l  (a1)+,d2
        cmp.w   d1,d2
        dbeq    d3,dftcmp
        beq     X1plus
        [jnx]

Xbasecpu lea    ubase([bp],[up].l),a0
        move.w  (a0),-([sp])
        move.w  #36,(a0)
        move.l  obasecpu-Z([bp]),-([sp])
        [jnx]

Xsmul   move.w  ([sp])+,a0 ( dn1 n2 -- dn3 | ovf )
        move.l  a0,-([sp])   mul duble by single into double
Xdmul   pea     ([nx])     ( dn1 dn2 - dn3 | ovf )
        bsr.s   dmmulcal  > signed
        addq.l  #4,[sp]   drop hi.l
        not.l   d3        test it
        beq.s   dmulret   ? 32bit -ve
        not.l   d3
        beq.s   dmulret   ? 32bit +ve
        move.l  d3,([sp])
        jsr     dmmulov(pc) > +/- ovf
        addq.l  #2,[sp]
        move.l  d0,([sp])
dmulret rts

Xudmul  pea     Xtwodp-Z([bp])
        bra.s   cudmmul

Xudmmul pea     ([nx])
cudmmul lea     qml_cal(pc),[w] unsigned
        bra.s   udmmulntr

Xdmmul  pea     ([nx])
dmmulcal lea    qml_sgd(pc),[w] signed
udmmulntr move.l d4,a0
        move.l  d5,a1
        move.l  ([sp])+,d4
        move.l  ([sp]),d5
        jsr     ([w])
        move.l  d2,([sp])
        move.l  d4,-([sp])
        move.l  d4,d3
        move.l  a1,d5
        move.l  a0,d4
        rts

Xsrftc  dc.w $4afc
        move.w  ([sp]),sr
        [jnx]

Xsrsto  trap    #0
        move.w  ([sp])+,sr
        [jnx]

Xtrap0r trap    #0
        and.w   #$dfff,sr
        [jnx]

Xngreatr lea    2([sp]),[w]     n>r
        bsr.s   qngtr   >
ngtmps  bmi.s   ngrnxt  ?
ngtpsh  move.w  -([w]),-([rp])
        dbra    d0,ngtpsh
        move.l  a0,[sp]
ngrnxt  [jnx]

Xnrgreat move.l [rp],[w]        nr>
        bsr.s   qngtr   >
        bmi.s   nrgnxt  ?
nrgpop  move.w  -([w]),-([sp])
        dbra    d0,nrgpop
        move.l  a0,[rp]
nrgnxt  [jnx]

qngtr   moveq   #0,d0
        st      d0
        and.w   ([sp])+,d0
        move.w  d0,d1
        add.w   d1,d1           count bytes
        add.w   d1,[w]
        move.l  [w],a0
        subq.w  #1,d0
        rts

qmgtr   moveq   #0,d0
        move.w  ([sp])+,d0      bytes
        move.w  ([sp])+,[w]     mem
        ble.s   qmgnix          ?
        add.l   [bp],[w]
        moveq   #1,d1
        and.w   d0,d1
        add.w   d0,d1           even len
qmgnix  subq.w  #1,d0
        blt.s   qmgtrr          ? none or..
        move.w  #$1ff,d3
        cmp.w   d0,d3           ..too many
qmgtrr  rts

Xrgreatm bsr.s  qmgtr   >       r>m
        blt.s   mrgjnx  ?
        move.l  [rp],a0
mrgpop  move.b  (a0)+,([w])+
        dbra    d0,mrgpop
        add.w   d1,[rp]
mrgjnx  [jnx]

Xmgreatr bsr.s  qmgtr   >       m>r
        blt.s   mgrjnx  ?
        sub.w   d1,[rp]
        move.l  [rp],a0
mgrpsh  move.b  ([w])+,(a0)+
        dbra    d0,mgrpsh
mgrjnx  [jnx]

* IF-optimierung mit 0= und/oder 0< oder 0>
Xqzeqbra move.w #zerobranch-Z,d1
        lea     udp([bp],[up].l),a1
        lea     ccmc-Z([bp]),a0
        tst.w   (a0)
        ble.s   ifo_cma ?
        lea     -2([bp]),[w]
        add.w   (a1),[w]
        move.w  ([w]),d0
        sub.w   #zeroeq-Z,d0
        bne.s   ifo_q01 ?
        subq.w  #2,(a1)
        subq.w  #1,(a0)
        move.w  #nzbranch-Z,d1
ifo_q01 tst.w   (a0)
        ble.s   ifo_cma ?
        lea     -2([bp]),[w]
        add.w   (a1),[w]
        cmp.w   #zeroless-Z,([w])
        bne.s   ifo_q02 ?
        subq.w  #2,(a1)
        move.w  #plbranch-Z,d1
        tst.w   d0
        bne.s   ifo_cma ?
        move.w  #mibranch-Z,d1
        bra.s   ifo_cma -
ifo_q02 cmp.w   #zerogt-Z,([w])
        bne.s   ifo_cma ?
        subq.w  #2,(a1)
        move.w  #lebranch-Z,d1
        tst.w   d0
        bne.s   ifo_cma ?
        move.w  #gtbranch-Z,d1
ifo_cma clr.w   (a0)
        move.l  [bp],a0
        add.w   (a1),a0
        addq.w  #2,(a1)
        move.w  d1,(a0)
        [jnx]






Z equ *+$8000
sys       dc.w next-Z
sysname   dc.w 2,'F6'
syscreen  dc.w $201,7,448,202,32,14

qf.error  dc.l 0

* 4th system vari
savehead dc.l   0     file length
        dc.b    0,1   access code = 0, filetype = executeable
        dc.l    dataspace
        dc.l    0
* dataspace may be altered, but keep < 63K-'here'!

* a simple redirection of our channel table:
iochn   dc.b    1     $24 current i/o            set by 'mkchp'
dr0ch   dc.b    chans-2  (14) dr0 r/w           screen
dr1ch   dc.b    chans-1  (15) dr1 save, chain   file
stdio   dc.b    0        console/std input      in-cons (2nd chain)
stdout  dc.b    1        console/std output     out-cons
usriup  dc.b    2        user input/update file printer
usriow  dc.b    3        user io/work file      work
        ds.w    0       (align)
* Channels are set up as (id's at limit+):
*  0     : primary input: first EX chan or screen
*  1     : primary output: second or only EX chan or screen
*  2     : uncommitted
*  3-11  : may also be passed in by EX
* 12-13  : uncommitted
* 14     : Used by r/w as dr0. used for screen i/o
* 15     : Used by r/w as dr1. Also used by chain and save.

* base of fig-FORTH proper
origin  jmp     docold(pc)  0 restore all regs
        jmp     dowarm(pc)  4
obasecpu dc.l [.cpu]      8 ver.name (M68LR6) in radix 36
* cold/warm move the following to the user area
olast   dc.w  lastop-Z    c last name in dictionary
        dc.w  del.c       e backspace character (never used)
oup     dc.L  0,0,0      10 initial up, s0, r0 and
otib    dc.w  0          1c initial tib - filled in at prog exec
        dc.w  31         1e width   initial max width for names
        dc.w  0          20 warning 0: no disk, 1: dr0 available, -1: (abort) in use
* warm stops here
ofnc    dc.w  linktop-Z  22 fence  initial fence address (lfa)
odp     dc.L  dptop      24 dp=>-L initial top of dictionary
ovocl   dc.w  voctop-Z   26 voc-link initial voc. link pointer
ouup    dc.w  uptop      28 user top
* cold goes all the way, and also resets forth+6 from origin+$c

* system cons & vari *

winhnd  dc.l  0  handler to determine
romhnd  dc.l  0   ..a window channel
pifdsp  dc.l  0  parm-cdt displacement with pif
thntry  dc.l  0  th.entry
hkthg   dc.l  0  the hotkey thing
vquit   dc.w  loadquit-Z  (quit) initial quit-cfa
;*,;vinterpret dc.w interpret-Z (interpret)
vert    dc.w  -1 toggle ert-action
loadblk dc.w  0  initial loading (n.i.)

bootfile string.w {flp1_forth_scr}
        dcb.b cfname+2-*+bootfile,0
loadfile string.w {flp2_forth_scr}
        dcb.b   cfname+2-*+loadfile,0
scrfile string.w {flp2_fig_scr}
        dcb.b   cfname+2-*+scrfile,0
prtfile string.w {ser1}
        dcb.b   cfname+2-*+prtfile,0
dirfile string.w {flp2_}
        dcb.b   cfname+2-*+dirfile,0
lngnam   string {_lngBAD}
cchonnm  string {CACHE_ON}
cchoffnm string {CACHE_OFF}

* block of data set with system initialisation
* 4th addressable by
*       (dir) f/n + 2+ tableoffset +
jdttab  dc.l  0 base address of own job definition table
procftab dc.b 0 -1 68010+, 0 otherwise
emuflag dc.b  0 -2 qxl, -1 emu, 1 pre-js, 0 otherwise
sysmflg dc.b  0 nation char of qdos version
miflag  dc.b  0 -1 minerva (flag for ri-exec), 0 otherwise
mtinftab dc.l 0 job-id
qdosver dc.l  0 qdos vernum (n.nn)
sysvari dc.l  0 base of system variables
deftch  dc.l  0 1st (default) channel
sbase   dc.l  0 job base address a6 = [bp]
bank    dc.l Z-Z,0 (n.i.) initial link offset into (next) memory field
wmanvec dc.l  0 window manager vector if > 0 (n.i.)
clsp    dc.w 0

muldivtab dc.b 16,14,0
        ds.w 0

* +++

Xtrap0  dc.w $4afc
        [jnx]

Xtrap0s trap    #0
        [jnx]

* use:create {name} docall/ docallw - execute a subroutine with return to next
docall  pea     ([nx])
        move.l  ([w])+,a1
        jmp     0([bp],a1.l)

docallw pea     ([nx])          push 'rts'-destination
        move.w  ([w])+,a1
        jmp     0([bp],a1.l)

TSTJNX ;* bot of [nx]/[sp] inclusive reg testing for the 2ndary job

voc setstr fth

Xlit    move.w  ([ip])+,-([sp])
* the next entries mustn't change any data-regs other than d5, nor a0, a3
next    move.w  ([ip])+,[w]  < [nx]
next1   add.l   [bp],[w]
        move.w  ([w])+,a1
        jmp     0([bp],a1.w)

Xdlit   move.l  ([ip])+,-([sp])
jnxcode [jnx]

Xperform move.w ([sp]),[w]      @
        move.w  0([bp],[w].w),([sp]) ;;-([sp])
Xcfaexec subq.w #2,([sp])       cfa
Xexecute move.w ([sp])+,[w]     exec
        bra.s   next1

Xpsemicq move.l aendcode-Z([bp]),-([sp])
        [jnx]

dojump  move.l  ([w])+,a1
        jmp     0([bp],a1.l)

* use: ..code.. bsr docontinue  dc.w nextwa-Z .. dc.w semis-Z
docontinue move.l (a7)+,[ip]    advance ip to parameterfield
        [jnx]

;;* use: ..code.. lea wordcfa(pc),[w] jsr ccolon ..code..
;Ccolon  pea     ([ip])
;        lea     c4thret(pc),[ip]
;        jmp     docolon(pc)

Cdefer  pea     ([ip])
        lea     c4thret(pc),[ip]
        jmp     dodefer(pc)

Xzdbra  tst.w   ([sp])
        beq.s   Xzbra   drop & branch if eq
        addq.l  #2,[ip] else try again
        [jnx]

Xnzbranch tst.w ([sp])+
        bne.s   Xbranch
        addq.l  #2,[ip]
        [jnx]

Xlebra  subq.w  #1,([sp])
Xmibra  tst.w   ([sp])+
        bmi.s   Xbranch
        addq.l  #2,[ip]
        [jnx]

Xszbra  move.w  ustate([bp],[up].l),-([sp])
Xzbra   tst.w   ([sp])+
        beq.s   Xbranch   ?
        addq.l  #2,[ip]
        [jnx]

Xploopq moveq   #1,d0
loopcmp add.w   ([rp])+,d0
        cmp.w   ([rp]),d0
        bge.s   loopex    ?
loopon  move.w  d0,-([rp])
Xbranch add.w   ([ip]),[ip]
        [jnx]

Xgtbra  subq.w  #1,([sp])
Xplbra  tst.w   ([sp])+
        bpl.s   Xbranch
        addq.l  #2,[ip]
        [jnx]

Xpplopq move.w  ([sp])+,d0
        bgt.s   loopcmp   ?
        add.w   ([rp])+,d0  (also terminates 0 +loop)
        cmp.w   ([rp]),d0
        bgt.s   loopon    ?
loopex  addq.l  #2,[ip]
Xrdrop  addq.l  #2,[rp]
        [jnx]

X2grr   move.l  ([sp]),-([sp])  copy and
X2gr    move.l  ([sp])+,-([rp]) push double
        [jnx]

Xqleave move.w  ([sp])+,d0 : -leave
        beq.s   nixleave
Xleave  move.w  ([rp]),d0 keep running index
        move.w  d0,2([rp])
nixleave [jnx]

Xone    move.w  #1,-([sp])
        [jnx]

* bitwise

docand  move.w  ([w]),-([sp])
Xand    move.w  ([sp])+,d0
        and.w   d0,([sp])
        [jnx]

Xtwoand move.l  ([sp])+,d0
        and.l   d0,([sp])
        [jnx]

Xeven   and.w   #-2,([sp])
        [jnx]

Xorx    move.w  ([sp])+,d0
        or.w    d0,([sp])
        [jnx]

Xxor    move.w  ([sp])+,d0
        eor.w   d0,([sp])
        [jnx]

*** arithmetik

qerr    dc.w    *+2-Z
jqerr   tst.l   qf.error-Z([bp])
        bra.s   neqset

Xzneq   clr.w   -([sp])
Xneq    cmp.w   ([sp])+,([sp])+
neqset  sne     d0
        bra.s   zlepush

Xfeq    movem.w ([sp])+,d0/d1/d2/d3
        cmp.w   d0,d3
        bne.s   feqset
        cmp.w   ([sp]),d1
        bne.s   feqset
        move.w  d2,([sp])
Xeq     cmp.w   ([sp])+,([sp])+
        bra.s   equset

;;Xqzeroeq tst.l  ([sp])+
;        bne.s   feqset  ?
;        bra.s   Xdzeroeq -

Xfzeq   tst.w   ([sp])+
        beq.s   feqset  ? fp zero exponent
Xdzeroeq tst.l  ([sp])
feqset  addq.l  #4,[sp]
        bra.s   equset

Xzeroeq tst.w   ([sp])+
equset  seq     d0
        bra.s   zlepush

Xdeq    cmp.l   ([sp])+,([sp])+
        bra.s   equset

;Xqeq    move.l  ([sp])+,d0
;        sub.l   ([sp])+,d0
;        add.l   ([sp])+,d0
;        sub.l   ([sp])+,d0
;        bra.s   equset

Xfzgt   addq.l  #2,[sp]
        tst.l   ([sp])+
        bra.s   gtset

Xfzl    addq.l  #2,[sp]
Xdzerol tst.l   ([sp])+
        bra.s   zleset

Xzeroless tst.w ([sp])+
zleset  smi     d0
zlepush neg.b   d0
        ext.w   d0
        move.w  d0,-([sp])
        [jnx]

Xzerogt neg.w   ([sp])+
        bra.s   zleset

Xtwouless cmp.l ([sp])+,([sp])+
        bra.s   uleset

Xuless  cmp.w   ([sp])+,([sp])+
uleset  scs     d0
        bra.s   zlepush

Xgreat  cmp.w   ([sp])+,([sp])+
gtset   sgt     d0
        bra.s   zlepush

Xcless  move.w  ([sp])+,d0
        move.w  ([sp])+,d1
        cmp.b   d0,d1
        bra.s   uleset

Xdless  cmp.l   ([sp])+,([sp])+
        bra.s   tstless
Xless   cmp.w   ([sp])+,([sp])+
tstless slt     d0
        bra.s   zlepush

X1abs   tst.b   ([sp])
        bpl.s   x1anxt
Xnot    not.w   ([sp])
x1anxt  [jnx]

Xabs    move.w  ([sp]),-([sp])
Xplusdash tst.w ([sp])+
        bpl.s   xpret   ?
Xminus  neg.w   ([sp])
xpret   [jnx]

Xplus   move.w  ([sp])+,d0
        add.w   d0,([sp])
        [jnx]

Xsysfl  move.l  procftab-Z([bp]),-([sp])
        [jnx]

Xfthid  move.l  mtinftab-Z([bp]),-([sp])
        [jnx]

* error (pseudo-)constants

Xfperr  move.w  #Z-Z,-([sp])
cfperr  equ     *-2
        clr.w   cfperr-Z([bp])
        [jnx]

vftherr equ *+2
Xftherr move.w  #0,-([sp])
        clr.w   vftherr-Z([bp])
        [jnx]

Xioerr  move.l #ioerr-ioerr,-([sp])
cioerr  equ     *-4
        addq.l  #2,[sp]   leave single length cons
        clr.w   2+cioerr-Z([bp])
        [jnx]

Xernum  move.l  qf.error-Z([bp]),-([sp])
        clr.l   qf.error-Z([bp])
        [jnx]

Xert    tst.w   vert-Z([bp])
        beq.s   Xtwodp  ?
        move.l  ([sp])+,d0
        jmp     rwtst(pc)

* stack

Xfourdp addq.l  #4,[sp] 4drop
Xtwodp  addq.l  #2,[sp] 2drop
Xdrop   addq.l  #2,[sp]  drop
        [jnx]

Xrot    move.l  ([sp])+,d0
        move.w  ([sp])+,[w]
        move.l  d0,-([sp])
        move.w  [w],-([sp])
        [jnx]

Xdashrot move.w ([sp])+,[w]
        move.l  ([sp])+,d0
        move.w  [w],-([sp])
Xlixl   move.l  d0,-([sp])      l<i
        [jnx]

Xcspsto move.L  ucsp-2([bp],[up].l),d0
        bra.s   csprpsh

Xspsto  move.L  us0-2([bp],[up].l),d0
csprpsh lea     0([bp],d0.L),[sp]
        [jnx]

Xtworf  move.l  ([rp]),-([sp])
        [jnx]

X2rg    move.l  ([rp])+,-([sp])
        [jnx]

Xgrr    move.w  ([sp]),-([rp])  >rr
        [jnx]

Xgreatr move.w  ([sp])+,-([rp]) >r
        [jnx]

Xrplus  addq.w  #2,([rp])       r+
        move.w  ([rp]),d1
        move.w  -2([bp],d1.w),-([sp])
        [jnx]

Xrg     move.w  ([rp])+,-([sp])
        [jnx]

Xrx     move.w  ([rp]),-([sp])
        [jnx]

Xj      move.w  4([rp]),-([sp]) ( 2nd index / 1st when in a case:-call )
        [jnx]

Xni     move.w  ([sp])+,d0
        lsl.w   #2,d0
je      move.w  0([rp],d0.w),d0
Xlix    move.w  d0,-([sp])
        [jnx]

Xdashd  move.w  ([sp]),d0
        bne.s   Xlix    ?
        [jnx]

X0drop  move.w  ([sp])+,d0      drop if zero
        bne.s   Xlix
        [jnx]

Xover   move.w  2([sp]),-([sp])
        [jnx]

Xsover  move.l  ([sp]),d0
        swap    d0
        move.l  d0,([sp])
        move.w  d0,-([sp])
        [jnx]

X4dup    move.l 4([sp]),-([sp])
Xtwoover move.l 4([sp]),-([sp])
        [jnx]

Xdup    move.w  ([sp]),-([sp])
        [jnx]

Xtwodup move.l  ([sp]),-([sp])
        [jnx]

X2sdrop move.l  ([sp])+,([sp])
        [jnx]

* ++

CTn     move.w  #-2,-([sp]) {0} do nothing
CT1     not.w   ([sp])      +ve no ctrl  -ve ctrl n.i.
        [jnx]

Xplusorg add.w  #origin-Z,([sp])
        [jnx]

Xdisplus move.l #sys-go+$8000,a1
        bra.s   bsplsnt

Xcodeplus lea   go(pc),a1
        bra.s   bsplsnt

Xbaseplus move.l [bp],a1
bsplsnt add.w   ([sp])+,a1
fthplnt move.l  a1,-([sp])
        [jnx]

Xtfp    move.l  ([sp])+,a1
        sub.l   [bp],a1
        bra.s   fthplnt

Xtbp    move.l  [bp],d0
        bra.s   tbpntr

Xd2mul  move.l  ([sp]),-([sp])
Xdplus  move.l  ([sp])+,d0
tbpntr  add.l   d0,([sp])
        [jnx]

Xddash  neg.l   ([sp])
        bra.s   Xdplus

Xqabs   move.w  ([sp]),-([sp])
Xqplusdash tst.w ([sp])+
        bpl.s   qmijnx
Xqminus neg.l   4([sp])
        negx.l  ([sp])
qmijnx  [jnx]

Xdplusdash tst.w ([sp])+
        bra.s   dminusq
Xdabs   tst.b   ([sp])
dminusq bpl.s   nodminus
Xdminus neg.l   ([sp])
nodminus [jnx]

dotog   move.w  ([w]),-([sp])
Xtoggle move.w  ([sp])+,d0
        move.w  ([sp])+,[w]
        eor.b   d0,0([bp],[w].w)
        [jnx]

msbtog  dc.w    dotog-Z,$80
immtog  dc.w    dotog-Z,$40
smutog  dc.w    dotog-Z,$20

Xdexit  tst.w  ([sp])+
        beq.s   qsmjnx  ?
dosemis move.w  ([rp])+,[ip]
        add.l   [bp],[ip]
qsmjnx  [jnx]

Xcarb   move.w  #%11000000,ustate([bp],[up].l)
        [jnx]

Xrivec  move.w  ([sp])+,d0
        bge.s   riXd0
        movem.w ([sp])+,a0/a2
        bra.s   riXd0
dorix   move.w  ([w])+,d0
riXd0   jmp     XriXd0(pc)

X8plus  addq.w  #2,([sp])
X6plus  addq.w  #2,([sp])
X4plus  addq.w  #2,([sp])
X2plus  addq.w  #2,([sp])
        [jnx]
X7plus  addq.w  #2,([sp])
Xfivepl addq.w  #2,([sp])
X3plus  addq.w  #2,([sp])
X1plus  addq.w  #1,([sp])
        [jnx]
X7dash  subq.w  #2,([sp])
X5dash  subq.w  #2,([sp])
X3dash  subq.w  #2,([sp])
X1dash  subq.w  #1,([sp])
        [jnx]
X8dash  subq.w  #2,([sp])
X6dash  subq.w  #2,([sp])
X4dash  subq.w  #2,([sp])
X2dash  subq.w  #2,([sp])
        [jnx]

* fast mult. 2's-, 1's-complement or sg'd magnitude
X3mul   move.w  ([sp]),d0
        pea     sixment(pc)
        bra.s   Xtwomul

X16mul  pea     Xfourmul-Z([bp])
Xfourmul pea    Xtwomul-Z([bp])
Xtwomul asl.w   ([sp])
tstmul  bvc.s   tml_nvs
        bchg    #7,([sp])
tml_nvs rts

Xfourby asr.w   ([sp])
Xtwoby  asr.w   ([sp])
        rts

X6mul   pea     sixment(pc)
        bra.s   X5mul

X10mul  pea     Xtwomul-Z([bp])
X5mul   move.w  ([sp]),d0
        bsr.s   Xfourmul
sixment add.w   d0,([sp])
        bra.s   tstmul

Xbasef  move.w  ubase([bp],[up].l),-([sp])
        [jnx]

Xbases  move.w  ([sp])+,ubase([bp],[up].l) reset base
        [jnx]

Xdplf   move.w  udpl([bp],[up].l),-([sp])
        [jnx]

Xzinsto clr.w   uin([bp],[up].l)
        [jnx]

Xstatef move.w  ustate([bp],[up].l),-([sp])
        [jnx]

Xtibf   move.w  utib([bp],[up].l),-([sp])
        [jnx]

Xoverd  move.w  2([sp]),-([sp])
Xdash   move.w  ([sp])+,d0
        sub.w   d0,([sp])
        [jnx]

outcpu  move.w  d0,([sp])
        lea     dodotcpu-Z([bp]),[w]
        jmp     docolon-Z([bp])

voc setstr fth * +++ defining words

Xspfetch move.l [sp],[w]
         bra.s  dovariable

Xrpfetch move.w [rp],[w]
         bra.s  dovariable

Xpwquoteq move.l [ip],[w]
        moveq   #1,d0
        and.w   ([ip]),d0
        add.w   ([ip])+,d0
        add.w   d0,[ip]
dotwovariable
dovariable sub.l [bp],[w]
        move.w  [w],-([sp])
        [jnx]

;;dowith  move.w  ([ip])+,[w]   ;;
docolon sub.l   [bp],[ip]       (nest)
        move.w  [ip],-([rp])
        move.l  [w],[ip]
        [jnx]


; dc.b 7!128,'(does>',p,0,0
dodoesgreat sub.l [bp],[ip]
        move.w  [ip],-([rp])
        move.w  ([w])+,[ip]     cfa pt's to does>-part
        add.l   [bp],[ip]
        sub.l   [bp],[w]        push
        move.w  [w],-([sp])         pfa
dfdoff  [jnx]

; dc.b 6!128,6!128,'(cons',p,0,0
doconstant
        move.w  ([w])+,-([sp])
        [jnx]

; dc.b 6!128,6!128,'(user',p,0,0
douser  move.w  ([w])+,-([sp])
        add.w   [up],([sp])
        [jnx]

; dc.b 7!128,'(2cons',p,0,0
dotwoconstant
        move.l ([w])+,-([sp])
        [jnx]

; dc.b 7!128,'(defer',p,0,0
dodefer moveq   #0,d0
        move.l  [w],a1
trydfer move.w  (a1)+,d0        cfa
        move.w  d0,[w]
        lsr.w   #1,d0           odd
        bcs.s   dfdoff          ? don't exec
        cmp.w   #$4000,d0
        beq.s   trydnxt         ? empty exvec
        cmp.L   udp-2([bp],[up].l),[w]
        blt     next1           ? executeable
trydnxt not.l   d0
        bpl.s   nodferd         ? no 3rd chance
        move.w  (a1),-(a1)      restore default action
        bra.s   trydfer         try 2nd

istobody dc.w dojump-Z
 dc.l Xistobody-Z
        dc.b 4!128,4!128,'(is',p,0,0
bisq    dc.w dojump-Z
 dc.l Xbisq-Z

* cfa table for {is} & {default-is} and table of {is}-actions
istab   dc.w dferdfd-*,dodefer-Z
        dc.w consdfd-*,doconstant-Z
        dc.w consdfd-*,dovariable-Z
dftnd   dc.w twoconsdfd-*,dotwoconstant-Z
        dc.w fconsdfd-*,dofcons-Z
        dc.w twoconsdfd-*,dotwovariable-Z
        dc.w userdfd-*,douser-Z
        dc.w ddgdfd-*,docases-Z
        dc.w rgasdf-*,doassoc-Z
        dc.l 0

nodferd moveq   #26,d0
        jmp     goXqerr(pc)

rgasdf  moveq   #4,d0           disp to top index & flag
        neg.w   d0
        bra.s   selcse          -
ddgdfd  moveq   #-6,d0
selcse  add.w   (a0)+,d0        top index ptr & flag
        move.w  ([sp])+,d1      index
        bmi.s   nodferd         ? < 0
        add.w   d1,d1
        cmp.w   d1,d0
        bmi.s   nodferd         ? index > max
        tst.l   d0
        bpl.s   consdfd         range: or associative:
        tst.w   (a0)+           flag
        beq.s   consdfd         ? no cfa-cases
dferdfd subq.w  #2,d3           cfa
consdfd move.w  d3,0(a0,d1.w)   !
        [jnx]

userdfd lea     0([bp],[up].l),a1
        add.w   (a0),a1
        move.w  d3,(a1)
        [jnx]

twoconsdfd move.w d3,(a0)+
        move.w  ([sp])+,(a0)
        [jnx]

fconsdfd move.w d3,(a0)+
        move.l  ([sp])+,(a0)
        [jnx]

dfderr  dc.w nodferd-Z

bdeftb  dc.w *+2-Z
        lea     2([bp]),a1
        add.w   ([sp])+,a1
        move.w  (a1),-(a1)
        [jnx]

dftcfa  dc.w dojump-Z
 dc.l Xdftcfa-Z

Xhex    move.w  #16,ubase([bp],[up].l)
        [jnx]

Xdecimal move.w #10,ubase([bp],[up].l)
        [jnx]

basecpu dc.w dojump-Z
 dc.l Xbasecpu-Z

Xsdgd   move.w  ([sp])+,[w]
        move.l  [w],-([sp])
        [jnx]

Xcdgs   tst.b   1([sp])
        smi     ([sp])
        [jnx]

* mul & div:

Xumul   move.w  ([sp])+,d0
        mulu    ([sp])+,d0
        move.l  d0,-([sp])
        [jnx]

Xmmul   move.w  ([sp])+,d0   <mulbymod>
        muls    ([sp])+,d0
        move.l  d0,-([sp])
        [jnx]

Xmul    move.w  ([sp])+,d1
        mulu    ([sp])+,d1
Xcasix  move.w  d1,-([sp])   <index
        [jnx]

*++++

Xuqmbymod move.l ([sp])+,-([rp])
        bsr     cudmmul >
        move.l  ([rp])+,-([sp])
        jmp     Xudmbym(pc)

Xmplus  move.w  ([sp])+,a0
        add.l   ([sp])+,a0
        move.l  a0,-([sp])
        [jnx]

Xumbym  move.w  ([sp])+,d1
        beq.s   ubynul   ?  div null
        move.l  ([sp]),d0
        divu    d1,d0
ubyndn  swap    d0
ubyputqt move.l d0,([sp])
        [jnx]

* usnigned ovf rmd & qot
ubynul  moveq   #-1,d0
        move.l  ([sp]),d1
        bne.s   ubyputqt  ? set ovf both r & q to unsigned max
        moveq   #1,d0     on 0/0 leave r=0 q=1
        bra.s   ubyndn

* signed ovf rmd & qot
mbynul  bsr     bynulov   * rmd 0 or +/-7fff qot 1. or +/-7fff.ffff
        move.w  ([sp])+,d0 drop qot.hi
        beq.s   mbynulret  ? r=0 q=1
        move.w  d1,([sp])  set qot to ovf
mbynulret rts

Xmulbym pea     ([nx])
        move.w  ([sp])+,d1
        beq.s   mbynul
        move.w  ([sp])+,d0
        muls    ([sp])+,d0
        bra.s   mulbyn

Xmby    pea     ([nx])
        move.w  ([sp])+,d1
bymodent beq.s  mbynul          <bymod
        move.l  ([sp])+,d0
mulbyn  divs    d1,d0
umbyext swap    d0
        move.l  d0,-([sp])
        rts

Xbymod  pea     ([nx])
bymodcal movem.w ([sp])+,d1/d2  <mod   sign extend dvs
        move.l  d2,-([sp])
        tst.w   d1              test for div nul
        bra.s   bymodent

Xby     bsr.s   bymodcal
Xsdrop  move.w  ([sp])+,([sp])
        [jnx]

Xmod    bsr.s   bymodcal
modrop  addq.l  #2,[sp]
        [jnx]

Xumod   pea     Xumbym-Z([bp])
        moveq   #0,d0
        move.w  ([sp])+,d0
        bra.s   umbyext

Xclosto move.w  ufence([bp],[up].l),-([sp])
Xsavsto jmp     CXsavsto(pc)

Xtical  move.l  tical-Z([bp]),-([sp])
        [jnx]

X1off   subq.w  #1,([sp])
        moveq   #0,d0
;;        bra.s   v1off
;;Xvecoff moveq   #-2,d0
v1off   moveq   #0,d1
        bra.s   Xveco
X1on    subq.w  #1,([sp])
;;Xvecon
        moveq   #1,d1
        moveq   #-1,d0
Xveco   move.w  ([sp])+,d2
        lea     1([bp],d2.w),a1
        bra.s   Xvecs

Xupdate moveq   #-1,d0
        moveq   #-128,d1
        bra.s   prevfetch

Xupdoff moveq   #127,d0
        moveq   #0,d1
prevfetch lea   vprev-Z([bp]),a1
        move.w  (a1)+,d2
        tst.w   (a1)
        beq.s   noupdt
        lea     0([bp],d2.w),a1
        lsr.w   #1,d2
        bls.s   noupdt
Xvecs   and.b   d0,(a1)
        or.b    d1,(a1)
noupdt  [jnx]

Xdrzero clr.w   uoffset([bp],[up].l)
        [jnx]

Xdrone  move.w  #$4000,uoffset([bp],[up].l)
        [jnx]

Xblkft  move.w  ublk([bp],[up].l),-([sp])
        [jnx]
Xfencef move.w  ufence([bp],[up].l),-([sp])
        [jnx]
Xlastf  move.w  ulast([bp],[up].l),-([sp])
        [jnx]
Xcurrentf move.w ucurrent([bp],[up].l),-([sp])
        [jnx]

dofcons move.l  ([w])+,d0
        move.w  ([w])+,-([sp])
        move.l  d0,-([sp])
        bra.s   fhibyt

dofscons clr.w  -([sp])
        move.l  ([w])+,-([sp])
        bra.s   dpld2

Xf2div  subq.w  #1,([sp])
        bra.s   fhibyt

Xf2mul  addq.w  #1,([sp])
fhibyt  and.b   #15,([sp])
dpld2   move.w  #-2,udpl([bp],[up].l)
        [jnx]

TSTJTOP ;* adressen-obergrenze fr berwachungsjob

voc setstr fth

root create {root} dodoesgreat
        dc.w    dovoc-Z,vocnfa,roottop-Z
[prevlab]v dc.w [lastvoc]-Z,$8000,0
lastvoc setstr  [prevlab]v
rootlink setstr [lastvoc]-4
previmm setnum $140-[previmm]

locvoc create {local} dodoesgreat V: root
        dc.w    dovoc-Z,vocnfa,locvtop-Z
[prevlab]v dc.w [lastvoc]-Z,$8000,0
lastvoc setstr  [prevlab]v
locvlink setstr [lastvoc]-4
previmm setnum $140-[previmm]

noop create {noop} jnxcode

forth create {forth} dodoesgreat V: root
        dc.w dovoc-Z  pfa   0: <=  tick..
        dc.w vocnfa   voc   2: 1st nfa $81A0
        dc.w fthtop-Z (current)cfa   (context)
[prevlab]v dc.w [lastvoc]-Z 6: (voc-link)adr  (voc-link)
        dc.w $8000    ptr to pfa of next voc in search order
        dc.w 0        find flag (: 0: locked, 1: end, forth is excluded)
lastvoc setstr [prevlab]v
previmm setnum $140-[previmm]

hidden create {hidden} dodoesgreat
        dc.w    dovoc-Z,vocnfa,hidntop-Z
[prevlab]v dc.w [lastvoc]-Z,forth+2-Z,0
lastvoc setstr  [prevlab]v
hidnlink setstr [lastvoc]-4
previmm setnum $140-[previmm]

qdos create {qdos} dodoesgreat
        dc.w    dovoc-Z,vocnfa,qdostop-Z
[prevlab]v dc.w [lastvoc]-Z,pif+2-Z,0
lastvoc setstr  [prevlab]v
qdoslink setstr [lastvoc]-4
previmm setnum $140-[previmm]

fp create {fp} dodoesgreat
        dc.w    dovoc-Z,vocnfa,fptop-Z
[prevlab]v dc.w [lastvoc]-Z,qdos+2-Z,0
lastvoc setstr  [prevlab]v
fplink  setstr  [lastvoc]-4
previmm setnum $140-[previmm]

editor create {editor} dodoesgreat
        dc.w dovoc-Z,vocnfa,editop-Z
[prevlab]v dc.w [lastvoc]-Z,forth+2-Z,0
lastvoc setstr  [prevlab]v
edilink setstr  [lastvoc]-4
previmm setnum $140-[previmm]

pif create {pif} dodoesgreat V: qdos
        dc.w dovoc-Z,vocnfa,piftop-Z
[prevlab]v dc.w [lastvoc]-Z,forth+2-Z,0
lastvoc setstr  [prevlab]v
piflink setstr  [lastvoc]-4
previmm setnum $140-[previmm]

minerva create {minerva} dodoesgreat V: fth :=> fp qdos pif forth
        dc.w dovoc-Z,vocnfa,mitop-Z
[prevlab]v dc.w [lastvoc]-Z,fp+2-Z,0
lastvoc setstr  [prevlab]v
milink setstr   [lastvoc]-4
previmm setnum $140-[previmm]

asm68 create {asm68} dodoesgreat V: root :=>
        dc.w dovoc-Z,vocnfa,asmtop-Z
[prevlab]v dc.w [lastvoc]-Z,forth+2-Z,0
lastvoc setstr  [prevlab]v
asmlink setstr  [lastvoc]-4
previmm setnum $140-[previmm]

seal    create {seal} docolon V: hidn
 dc.w currentf-Z,literal-Z,dcompile-Z,psealp-Z,semis-Z
previmm setnum $140-[previmm]

* +++ common headerless

flushdat dc.w dojump-Z
 dc.l Cflushdat-Z

* for w-save collect window data and store into head area
savwdw  dc.w dojump-Z           ( d.cdt pifdisp --)
 dc.l Csavwdw-Z

emptys dc.w dojump-Z store system data after empty
 dc.l Xemptys-Z

cfacomma dc.w dojump-Z
 dc.l Xcfacomma-Z
zerocomma dc.w dojump-Z
 dc.l Xzerocomma-Z
dcomma dc.w dojump-Z
 dc.l Xdcomma-Z

psealp dc.w dojump-Z
 dc.l Xpsealp-Z

savsto dc.w Xsavsto-Z ( -- d.timecount tiptr d.baseptr d.flen savptr)
closto dc.w Xclosto-Z ( -- fence d.timecount tiptr d.baseptr d.flen savptr)

* +++

voc setstr fth * -- qdos-io -- * forth words refer to the "work" channel *

io create {i/o} *+2  current i/o-channel re by <mkchp>
        move.b  iochn-Z([bp]),-([sp])
        sf      -([sp])
        [jnx]

screen create {screen} *+2
        move.b  dr0ch-Z([bp]),-([sp])
        sf      -([sp])
        [jnx]

fyle create {file} *+2
        move.b  dr1ch-Z([bp]),-([sp])
        sf      -([sp])
        [jnx]

incons create {in-cons} *+2
        move.b  stdio-Z([bp]),-([sp])
        sf      -([sp])
        [jnx]

outcons create {out-cons} *+2
        move.b  stdout-Z([bp]),-([sp])
        sf      -([sp])
        [jnx]

work create {work} *+2 (-- currchan)
        pea     ([nx])
cdftcal move.b  usriow-Z([bp]),-([sp])
        sf      -([sp])
        rts

prt create {prt} *+2
        move.b  usriup-Z([bp]),-([sp])
        sf      -([sp])
        [jnx]

isprt create {is-prt} *+2 V: hidn
        lea     usriup-Z([bp]),a0
        bra.s   chkchn

iscreen dc.w *+2-Z
        lea     dr0ch-Z([bp]),a0
chkchn  jmp     Cchkchn(pc)

safesto create {safe!} dojump
 dc.l Xsafesto-Z

empty create {empty} docolon
CO01    dc.w lastf-Z,dup-Z
        dc.w pfa-Z,wforget-Z,fencef-Z
        dc.w great-Z,nzbranch-Z
        dc.w CO01-*,emptys-Z,semis-Z

doforget create {doforget} dodefer V: hidn forget pre-processing
        dc.w noop-Z,noop-Z      (vnfa wnfa -- vnfa wnfa)

wforget create {w-forget} docolon  ( pfa -- )
FG03    dc.w dup-Z,nfa-Z
        dc.w fencef-Z
        dc.w great-Z,nzbranch-Z
        dc.w FG02-*,drop-Z
FG01    dc.w semis-Z

pdforgetq dc.w docolon-Z        ( forget per $-ptr in the context-voc. only
        dc.w also-Z,also-Z,context-Z,twoplus-Z,off-Z
        dc.w wfindq-Z
        dc.w previous-Z,previous-Z
        dc.w zerobranch-Z
        dc.w FG01-*,drop-Z,branch-Z
        dc.w FG03-*

dashforget create {-forget} docolon ( compileable forget, if not found do nothing )
        dc.w qname-Z,dcompile-Z,pdforgetq-Z,semis-Z
previmm setnum $140-[previmm]

* ' nfa dup fence @ < $15 ?error cache >r cache-off drop >r voc-link @
* BEGIN r over < WHILE [compile] forth definitions @ dup voc-link ! REPEAT
* BEGIN dup 4- BEGIN pfa lfa @ dup r < UNTIL over 2- ! @ -dup 0= UNTIL
* r> dp ! r> IF cache-on drop ENDIF
forget create {forget} docolon
        dc.w tick-Z
FG02    dc.w nfa-Z,dup-Z
        dc.w fencef-Z,less-Z
        dc.w lit-Z,$15,questerror-Z
        dc.w cache-Z,cacheoff-Z,drop-Z,greatr-Z ;q;
        dc.w greatr-Z,vocdashlink-Z,fetcha-Z
        dc.w rx-Z,doforget-Z,drop-Z     <= (vocnfa wordnfa -- v w )extra action
M39     dc.w rx-Z,over-Z,less-Z            
        dc.w zerobranch-Z                  
        dc.w M40-*,forth-Z,definitions-Z
        dc.w fetch-Z,dup-Z,vocdashlink-Z
        dc.w storea-Z,branch-Z
        dc.w M39-*
M40     dc.w lit-Z,$8000,last-Z,storea-Z
* find new last & here and voc. top-nfa
M41     dc.w dup-Z,fourdash-Z      voc-nfa
M42     dc.w pfa-Z,lfa-Z,fetch-Z   nfa lfa @ => preceeding voc
        dc.w dup-Z,rx-Z,less-Z     dup r <
        dc.w zerobranch-Z          while
        dc.w M42-*
        dc.w dup-Z,lastf-Z,max-Z,last-Z,storea-Z
        dc.w over-Z,twodash-Z,store-Z
        dc.w fetch-Z,dashdup-Z,nzbranch-Z
        dc.w M41-*
        dc.w rgreat-Z,even-Z,dp-Z,storea-Z  even dp
        dc.w rgreat-Z,dcache-Z,drop-Z
        dc.w semis-Z

branch  create  {branch}  Xbranch V: hidn

greatresolve create {>resolve} docolon   ;resolve forward
        dc.w    here-Z,overdash-Z,swapx-Z,store-Z,semis-Z

back    create {back} docolon V: hidn    ;resolve backward
        dc.w    here-Z,dash-Z,comma-Z,semis-Z

emitm   create {emit-m} dojump
 dc.l Xemitm-Z ( n1 c2 -- ) n1 times emit char c2

enumfil create {.(r)} dojump ( n1 n2 -- n1) emit n2-n1 chars of (r)
 dc.l Xnumfil-Z

spaces  create  {spaces}  dojump
 dc.l Xspaces-Z

lesssharp create  {<#} dojump
 dc.l Clsharp-Z

sharpgreat create {#>} dojump
 dc.l Csharpgt-Z

sign    create  {sign} dojump
 dc.l Xsign-Z

sharp   create  {#} dojump
 dc.l Xsharp-Z

sharps  create  {#s} dojump
 dc.l Xsharps-Z

bddot create {(d#)} dojump
 dc.l Xbddot-Z ( dn1 signed.flag -- adr count )

bddotr dc.w docolon-Z ;{(d.r)} * ( dn1 n2.chars n3.sg.flg --- adr cnt )
  dc.w swapx-Z,greatr-Z,bddot-Z
  dc.w rgreat-Z
  dc.w enumfil-Z
  dc.w type-Z,semis-Z

ddotr   create  {d.r}   docolon
        dc.w over-Z,bddotr-Z,semis-Z

uddotr  create  {ud.r}  docolon
        dc.w zero-Z,bddotr-Z,semis-Z

ddot    create  {d.}    docolon
        dc.w zero-Z,ddotr-Z,space-Z,semis-Z

uddot   create  {ud.}   docolon
        dc.w zero-Z,uddotr-Z,space-Z,semis-Z

dotr    create  {.r}    docolon
        dc.w greatr-Z,sdashgreatd-Z,rgreat-Z,ddotr-Z,semis-Z

decdot  create  {#.}    dodoesgreat
        dc.w basedot-Z,10

hexdot  create  {$.}    dodoesgreat
        dc.w basedot-Z,16
dhexdot create  {d$.}   docolon
        dc.w basefetch-Z,hex-Z,dashrot-Z
        dc.w uddot-Z,basestore-Z,semis-Z

octdot  create  {&.}    dodoesgreat
        dc.w basedot-Z,8

bindot  create  {%.}    dodoesgreat
        dc.w basedot-Z,2

basedot dc.w fetch-Z,basefetch-Z,swapx-Z,basestore-Z
        dc.w swapx-Z,udot-Z,basestore-Z,semis-Z

dot create {.} docolon
        dc.w sdashgreatd-Z,ddot-Z,semis-Z

udot create {u.} docolon
        dc.w zero-Z,uddot-Z,semis-Z

quest create {?} docolon
        dc.w fetch-Z,dot-Z,semis-Z

qbase dc.w docolon-Z
        dc.w basefetch-Z,dup-Z,decimal-Z,dot-Z,basestore-Z,semis-Z

* list context-voc, <esc> leave, any other key to halt/restart display
vlist create {vlist} docolon V: root
        dc.w context-Z,fetcha-Z,greatr-Z
        dc.w incons-Z,chid-Z
        dc.w outcons-Z,incons-Z,tochan-Z,cbyl-Z
        dc.w incons-Z,dup-Z,towork-Z,dashwindow-Z,zerobranch-Z
        dc.w M52z-*,drop-Z,chenq-Z
        dc.w twoswap-Z,twodrop-Z,sdrop-Z,dashdup-Z,nzbranch-Z
        dc.w M52z-*,lit-Z,130
M52z    dc.w twodash-Z
        dc.w rgreat-Z
        dc.w zdupbranch-Z
        dc.w M53x-*,fetch-Z,branch-Z
        dc.w M52x-*
M52y    dc.w twodup-Z,cfetch-Z,onefand-Z
        dc.w out-Z,fetcha-Z,plus-Z,less-Z,zerobranch-Z
        dc.w M53-*
M52x    dc.w cr-Z
M53     dc.w dup-Z,iddot-Z,pfa-Z,lfa-Z
        dc.w fetch-Z,dup-Z,oneplus-Z,cfetch-Z
        dc.w lit-Z,$0a0,eq-Z,questesc-Z
        dc.w nzbranch-Z
        dc.w M53z-*
        dc.w onedash-Z,andx-Z,dashdup-Z,nzbranch-Z
        dc.w M52y-*,twodup-Z
M53z    dc.w twodrop-Z
M53x    dc.w drop-Z,curdis-Z,incons-Z,setchan-Z
        dc.w semis-Z

itimecal jsr Ctimecal(pc)
         pea    ([ip])
aendcode jsr docontinue-Z([bp])
        dc.w mibranch-Z
        dc.w TI01-*,uqmbymod-Z,twoswap-Z,twodrop-Z
TI01    dc.w cflong-Z,flit-Z,$0811,$61A8,0000
        dc.w ridiv-Z,fdot-Z,pdotquoteq-Z
        string.b {mcs  }
c4thret dc.w *-Z+2
        dc.w *-Z+2
        move.l  (a7)+,[ip]
        rts

ticknul create  {ti-cal} Xtical

timecal create  {set-cal} dojump
 dc.l Cxtical-Z

time    create  {tick} dotwoconstant
timem   dc.l    0       counter (dummy data for timer setup)
tical   dc.l    0       caliber
timelink dc.l   0,0     qdos link & ptr to <timer>
timadr equ *+2          ptr from routine in heap to timem
timer   addq.l  #1,$0800000
        rts
timemend

tregs create {t-regs} doconstant V: hidn
        dc.w tvtregs-go

open    create  {open}   dojump
 dc.l Xopen-Z (name type chan -- ernum)
openlk  create  {open-link} dojump (name link.id chan -- ernum)
 dc.l Clopen-Z
close   create  {close}  dojump
 dc.l Xclose-Z  (chan --)
ert     create  {ert}    Xert    (d.ernum --}
perq    create  {(ert)}  doconstant
        dc.w vert-Z

        dc.b 5!128,'(stk',')'!128
        dc.w 0
prstakq dc.w dojump-Z
 dc.l Xrstak-Z
pxstakq dc.w dojump-Z
 dc.l Xxstak-Z
;*;stackcolon create {stack:} docolon
;        dc.w create-Z,smudge-Z,lit-Z,jwstakq-Z
;        dc.w here-Z,twodash-Z,storea-Z,branch-Z
;        dc.w S02-*
jwstakq jmp Xwstak(pc)
stack   create {stack} docolon
        dc.w statefetch-Z
        dc.w zerobranch-Z
        dc.w S01-*
        dc.w compile-Z,prstakq-Z
S02     dc.w bl-Z,word-Z
        dc.w here-Z,cfetch-Z,twoplus-Z
        dc.w even-Z,allot-Z,semis-Z
S01     dc.w bl-Z,word-Z
        dc.w pxstakq-Z,semis-Z
previmm setnum $140-[previmm]

pwquoteq create {(")} Xpwquoteq V: hidn (-- addr)

wchar create {text} docolon     (c1 -- ptr) text until char c1 to pad/codebody
M56     dc.w statezbra-Z
        dc.w M55-*,zero-Z,compile-Z
        dc.w pwquoteq-Z,ccomma-Z,wordh-Z
        dc.w cfetch-Z,oneplus-Z
        dc.w one-Z,orx-Z,allot-Z,semis-Z
M55     dc.w qtext-Z,pad-Z,semis-Z
previmm setnum $140-[previmm]

wquote create {"} docolon * w"
        dc.w asciiquote-Z,branch-Z
        dc.w M56-*
previmm setnum $140-[previmm]

qname create {name} docolon     (-- ptr) word counted string to pad until <bl>
        dc.w bl-Z,branch-Z      (compiles: ... name {name} ...;
        dc.w M56-*              (executes: ... ptr ...
previmm setnum $140-[previmm]

qtext create {\name} docolon    (c1 --) word-counted string until char c1
        dc.w pad-Z,off-Z
        dc.w wordh-Z,pad-Z
        dc.w oneplus-Z,over-Z,cfetch-Z
        dc.w oneplus-Z,cmove-Z,semis-Z

wtxt create {w@} docolon        (c1 --) expect word counted text to pad until <nl> or <c1>
        dc.w one-Z,branch-Z
        dc.w TX0-*

txt create {s@} docolon (c1 --) expect byte counted text to pad until <nl> or <c1>
        dc.w zero-Z
TX0     dc.w pad-Z,dup-Z,off-Z
        dc.w plus-Z,oneplus-Z
        dc.w twodup-Z,dup-Z,dashrot-Z
        dc.w lit-Z,.lumpplus,expect-Z
        dc.w enclose-Z,drop-Z,overdash-Z
        dc.w rot-Z,twodup-Z,onedash-Z
        dc.w cstore-Z,rot-Z,over-Z,plus-Z
        dc.w swapx-Z,rot-Z,greatrr-Z,cmove-Z
        dc.w rgreat-Z,plus-Z,cstore-Z,semis-Z

num create {s#} docolon (-- nn) kbd/blk input a number from text until <nl> or <bl>
        dc.w bl-Z,txt-Z
        dc.w pad-Z,cfetch-Z,zerobranch-Z
        dc.w NU01-*,pad-Z,bnumberb-Z,zerobranch-Z
        dc.w NU02-*
NU01    dc.w dzero-Z
NU02    dc.w drop-Z,semis-Z

U03     dc.w docolon-Z,bl-Z,wtxt-Z      {using} runtime
        dc.w pad-Z,branch-Z
        dc.w U02-*
using create {using} docolon    (--) use: using {name} to open {name} as screenfile
        dc.w statezbra-Z
        dc.w U01-*,compile-Z,U03-Z,semis-Z
U01     dc.w qname-Z            (ptr --) {using} runtime executive
U02     dc.w dup-Z,scrname-Z            dup (screen)
        dc.w over-Z,dup-Z,twoplus-Z     over dup 2+
        dc.w cfetch-Z,nzbranch-Z        c@ 0= IF
        dc.w U04-*,drop-Z,greatr-Z,twodrop-Z  >r 2drop   (fetch default)
        dc.w rx-Z,rx-Z,rx-Z,rgreat-Z    r r r r> ENDIF
U04     dc.w fetch-Z,twoplus-Z          @ 2+
        dc.w lit-Z,40,min-Z             40 min
        dc.w cmove-Z,zero-Z             cmove 0 work
        dc.w work-Z,open-Z,zeroless-Z   open 0<
        dc.w nzbranch-Z                 IF error ELSE
        dc.w doerr-*,drop-Z,screen-Z    drop work
        dc.w ischan-Z,lspsto-Z,semis-Z  is-screen ENDIF
previmm setnum $140-[previmm]

qwsav   dc.w docolon-Z,incons-Z,dashwindow-Z,zerobranch-Z
        dc.w WV03-*,incons-Z,isochan-Z,zerobranch-Z
        dc.w WV03-*,incons-Z,cdt-Z,onedash-Z,dup-Z,mibranch-Z
        dc.w WV02-*,fdup-Z,savwdw-Z
WV02    dc.w fdrop-Z
WV03    dc.w semis-Z

wsave create {w-save} docolon   save with current in-cons window sizes
        dc.w one-Z,branch-Z
        dc.w SV01-*
* fop-over ert file is-chan tical dup dup 2@ 2swap 0. rot 2!
* 0 code+ savehead dup 2+ here disp+ 2dup swap ! dup minus
* $408 - rot 6 + ! swap heads 2drop 0 fssave file close 2! ernum ?message
savequote create {save} docolon
        dc.w zero-Z
SV01    dc.w fopoverq-Z,questqerr-Z,bsavb-Z,semis-Z

bsavb dc.w docolon-Z
        dc.w zerobranch-Z
        dc.w SV02-*,qwsav-Z
SV02    dc.w lastf-Z,pfa-Z,lfa-Z
        dc.w fence-Z,fencef-Z,greatr-Z,store-Z
        dc.w fyle-Z,ischan-Z,savsto-Z,heads-Z
        dc.w sdrop-Z,greatrr-Z,nzbranch-Z
        dc.w SV03-*,fssave-Z
        dc.w ernum-Z,drop-Z,rdrop-Z,greatr-Z
SV03    dc.w fyle-Z,close-Z,twostore-Z
        dc.w rgreat-Z,zerobranch-Z
        dc.w SV04-*,pad-Z,fdel-Z
SV04    dc.w rgreat-Z,fence-Z,storea-Z
        dc.w semis-Z

* >r 0 DO 4dup j cmove-l j m+ 2swap j m+ 2swap LOOP rdrop
* ( d.srce d.dest +count +len -- d.srce+ d.dest+ )
movmem create {move-mem} dojump
 dc.l Xmovmem-Z

* called immediately after moving code & data to the new job.
* must preserve the job-id. the jdt comes with {a2l@}
clonejdt create {clone-jdt} dodefer V: hidn ( d.jobid -- d.jobid )
        dc.w noop-Z,noop-Z

* afterwards the job-id and cdt-address may be read by {d1l@} and {a2l@}
clone4th create {clone-4th} docolon
        dc.w qwsav-Z            store   current window data
        dc.w closto-Z           fetch   fence d.timecount tiptr d.baseptr d.flen savptr
        dc.w zero-Z                     ...ex/ew
        dc.w bexecb-Z,twodrop-Z multitasking start the job, drop job-id
        dc.w twostore-Z        restore timecount
        dc.w fence-Z,storea-Z  restore current fenceptr
        dc.w semis-Z

bexecb create {(exec)} docolon V: hidn  ( d.base d.flen headptr ex/ew -- d.id )
        dc.w swapx-Z
        dc.w sixplus-Z,greatr-Z         keep header=savptr + 6
        dc.w lit-Z,-4,roll-Z            ( ex/ew dbase dflen
        dc.w dzero-Z,twoover-Z          (             0. dflen
        dc.w rgreat-Z,twofetch-Z        (             0. dflen ddata
        dc.w twoswap-Z                  (             0. ddata dflen
        dc.w fthid-Z                    ( ex/ew dbase 0. d.data d.code d.id
        dc.w cjob-Z                     (           run data code owner -- new.id
        dc.w ernum-Z,questqerr-Z
        dc.w twogreatr-Z                ( ex/ew dbase        ( keep job-id
        dc.w a2ql-Z,twoswap-Z           ( ex/ew dbase djbase ( fetch jdt-ptr
        dc.w lit-Z,16384,mby-Z          move code to the jobs codespace
        dc.w greatr-Z,zdupbranch-Z
        dc.w CJ01-*,zero-Z,swapx-Z,movmem-Z
CJ01    dc.w rgreat-Z,zdupbranch-Z
        dc.w CJ02-*,lit-Z,16384,movmem-Z
CJ02    dc.w fourdrop-Z                 drop memory ptrs
        dc.w tworgreat-Z                job-id back
        dc.w clonejdt-Z                 final (user definable) action
        dc.w rot-Z                      timeout
        dc.w bl-Z,swapx-Z,activ-Z       activate the job, leave id
        dc.w semis-Z

bye create {bye} dojump V: root
 dc.l Cbye-Z

* fast multiway decision by associative & cases & associative cases
* d1.w mustn't be touched because of its use in the {cc-4th}-cases

* (CFA@) -find 0= IF [compile] forth here number dpl@ 1+
*       IF drop ENDIF -1 [compile] rvoc ELSE $c0 < ENDIF
 dc.b 6!128,6!128,'(cfa@',')'!128 ;(cfa@) ( --
 dc.w 0
pcfafetchp dc.w docolon-Z
        dc.w dashfind-Z,nzbranch-Z
        dc.w CS10-*,also-Z,forth-Z,also-Z,context-Z,twoplus-Z,off-Z
        dc.w here-Z,number-Z
        dc.w dplfetch-Z,oneplus-Z,nzbranch-Z
        dc.w CS11-*,drop-Z
CS11    dc.w dashone-Z,previous-Z,previous-Z,semis-Z
CS10    dc.w lit-Z,$c0,less-Z,semis-Z

* compiles: [ | max.disp | cfa.flg | num | num | ... ]
* runtime: num will be executed as a cfa if cfa.flg =/= 0
 dc.b 6!128,6!128,'(cfa,',')'!128
 dc.w 0
pcfacommap dc.w docolon-Z
        dc.w four-Z,here-Z,dzero-Z,dcomma-Z
CS01    dc.w pcfafetchp-Z,zdupbranch-Z
        dc.w CS02-*,zeroless-Z,nzbranch-Z
        dc.w CS03-*,cfa-Z,rot-Z,twoplus-Z,dashrot-Z
CS03    dc.w comma-Z,branch-Z
        dc.w CS01-*
CS02    dc.w here-Z,fetch-Z,lit-Z,$13b,neq-Z,zerobranch-Z
        dc.w CS4-*,cfaexec-Z,branch-Z
        dc.w CS01-*
CS4     dc.w drop-Z,dup-Z,greatresolve-Z
        dc.w sover-Z,fetch-Z,eq-Z,swapx-Z
        dc.w twoplus-Z,store-Z,cmcoff-Z,semis-Z

casix create {#case} Xcasix

casecolon create {case:} docolon
        dc.w statezbra-Z
        dc.w CS0-*,compile-Z,pcasep-Z
        dc.w pcfacommap-Z,semis-Z
CS0     dc.w create-Z,pcfacommap-Z,smudge-Z
        dc.w psemicodeq-Z
docases jmp     Xdocases(pc)
previmm setnum $140-[previmm]

* inline runtimes

* (CASE) r> dup @ 2dup + >r (csel)      einbau-runtime m. sprung
 dc.b 6!128,6!128,'(case',')'!128
 dc.w 0
pcasep dc.w dojump-Z ;create {(case)} dojump V: hidn
 dc.l Xdocase-Z

* (ASVR) r> dup @ 2dup + >r (asvl)  \ einbau-runtime
 dc.b 6!128,6!128,'(asvr',')'!128
 dc.w 0
pasvrq dc.w dojump-Z
 dc.l Xpasvrq-Z

* associatve list words

* (ASV@) bl word find ?dup                \ pfa 0 imm | integer 1 | pfa 1
*     IF 0< ELSE number drop true ENDIF   \ ';' => eingabe-ende
 dc.b 6!128,6!128,'(asv@',')'!128
 dc.w 0
pasfetchq dc.w docolon-Z
        dc.w dashfind-Z,zerobranch-Z
        dc.w AS1-*,lit-Z,$c0,less-Z,semis-Z
AS1     dc.w here-Z,number-Z,drop-Z,one-Z,semis-Z

*( flg -- )
*here dup 0 ,
*BEGIN BEGIN (asv@) WHILE , REPEAT here @ $13b =/= WHILE cfa execute REPEAT
*drop >resolve +!
 dc.b 6!128,6!128,'(asv,',')'!128
 dc.w 0
pasvcommaq dc.w docolon-Z ( flg --) 0:associative 1:range
        dc.w here-Z,dup-Z,zerocomma-Z
AS2     dc.w pasfetchq-Z,zerobranch-Z   fetch pfa/number/immediate
        dc.w AS3-*,comma-Z,branch-Z     compile if not an immedate word
        dc.w AS2-*
AS3     dc.w here-Z,fetch-Z,lit-Z,$13b,neq-Z,zerobranch-Z
        dc.w AS4-*,cfaexec-Z,branch-Z   otherwise exec
        dc.w AS2-*
AS4     dc.w drop-Z,greatresolve-Z      drop pfa, resolve table len
        dc.w plusstore-Z,cmcoff-Z,semis-Z mark range: or associative:

* associate an index to a number range top down an associative:-list
* num {rangelist} -- nn | nn of [0,max+1] such that val(nn) <= num < val(nn+1)
range create {range:} docolon
        dc.w one-Z,branch-Z
        dc.w AS01-*
previmm setnum $140-[previmm]

* : ASSOCIATIVE: $80 state@ IF compile (asvr) (asv,)
*   ELSE <builds (asv,) latest swap toggle does> dup @ (asvl) ENDIF
associativec create {associative:} docolon
        dc.w zero-Z
AS01    dc.w statezbra-Z
        dc.w AS0-*,compile-Z,pasvrq-Z
        dc.w pasvcommaq-Z,semis-Z
AS0     dc.w create-Z,pasvcommaq-Z,smudge-Z
        dc.w psemicodeq-Z
doassoc jmp     Xdoassoc(pc)
previmm setnum $140-[previmm]

*;;=>7.22: forth_scr, gendert: n1 n2 .. nn <TOS
;;dotsp create {.s} docolon
;        dc.w incons-Z,outcons-Z,xchan-Z
;        dc.w spfetch-Z,lit-Z,91,emit-Z,qbase-Z
;        dc.w depth-Z,onedash-Z,dup-Z,decdot-Z
;        dc.w bs-Z,lit-Z,0+']',emit-Z,space-Z,zdupbranch-Z
;        dc.w MD1-*,lit-Z,31,min-Z,twomul-Z,bounds-Z,pdoq-Z ;;zero-Z,pdoq-Z
;MD2     dc.w ix-Z,fetch-Z,udot-Z,two-Z,pplusloopq-Z
;;MD2     dc.w dup-Z,fetch-Z,udot-Z,twoplus-Z,ploopq-Z
;        dc.w MD2-*,zero-Z ;;
;MD1     dc.w drop-Z,incons-Z,outcons-Z,xchan-Z,semis-Z

* -- editting -- * f.i.g.-editor string words -- forth definitions

edit create {edit} dodefer
        dc.w fedit-Z,fedit-Z
fedit   dc.w docolon-Z,screen-Z,scrname-Z
        dc.w one-Z,work-Z,open-Z
        dc.w ert-Z,screen-Z,ischan-Z
        dc.w one-Z,load-Z,screen-Z
        dc.w close-Z,dup-Z,isopen-Z,zerobranch-Z
        dc.w ED01-*,iscreen-Z,zero-Z
ED01    dc.w drop-Z,edit-Z,semis-Z

* append word counted text
plustext create {+text} dojump (dest source --)
 dc.l Xplustext-Z
sname create {!name} dojump (dest maxlen source --)
 dc.l Xsname-Z

tleq    create {tl=} dojump (1.daddr 1.len ...)
 dc.l Xlstgcmp-Z
teq     create {t=} dojump (1.ptr 1.len 2.ptr 2.len -- flag:<0 0 >0
 dc.l Xstgcmp-Z

weq     create {w=} dojump (memptr memlen stgptr -- f)
 dc.l Xdashtx-Z         ; 4th-voc -text

voc setstr edi * -- editor definitions -- *

* FLUSH [ limit first - b/buf head+ / ] literal
*  0 DO max-blk buffer drop LOOP workfile fsflush w#0 k>
flush create {flush} docolon
        dc.w flushdat-Z,pdoq-Z
FH00    dc.w lit-Z,$7fff,buffer-Z
        dc.w drop-Z,ploopq-Z
        dc.w FH00-*,workid-Z
        dc.w edifile-Z,sdrop-Z
FH01    dc.w towork-Z,fsflush-Z
        dc.w setwork-Z,semis-Z

*identisch w=
*dashtext create {-text} dojump ; tf if stg of len memlen found at memptr
* dc.l Xdashtx-Z (memptr memlen stgptr -- f)

stringeq create {s=} dojump
 dc.l Xstgeq-Z  (joker d.stgadr count d.memadr --f) tf: stg found

matchl create {s==} dojump
 dc.l Xmatchl-Z (joker d.stgadr stgcnt d.memadr maxcnt -- f disp)

* match: tf: memptr+disp points to behind stg
match create {match} dojump
 dc.l Xmatch-Z ( memptr memlen stgptr stglen -- f disp)

voc setstr fth * -- device allocation -- * forth words *

xpfopq  create {(fop)} dodefer ( opencode name -- o n )
        dc.w noop-Z,noop-Z
pfopq   dc.w docolon-Z,swapx-Z,xpfopq-Z,work-Z,open-Z
        dc.w zero-Z,paper-Z,semis-Z

* does> @ [compile] name swap (fop) work open
dofop   dc.w fetch-Z,qname-Z,dcompile-Z,pfopq-Z,semis-Z

pfoplkq dc.w docolon-Z,dashrot-Z,work-Z,openlk-Z,semis-Z
foplk   create {fop-link}  docolon (d.id fop-link " name" -- chan d.0 | d.ernum)
        dc.w qname-Z,dcompile-Z,pfoplkq-Z,semis-Z
previmm setnum $140-[previmm]

fopenq  create  {fopen}    dodoesgreat (use: fopen name -- d.ernum)
        dc.w dofop-Z,0
previmm setnum $140-[previmm]
fopinq  create  {fop-in}   dodoesgreat
        dc.w dofop-Z,1
previmm setnum $140-[previmm]
fopnewq create  {fop-new}  dodoesgreat
        dc.w dofop-Z,2
previmm setnum $140-[previmm]
fopdirq create  {fop-dir}  dodoesgreat
        dc.w dofop-Z,4
previmm setnum $140-[previmm]
ftest create {ftest} docolon
        dc.w fopenq-Z,nzbranch-Z
        dc.w FT0-*,work-Z,close-Z
FT0     dc.w semis-Z
previmm setnum $140-[previmm]

fdeleteq create {fdelete} docolon
        dc.w qname-Z,dcompile-Z,fdel-Z,semis-Z
previmm setnum $140-[previmm]

bfovd   dc.w docolon-Z,in-Z,fetcha-Z,rgreat-Z,fdeleteq-Z
        dc.w greatr-Z,in-Z,storea-Z,fopnewq-Z,semis-Z
* fop-over als delete und open-new fr ql ohne tk2 und bessere disk-ordnung
fopoverq create {fop-over} docolon
        dc.w dcompile-Z,bfovd-Z,semis-Z
previmm setnum $140-[previmm]

format create {format} docolon
        dc.w qname-Z,dcompile-Z,frmt-Z,semis-Z
previmm setnum $140-[previmm]

* -- qdos-io -- * forth words * all refer to the "work" channel *

chid create {ch-id} dojump (ch.num -- d.channel-id)
 dc.l CXchid-Z

chp create {chp} dojump (ch -- chan.adr)
 dc.l Xchp-Z

isochan create {is-ochan} dojump (ch -- ff|tf) own channels  only
 dc.l CXisochc-Z

isopen create {is-open} dojump (ch -- ff | tf) tf if chan is open
 dc.l CXisopen-Z

dashwindow create {-window} dojump (ch -- tf | ff if not a window)
 dc.l CXdwd-Z

wdsize create {wd-size} dojump (ch -- y x hgt wdt tf | ff if not a window)
 dc.l Cwsiz-Z

* -- qdos-io -- *

cdt create {cdt} dojump V: qdos (ch -- d.cdt.adr 0/1/49| -1. -1)
 dc.l CXccdt-Z
*  cdt-address abs long, flag 0 not a window, -1 no channel

voc setstr fth

newchan create {new-chan} dojump (-- chan| ff) topmost free chan into work
 dc.l Xnewch-Z

ischan create {is-chan} docolon        (c1 --) set work-id to channel-ptr of c1
  dc.w dup-Z,close-Z,workid-Z,rot-Z,chp-Z,twostore-Z,semis-Z

towork create {to-work} docolon        (c1 --) put c1-id to work-channel
        dc.w chid-Z
TC02    dc.w work-Z,branch-Z
        dc.w TC01-*

tochan create {to-chan} docolon       (c1 c2 --) put c1-id to c2-location
        dc.w swapx-Z,chid-Z,rot-Z,branch-Z
        dc.w TC01-*

setchan create {set-chan} docolon      (dn1 c2 --) channel-id to channel pointer
TC01    dc.w chp-Z,twostore-Z,semis-Z

setwork create {set-work} docolon      (dn1 --) set work-location to id dn
        dc.w branch-Z
        dc.w TC02-*

workid create {work-id} docolon        (-- dn ) work id
        dc.w work-Z,chid-Z,semis-Z

xchan create {>chan<} docolon
        dc.w chp-Z,swapx-Z,chp-Z,twodup-Z,twofetcha-Z,twoswap-Z
        dc.w twofetcha-Z,rot-Z,twostore-Z,rot-Z,twostore-Z,semis-Z

voc setstr qdos

t12 create   {trap1} dojump
 dc.l Xt12-Z (dn1 dn2 op -- dn1) & a1:=0 (no mt.trapv !)
activ create {activ} dojump
 dc.l Cactiv-Z ( d.id prior ex/ew -- d.id )
cjob create  {cjob} dojump  (dn1 dn2 dn3 dn4 -- dn1)
 dc.l Xcjob-Z
trap1a create {trap1a} dojump (da1 dd3 dd2 dd1 op -- dd1)
 dc.l Xtrap1a-Z
t11  dc.w dojump-Z
 dc.l Xt11-Z (dn1 op -- dn1 f) & a1:=0
t10  dc.w dojump-Z
 dc.l Xt10-Z (op -- dn1) & a1:=0

err  setstr {qerr-Z,semis-Z}
t3do setstr {dc.w docolon-Z,auxs-Z}

t00  setstr {dc.w fetch-Z,d0ws-Z}

dot10   dc.w fetch-Z,t10-Z,semis-Z
mtfree create {free}    dodoesgreat     (-- dn) biggest free heap
        dc.w dot10-Z,6
mtrclk create {rclck}   dodoesgreat     (-- dn) date
        dc.w dot10-Z,19

susjb create {susjb}    docolon         ( d.id wait -- d.id)
        dc.w zero-Z,lit-Z,8,t12-Z,semis-Z
dot11   dc.w fetch-Z,t11-Z,semis-Z
reljb create {reljb}    dodoesgreat     (dn -- dn) job/-1 -- id & {a2l@} jdt
        dc.w dot11-Z,9
mode create  {mode}     dodoesgreat     (dn -- dn) set mode d1.w 0 - read mode d1.w, TV/monitor always zero
        dc.w dot11-Z,16

dot11d  dc.w fetch-Z,t11-Z,twodrop-Z,semis-Z
baud create  {baud}     dodoesgreat     (dn --)
        dc.w dot11d-Z,18
sclck create {sclck}    dodoesgreat     (dn --)
        dc.w dot11d-Z,20
rechp create {rechp}    dodoesgreat     (dn --)
        dc.w dot11d-Z,25

setbaud create {set-baud} dojump V: fth ( n1 -- n2) read old & set new baudrate
 dc.l Xsbd-Z

jinf create {jinf} docolon              (dn1 dn2 -- dn3 dn4 n5 dn6)
        dc.w two-Z,t12-Z,lit-Z,a1wq-Z              nxt ownr pri start
        dc.w twofetcha-Z,a1ql-Z,drop-Z
        dc.w a2ql-Z,semis-Z

dot12d  dc.w fetch-Z,t12-Z,twodrop-Z,semis-Z
frjob create {frjob} dodoesgreat        (dn1 dn2 --) job ernum
        dc.w dot12d-Z,5
tra create {tra} dodoesgreat            (dn1 dn2 --) chartab msgtab
        dc.w dot12d-Z,36

dot12   dc.w fetch-Z,t12-Z,a2ql-Z,semis-Z
prior create {prior} dodoesgreat        (dn1 dn2 -- dn3 dn4) job pri -- id jdt
        dc.w dot12-Z,11
alchp create {alchp} dodoesgreat        (d.len d.id -- d.len d.adr)
        dc.w dot12-Z,24

d1ql create {d1l@} dotwoconstant
* trap#3              trap#1    hi.w lo.w lo.b long
d1lq    dc.l 0  ;out;   d1      d1qh d1qw d1qb
a1wq    dc.w 0          d2      a1qw
;a2wq
        dc.w 0
a1lq    dc.l 0          d3                     a1ql
a2lq    dc.l 0          a0                     a2ql
;t1lq
        dc.l 0          a1
d1lp    dc.l 0  ; in;   d1      d1hs d1ws      d1ls
d2lp    dc.l 0          d2           d2ws      d2ls
d0wp    dc.w 0          d3      d0ws
d3wp    dc.w -1                      d3ws
a1wp    dc.w 0          a0      a1ws
a2wp    dc.w 0                       a2ws
a2lp    dc.l 0          a1                     a2ls
d3wt    dc.w 0  ;tmp; timo
aux     dc.w 0  for docol <=> dodoes

dothree create {t3do} dojump V: hidn (d.chanid --)
 dc.l dt3ntr-Z

frmt create {formt} dojump (addr -- sec good f) f=ernum
 dc.l Cfrmt-Z

fdel create {delet} dojump (addr --)
 dc.l Cfdel-Z

*** trap #3 managing words

* does> d0w d1w d2w t3          (for just d1 and d2 parms)--)
t32     [t00],d1ws-Z,d2ws-Z,t3-Z,semis-Z

* does> d0w! a1w! d2l! d1l! t3 d1l@
dot33   [t3do]
t33     [t00],branch-Z          (d1l d2l a1w -- d1l)
        dc.w t33x-*
dot33l  [t3do]
        [t00],branch-Z          (d1l d2l a1l -- d1l)
        dc.w t33lx-*

dot34   [t3do]
t34     [t00],tforthplus-Z,a2ls-Z       (d1l d2l a1w a2l -- d1l)
t33x    dc.w sdashgreatd-Z,a1ls-Z
t34x    dc.w d2ls-Z,d1ls-Z,dot3lon-Z,d1ql-Z,semis-Z
dot34l  [t3do]
t34l    [t00],tforthplus-Z,a2ls-Z       (d1l d2l a1l a2l -- d1l)
t33lx   dc.w tforthplus-Z,a1ls-Z,branch-Z
        dc.w t34x-*

* does> d0w 0. 0. 0. d2l! sp@ a1w t3 (for window enquiries )
t3e     [t00],dzero-Z,dzero-Z,dzero-Z,d2ls-Z,spsa1-Z,dot3lon-Z,semis-Z

* does> d0w d1w! sp@ a1w t3     (for wdef, bfill)
dot3b   [t3do]                  (aux! d0w!) d1w! sp@ a1w! --)
t3b     [t00],d1ws-Z,spfetch-Z,a1ws-Z,t3-Z,fourdrop-Z,semis-Z

* does> @ d0w d3t! t3 d3r       (timo op --)
dot3t   [t3do]
        [t00],d3ts-Z,t3-Z,d3rs-Z,semis-Z

*** trap #3 qdos calls

pend create {pend} docolon      (timo -- tf|ff)(pending input|ready)
        dc.w zero-Z,dot3t-Z,[err]

eof create {eof} docolon        (-- eofflag)
        dc.w dzero-Z,dot3t-Z,ernum-Z
        dc.w dlit-Z,0,10,dplus-Z,dzeroeq-Z,semis-Z

* inkey (timo -- byte | -ALTbyte | $8000 timout or error)
*       (inkey) -dup 0IF dup 255 = 0IF ;s ELSE 0= (inkey) -dup ENDIF ENDIF
*       IF drop $8000 ENDIF minus ;
binkeyq dc.w docolon-Z,one-Z,dot3t-Z,d1qb-Z,qerr-Z,semis-Z
inkey create {inkey} docolon
        dc.w binkeyq-Z,nzbranch-Z
        dc.w MI01-*,dup-Z,lit-Z,255,eq-Z,zerobranch-Z
        dc.w MI03-*,zeroeq-Z,binkeyq-Z,zerobranch-Z
        dc.w MI02-*
MI01    dc.w drop-Z,lit-Z,$8000
MI02    dc.w minus-Z
MI03    dc.w semis-Z

fbyte create {fbyte} docolon    (-- byte f)
        dc.w dot30-Z,1
        dc.w d1qb-Z,swapx-Z,semis-Z

fline create {fline} docolon    (addr len -- len f)
        dc.w d1ws-Z,a1ws-Z,dot30-Z,2
        dc.w d1qw-Z,swapx-Z,semis-Z

fstrg create {fstrg} docolon    (addr len -- f)
        dc.w d2ws-Z,a1ws-Z
        dc.w dot30-Z,3
        dc.w semis-Z

sbyte create {sbyte} t31lit     (byte -- )
        dc.w 5

sstrg create {sstrg} docolon    (addr len -- f)
        dc.w d2ws-Z,a1ws-Z
        dc.w dot30-Z,7,semis-Z

pxenq create {pxenq} dodoesgreat (-- y x height width)
        dc.w t3e-Z,10
chenq create {chenq} dodoesgreat (-- row col rows cols)
        dc.w t3e-Z,11

border create {border} dodoesgreat (width colour --)
        dc.w t32-Z,12

wdef create {wdef} docolon      (y x height width bwid bcol--)
        dc.w swapx-Z,d2ws-Z,lit-Z,13,dot3b-Z,semis-Z
window create {window} docolon V: fth (y x height width --)
        dc.w dzero-Z,wdef-Z,semis-Z

cursen create {cursen} t3lit    (--)
        dc.w 14
curdis create {curdis} t3lit    (--)
        dc.w 15

atc create {at} dodoesgreat     (row col --)
        dc.w t32-Z,16
tabc create {tab} t31lit        (col --)
        dc.w 17

nl create {nl} t3lit            (--)
        dc.w 18
pcol create {pcol} t3lit        (--)
        dc.w 19
ncol create {ncol} t3lit        (--)
        dc.w 20
prow create {prow} t3lit        (--)
        dc.w 21
nrow create {nrow} t3lit        (--)
        dc.w 22

pixp create {pixp} dodoesgreat  (y x --)
        dc.w t32-Z,23

scroll create {scroll} t31lit   (distance --)
        dc.w 24
scrtp create {scrtp} t31lit     (distance --)
        dc.w 25
scrbt create {scrbt} t31lit     (distance --)
        dc.w 26

pan create {pan} t31lit         (distance --)
        dc.w 27
panln create {panln} t31lit     (distance --)
        dc.w 30
panrt create {panrt} t31lit     (distance --)
        dc.w 31

cls   create {clrsc} t3lit (--)
        dc.w 32
clrtp create {clrtp} t3lit (--)
        dc.w 33
clrbt create {clrbt} t3lit (--)
        dc.w 34
clrln create {clrln} t3lit (--)
        dc.w 35
clrrt create {clrrt} t3lit (--)
        dc.w 36

fount create {fount} docolon    (1stfont 2ndfont -- f)
        dc.w a2ls-Z,a1ls-Z
        dc.w dot30-Z,37,semis-Z

recol create {recol} docolon    (addr --) ( 8 colour bytes at addr )
        dc.w a1ws-Z
        dc.w dot30-Z,38,drop-Z,semis-Z

paper create {paper} t31lit     (colour --)
        dc.w 39
strip create {strip} t31lit     (colour --)
        dc.w 40
ink   create {ink}   t31lit     (colour --)
        dc.w 41
flash create {flash} t31lit     (boolean --)
        dc.w 42
under create {under} t31lit     (boolean --)
        dc.w 43
setmd create {setmd} t31lit     (OVER --)
        dc.w 44

csize create {csize} dodoesgreat (height width --)
        dc.w t32-Z,45

bfill create {bfill} dodoesgreat (y x height width colour --)
        dc.w t3b-Z,46

* fp graphic calls leave the stack data intact for further operations
point create {point} Xt3g       (fx fy -- fx fy)
        dc.w 48
gline create {line}  Xt3g       (fxs fys fxe fye -- x y x y)
        dc.w 49
arc create   {arc}   Xt3g       (fxs fys fxe fye frc -- .. )
        dc.w 50
elips create {elips} Xt3g       (fxc fyc frt fax frc -- .. )
        dc.w 51
scale create {scale} Xt3g       (fsc fxc fyc -- s x y)
        dc.w 52

flood create {flood} t31lit     (flag --)
        dc.w 53

gcur create {gcur} Xt3g         (ypx xpx ygc xgc -- ..)
        dc.w 54

fscheck create {fscheck} t30    (-- f)
        dc.w 64

fsflush create {fsflush} t3lit  (--)
        dc.w 65

** immediately after any of the pos calls, d1l? will give the current position
** there is no error trapping, leaving tf|ff on stack and ernum uncleared

posab   create {posab} docolon  (d.pos -- f)
        dc.w d1ls-Z,zero-Z,lit-Z,66,dot3t-Z,[err]

posre   create {posre}  docolon (d.disp -- f)
        dc.w d1ls-Z,zero-Z,lit-Z,67,dot3t-Z,[err]

poseof  create {poseof} docolon (--)
        dc.w dlit-Z,$3F,$FFFF,posre-Z,drop-Z,semis-Z

fpos    create {fpos}   docolon (-- d.fpos )
        dc.w dzero-Z,posre-Z,drop-Z,d1ql-Z,semis-Z

flen    create {flen}   docolon (-- d.flen ) fpos restored
        dc.w fpos-Z,poseof-Z,d1ql-Z
        dc.w twoswap-Z,posab-Z,zerobranch-Z
        dc.w FN01-*,lit-Z,qf.error+2-Z
        dc.w fetcha-Z,lit-Z,10
        dc.w plus-Z,zerobranch-Z
        dc.w FN01-*,twodrop-Z,dzero-Z
FN01    dc.w semis-Z

mdinf create {mdinf} docolon    (ptr -- good empty f (10 bytes to addr )
        dc.w a1ws-Z
        dc.w dot30-Z,69
        dc.w d1ql-Z,rot-Z,semis-Z

heads create {heads} docolon    (ptr -- len f (14 bytes sent from addr )
        dc.w a1ws-Z
        dc.w dot30-Z,70
        dc.w d1qw-Z,swapx-Z,semis-Z
headr create {headr} docolon    (ptr -- len f (14 bytes read to addr )
        dc.w a1ws-Z
        dc.w dot30-Z,71
        dc.w d1qw-Z,swapx-Z,semis-Z

sstrgl create {sstrg-l} docolon (d.addr +len --)
        dc.w zero-Z,lit-Z,7,branch-Z
        dc.w FS02-*
fstrgl create {fstrg-l} docolon (d.addr +len --)
        dc.w zero-Z,lit-Z,3,branch-Z
        dc.w FS02-*
fsload create {fsload} docolon  (d.addr d.len --(load file to addr )
        dc.w lit-Z,72,branch-Z
        dc.w FS02-*
fssave create {fssave} docolon  (d.addr d.len --(save to file)
        dc.w lit-Z,73
FS02    dc.w d0ws-Z,d2ls-Z,tforthplus-Z
        dc.w a1ls-Z,dot3lon-Z,semis-Z

fsrename create {fsrename} docolon (nameptr --)
        dc.w a1ws-Z,renm-Z,semis-Z
renm dc.w t3lit-Z,74

fstrunc create {fstrunc} t3lit (--)
        dc.w 75

fsmkdr create {fsmkdr} t30lit (--)
        dc.w 77

fsvers create {fsvers} t3llit (d1.l --) read the version with {d1l@}
        dc.w 78

xinf create {xinf} docolon      (addr -- f) 64(100) bytes device info to addr
        dc.w a1ws-Z
        dc.w dot30-Z,79,semis-Z

voc setstr pif
qflim create {qflim} dodoesgreat (-- y0 x0 height width) outline info
        dc.w t3e-Z,108
flim create {flim} docolon      (-- y x h w) default to standard screen
        dc.w work-Z,dashwindow-Z,nzbranch-Z
        dc.w FL01-*,lit-Z,-6,message-Z
FL01    dc.w qflim-Z,ernum-Z,orx-Z,zerobranch-Z
        dc.w FL02-*,dzero-Z,dlit-Z,$200,$100
FL02    dc.w semis-Z

svpw create {svpw} dodoesgreat  (y x 0/hgt.wdt sizes.ptr d.mem.adr -- d.sav.adr)
        dc.w t34-Z,109

rspw create {rspw} docolon      (y x flag 0 sizes.ptr d.sav.adr --)
        dc.w lit-Z,110,dot34-Z,twodrop-Z,semis-Z

pinf create {pinf} docolon (-- d.pif-version d.wman-vector)
        dc.w lit-Z,112,d0ws-Z,dot3lon-Z,a1lq-Z,d1ql-Z,semis-Z

rptr create {rptr} dodoesgreat  (y x tab(.b) 0 rcd.ptr -- y x)
        dc.w t33-Z,113          ( d3 := -1 )

rpxl create {rpxl} docolon      (y x d2.code -- colr posn)
        dc.w zero-Z,lit-Z,114,dot33-Z,semis-Z

wblb create {wblb} docolon      (y x d.blob.adr d.pat.adr --)
        dc.w dzero-Z,tworot-Z,tworot-Z,dot34l-Z,115,semis-Z

lblb create {lblb} dodoesgreat  (y.s x.s y.e x.e d.adr1.blb d.adr2.pat --)
        dc.w t34l-Z,116

wspt create {wspt} docolon      (y x d.adr.sprt --) draw sprite
        dc.w dzero-Z,twoswap-Z,lit-Z,117,dot33l-Z,semis-Z

spry create {spry} dodoesgreat  (y x d(.w)pix d.adr.blb d.adr.pat -- y x)
        dc.w t34l-Z,118

outl create {outl} docolon      (y x hgt wdt set/mov -)
        dc.w d2ws-Z,dzero-Z,d1hs-Z,lit-Z,122,dot3b-Z,semis-Z

sptr create {sptr} docolon      (y.pix x.pix flag -- y x)
        dc.w d2ws-Z,d1ls-Z
        dc.w dot30-Z,123
        dc.w drop-Z,d1ql-Z,semis-Z

ppick create {pick-job} t3llit  (d.jobid --)
        dc.w 124 ;{work} must be a (dummy) valid window channel

pickforth create {pick-4th} docolon V: fth (--) pick current "f6"-job
        dc.w zero-Z,towork-Z,fthid-Z,ppick-Z,semis-Z

swdf create {swdf} docolon      (d.adr --)
        dc.w lit-Z,125,branch-Z
        dc.w iopw-*

wsav create {wsav} docolon      (d.adr d.len --)
        dc.w d1ls-Z,lit-Z,126,branch-Z
        dc.w iopw-*

wrst create {wrst} docolon      (d.adr flag --)
        dc.w d2ws-Z,lit-Z,127
iopw    dc.w d0ws-Z,tforthplus-Z,a1ls-Z,dot3lon-Z,semis-Z

voc setstr qdos ** other qdos related routines

edline create {edline} dojump ( ptr1 maxcount -- ptr1 count | ff)
 dc.l Xedline-Z

xstrip  create {xstrip} dojump
  dc.l Xxstrip-Z  (c1 --) exchange ink & strip colours
dxstrip create {-xstrip} dojump
  dc.l Xdstrip-Z  (c1 f --) xg if tf

voc setstr pif ** hotkey routines - fetch from/store to hotkey buffer

hkstore create {hot!} dojump (ptr +nn -- f) ff if successfully done
 dc.l Chbfs-Z   ; string len -- store +nn chars from ptr)+
hkfetch create {hot@} dojump (ptr -nn -- ptr f) f>0:=len, 0 on error
 dc.l Chbff-Z   ; storage hbuf.no. -- fetch chars to ptr)+

voc setstr qdos
qcall create {call} dojump ( d.a4 ... d.a0 d.d4 ... d.d0 d.adr -- a4 ... d0 )
 dc.l Xqcall-Z

Xqdvec  jmp   Cxqdv(pc)
qddate create {d>date} Xqdvec ( dn1 -- ptr c2 )
 dc.w 236
qdday  create {d>day} Xqdvec ( dn1 -- ptr c2 )
 dc.w 238

voc setstr fth
qdates create {date$} docolon ( -- ptr cnt ) date$
 dc.w mtrclk-Z,qddate-Z,semis-Z

qdays  create {day$} docolon  ( -- ptr cnt ) day$
 dc.w mtrclk-Z,qdday-Z,semis-Z

* fetch a "MEM"-device execution vector (re "IO2" for details)
memvec create {memvec} dojump V: hidn      ( opco -- d.adr | -ve )
 dc.l Xcmemvec-Z

* execute a parameterless resident basic procedure ( try: hidden " tune" basic rvoc )
basic  create {basic} dojump V: hidn ( ptr -- ernum ) call basicproc ptr{name}.w
 dc.l Xbasic-Z

* "_lngBAD" to (partly) cure the the poor lightning screen positioning
lngbad create {lngbad} dojump ( -- ernum )
 dc.l Xlngb-Z
 dc.w lngnam-Z

* selection codes for the MEM-device character founts
losc create {losc} doconstant
        dc.w -15 lo script
hisc create {hisc} doconstant
        dc.w -14 hi
bblu create {bblu} doconstant
        dc.w -13 ibm#2
atne create {atne} doconstant
        dc.w -12 mi nerva
* activate a predefined char. fount ( code chan --)
fnt create {>fount} dojump
 dc.l Xfnt-Z

wmov create {wmov} dojump V: fth ( chan --)
 dc.l gowmov-Z

* +++ anfang +++ does> bis mul vor obere berwachungsgrenze gelegt

voc setstr qdos

auxs    dc.w    Xauxs-Z
Xauxs   move.w  ([sp])+,aux-Z([bp])
        move.w  #aux-Z,-([sp])
        [jnx]

d1qh  create {d1h@} *+2
        move.w  d1lq-Z([bp]),-([sp])
        [jnx]
d1qw  create {d1w@} *+2
        move.w  d1lq+2-Z([bp]),-([sp])
        [jnx]
d1qb  create {d1b@} *+2
        move.b  d1lq+3-Z([bp]),-([sp])
        sf      -([sp])
        [jnx]
a1qw  create {a1w@} *+2
        move.w  a1wq-Z([bp]),-([sp])
        [jnx]
a1ql  create {a1l@} *+2
        move.l  a1lq-Z([bp]),-([sp])
        [jnx]
a2ql  create {a2l@} *+2
        move.l  a2lq-Z([bp]),-([sp])
        [jnx]

d1ls  create {d1l!} *+2
        move.l  ([sp])+,d1lp-Z([bp])
        [jnx]
d2ls  create {d2l!} *+2
        move.l  ([sp])+,d2lp-Z([bp])
        [jnx]
d1hs  create {d1h!} *+2
        move.w  ([sp])+,d1lp-Z([bp])
        [jnx]
d1ws  create {d1w!} *+2
        move.w  ([sp])+,d1lp+2-Z([bp])
        [jnx]
d2ws  create {d2w!} *+2
        move.w  ([sp])+,d2lp+2-Z([bp])
        [jnx]
d0ws  create {d0w!} *+2
        move.w  ([sp])+,d0wp-Z([bp])
        [jnx]
d3ws  create {d3w!} *+2
Xd3ws   move.w  ([sp])+,d3wp-Z([bp])
        [jnx]
d3ts  create {d3t!} *+2
        move.w  d3wp-Z([bp]),d3wt-Z([bp])
        bra.s   Xd3ws
d3rs  create {d3r} *+2
        move.w  d3wt-Z([bp]),d3wp-Z([bp])
        [jnx]
a1ws  create {a1w!} *+2
        move.w  ([sp])+,a1wp-Z([bp])
        [jnx]
a1ls  create {a1l!} *+2
        move.l  ([sp])+,a1wp-Z([bp])
        [jnx]
a2ws  create {a2w!} *+2
        move.w  ([sp])+,a2wp-Z([bp])
        [jnx]
a2ls  create {a2l!} *+2
        move.l  ([sp])+,a2lp-Z([bp])
        [jnx]
spsa1 create {sp!a1} *+2
        move.l  [sp],a0
        sub.l   [bp],a0
        move.l  a0,a1wp-Z([bp])
        [jnx]

t30    dc.w  Xt30-Z * does> @ d0w t3 qerr (for no parameters)-- f)
dot30  dc.w  Xdot30-Z
Xdot30  move.l  [ip],[w]
        addq.l  #2,[ip]
Xt30    jmp     CXt30(pc)

t3 create {trap3} Xt3  ( chan# -- ) regs previously set
t30lit  clr.w   -([sp])                 (d1:=0)
t31lit  clr.w   -([sp])                 (d1.w --)
t3llit  move.l  ([sp])+,d1lp-Z([bp])    (d1.l --)
t3lit   move.w  ([w]),d0wp-Z([bp])      ( --)
Xt3     jmp     CXt3(pc)                (--)

* execute graphic op's, leaving stacked parameters intact
Xt3g    jmp     CXt3g(pc) (fn1 fn2 fn3 fn4 fn5 -- fn1 .. fn5) error code in {ernum}

dot3lon dc.w dojump-Z
 dc.l CXt3lon-Z

voc setstr fth

* search {vocname} => {vocname} for 2nd order searching in context-voc.
vsearch create {search} docolon V: root
 dc.w tick-Z,psrcq-Z,semis-Z
psrcq   dc.w *+2-Z
        jmp     Xpsrchq(pc)
previmm setnum $140-[previmm]

nosearch create {no-search} dojump V: root
 dc.l Xnosearch-Z
previmm setnum $140-[previmm]

* restore 1st order search voc.
rvoc create {rvoc} dojump V: root
 dc.l Xrvoc-Z
previmm setnum $140-[previmm]

* f-83 search order words
also    create {also} dojump V: root
 dc.l Xalso-Z
previmm setnum $140-[previmm]

previous create {previous} dojump V: root
 dc.l Xprevious-Z
previmm setnum $140-[previmm]

only    create {only} dojump V: root
 dc.l Xonly-Z
previmm setnum $140-[previmm]

assembler create {assembler} dodefer V: root
        dc.w asm68-Z,asm68-Z
previmm setnum $140-[previmm]

voc setstr hidn * compiler-runtimes

lit     create {lit} Xlit
dlit    create {dlit} Xdlit

statezbra dc.w Xszbra-Z
nzbranch create   {-branch} Xnzbranch (  0IF
mibranch create   {0<branch} Xmibra (    +IF
lebranch create   {0-branch} Xlebra ( 0< 0IF
gtbranch create   {0>branch} Xgtbra ( 0> 0IF
plbranch create   {+branch}  Xplbra ( 0<  IF
zerobranch create {0branch}  Xzbra  (     IF
zdupbranch create {?0branch} Xzdbra (       : -dup 0branch ...
neqbra create {?1branch} dojump
 dc.l Xneqbra-Z    ( CASE? : over- 0IF drop ...

pdoq    create {(do)}   X2gr
leave   create {leave}  Xleave  V: fth
qleave  create {-leave} Xqleave V: fth
ploopq  create {(loop)} Xploopq
pplusloopq create {(+loop)} Xpplopq

voc     setstr  fth

cfaexec dc.w Xcfaexec-Z cfa execute
execute create {execute} Xexecute  @ cfa execute
perform create {perform} Xperform  for the interpreting words
pcsemiq create {`;c]} Xpsemicq

digit   create  {digit} dojump  ( chr base - ff | digit tf )
        dc.l Xdigit-Z

enclose create  {enclose} dojump (adr1 char --- adr1 n1 n2 n3)
        dc.l Xenclose-Z

* new ex.vec: index ' {word} is cc-4th :index = char, where index 0 is for <del>
* {ctrl} takes the execution from a user-vectored case:-list, re-vectoring
* could be done by setting the user-variable {cc4th}: ' newcaselist is cc4th
cc4thc create {cc-4th} docases
ctt  dc.w cc4end-*,1
     dc.w dXdel-Z,dCT1-Z,dCT1-Z,dCT1-Z,dCT1-Z,dCT1-Z,dcurr-Z,bell-Z 127,1-7
     dc.w dXbs-Z,dCT1-Z,dcnl-Z,dcuru-Z,dpage-Z,dCT1-Z,dcen-Z,dcen-Z    8-15
     dc.w dCT1-Z,dCT1-Z,dtab-Z,dCT1-Z,dCT1-Z,dCT1-Z,dCT1-Z,dXbs-Z     16-23
     dc.w dcurd-Z,dCT1-Z,dCT1-Z,dCT1-Z,dCT1-Z,dpos-Z,dhome-Z,dat-Z    24-31
cc4end ds.w 0 * defined: 0 6 7 8 10 11 12 14 15 18 23 24 29 30 31 127

dct1    dc.w CT1-Z
DXdel   dc.w dojump-Z
 dc.l CXdel-Z
dcurr   dc.w dojump-Z
 dc.l Xcurr-Z
DXbs    dc.w dojump-Z
 dc.l Xbs-Z
dcnl    dc.w dojump-Z
 dc.l Ccnl-Z
dcuru   dc.w dojump-Z
 dc.l Ccuru-Z
dpage   dc.w dojump-Z
 dc.l Cpage-Z
dcen    dc.w dojump-Z
 dc.l Ccen-Z
dtab    dc.w dojump-Z
 dc.l Ctab-Z
dcurd   dc.w dojump-Z
 dc.l Ccurd-Z
dpos    dc.w dojump-Z
 dc.l CXpos-Z
dhome   dc.w dojump-Z
 dc.l Chome-Z
dat     dc.w dojump-Z
 dc.l Cat-Z

pieps   dc.w $0a0a,0,$0aaa,$0500,0,$0a,0,0,$0100
pctlq create {(ctl)} dovariable V: hidn
ctflag  dc.w -1

ipcom   create {ipcom} dojump V: qdos
 dc.l Xipcom-Z

bell    create {bell} dojump
 dc.l Xbell-Z

keyrow  create {keyrow} dojump
 dc.l Xkeyrow-Z

mtinf   create  {mt-inf} dojump  (-- d.svaddr d.qdosid d.jobid)
 dc.l Cmtinf-Z

cacheon create {cache-on} dojump
 dc.l Xdcache-Z
 dc.w 1
cacheoff create {cache-off} dojump
 dc.l Xdcache-Z
 dc.w 0
cache create {cache} dojump
 dc.l Xcache-Z
dcache create {-cache} dojump
 dc.l Xdcache-Z
 dc.w -1
* cache control for the qxl

syst   create {sysflg} Xsysfl
fthid  create {4th-id} Xfthid (-- d.jobid)

fperr  create {fp-err} Xfperr
ftherr create {4th-err} Xftherr
ioerr  create {io-err} Xioerr
ernum  create {ernum} Xernum (-- d.ernum) read ernum (once) only

* ctrl : control-keys * ( n3.key -- ff | -1 :n.i. | [n1 [n2]] n3 tf :no ctrl )
ctrl    create {ctrl} dojump
 dc.l Xctrl-Z
ctrlwa  dc.w dojump-Z
 dc.l doctrl-Z

Dqexpect dc.w dojump-Z
 dc.l Xqexpect-Z
Dexpect dc.w dojump-Z
 dc.l Xexpect-Z
Dkey    dc.w dojump-Z
 dc.l Xkey-Z
Dqkey   dc.w dojump-Z
 dc.l Xqkey-Z
Dqterminal dc.w dojump-Z
 dc.l Xqterminal-Z
Demit   dc.w dojump-Z
 dc.l Xemit-Z
Dpemit  dc.w dojump-Z
 dc.l Xpemit-Z
Dtype   dc.w dojump-Z
 dc.l Xtype-Z
Dtypel  dc.w dojump-Z
 dc.l Xtypel-Z
Dconsem dc.w dojump-Z
 dc.l Xconsemit-Z
Dconst  dc.w dojump-Z
 dc.l Xconstype-Z

docr    dc.w docolon-Z
        dc.w ctrlwa-Z,10,drop-Z,semis-Z
docls   dc.w docolon-Z
        dc.w ctrlwa-Z,12,drop-Z,semis-Z

do1ptype dc.w dojump-Z
 dc.l Cdo1ptype-Z

doptype dc.w docolon-Z,curdis-Z,zdupbranch-Z
        dc.w DT01-*,zero-Z,pdoq-Z
DT02    dc.w do1ptype-Z,ploopq-Z
        dc.w DT02-*
DT01    dc.w drop-Z,semis-Z

;;utmint  move.w  $0ce,a2
;        bra.s   utchan  ?
utmtext move.w  $0d0,a2
utchan  move.l  deftch(pc),a0
        jsr     (a2)    >
        moveq   #32,d1
        moveq   #5,d0
        trap    #3
        rts

domove  jmp     Cdomove(pc)

voc setstr hidn
cmoveup create  {cmove>} domove
ccmvu   dc.w 0
        dc.l jcmvup-Z
lesscmove create {<cmove} domove
ccmvd   dc.w 0
        dc.l jcmvdn-Z

voc setstr fth

cmovel  create {cmove-l} dojump
 dc.l Xcmovel-Z
cmove   create {cmove}  dojump
 dc.l Xcmove-Z
fill    create {fill}   dojump
 dc.l Xfill-Z
erase   create {erase}  dojump
 dc.l Xerase-Z
blanks  create {blanks} dojump
 dc.l Xblanks-Z

*** bitwise

onefand dc.w  docand-Z,$1f
;;asciiand dc.w docand-Z,$7f

qsplus create {qsys+} dojump
 dc.l CXqsplus-Z

plusorigin create {+origin} Xplusorg boot area

displus   create {disp+} Xdisplus (n1 - dn2) 4th-ptr to sys-address
codeplus  create {code+} Xcodeplus (n1 - dn2) disp to code-base to memory address
baseplus  create {base+} Xbaseplus (n1 - dn2) convert 4th-ptr to memory address
tforthplus create {2forth+} Xtfp (dn1 - dn2) memory address to d.4th-ptr
tbaseplus create {2base+} Xtbp

toggle  create  {toggle} Xtoggle

*** compiler

dexit   create {-exit} Xdexit   (un-nest if tf)
semis   create  {;s} dosemis    (un-nest)

semi    create  {;}     docolon
        dc.w questcsp-Z,smudge-Z,compile-Z,semis-Z,lbrac-Z,semis-Z
previmm setnum $140-[previmm]

twoconstant create {2constant}  docolon
        dc.w twovariable-Z
        dc.w pxscodeq-Z
        dc.w dotwoconstant-Z

constant create {constant} docolon
        dc.w create-Z,smudge-Z,comma-Z
        dc.w pxscodeq-Z,doconstant-Z

fcons create {constant} docolon V: fp
        dc.w create-Z,smudge-Z,comma-Z
        dc.w dcomma-Z,pxscodeq-Z,dofcons-Z

ftwodiv create {2/} Xf2div V: fp

ftwomul create {2*} Xf2mul V: fp

twovariable create {2variable}  docolon
        dc.w constant-Z,comma-Z
        dc.w pxscodeq-Z,dovariable-Z

variable create {variable} docolon
        dc.w constant-Z,pxscodeq-Z,dovariable-Z

*** user, cons

* dup usermax < 7 ?error dup up @ max up ! constant ;code w @ up + jmp ([nx])
user    create  {user}  docolon
        dc.w dup-Z,nuser-Z,twoby-Z
        dc.w great-Z,lit-Z,7,questerror-Z
        dc.w dup-Z,up-Z,fetcha-Z,max-Z
        dc.w up-Z,storea-Z,constant-Z
        dc.w pxscodeq-Z,douser-Z

* cons numbers
dzero   create {0.}     dotwoconstant
        dc.l 0
zero    create {0}      doconstant
        dc.w 0
one     create {1}      Xone
two     create {2}      doconstant
        dc.w 2
three   create {3}      doconstant
        dc.w 3
dashone create {-1}     doconstant
        dc.w -1
bl      create {bl}     doconstant
        dc.w 32
four    dc.w doconstant-Z,4
cons16  dc.w doconstant-Z,16
asciiquote dc.w doconstant-Z,0+'"'

* editor cons
cbyl    create {c/l}    doconstant
        dc.w 64
cbys    create {c/scr}  doconstant
        dc.w cscr       ;1024

* block memory cons
first   create {first}  doconstant
cfirst  dc.w 0
limit   create {limit}  doconstant
climit  dc.w 0
bbybuf  create {b/buf}  doconstant
cbbybuf dc.w ssize      ;64
bbyscr  create {b/scr}  doconstant
cbbyscr dc.w cscr/ssize ;16

* disc & ser related cons
fbyn    create {f/n}    doconstant
        dc.w cfname     ;38   len of filenames
bhed    create {b/hed}    doconstant
        dc.w cfhead     ;64   fileheader
bsec    create {b/sec}  doconstant
        dc.w cbsec      ;512  bytes/disksector
balc    create {b/alc}  doconstant
        dc.w cbalc      ;1536 allocation unit
adrv    create {a/drv}  dotwoconstant
        dc.l cadrv      ;480  a.units/drive
afre    create {a/fre}  dotwoconstant
        dc.l cafre      ;480  free a.units
dwpt    create {d/wpt}  doconstant
        dc.w cdwpt       write protect flag
dnum    create {d/num}  doconstant
        dc.w cdnum      drive number

sbaud   create {baud}   doconstant
        dc.w 19200      standard baud rate

* file i/o cons
chdr0   create {dr0ch}  doconstant
 dc.w dr0ch-Z
chdr1   create {dr1ch}  doconstant
 dc.w dr1ch-Z
scrname create {(screen)} doconstant
 dc.w scrfile-Z
filname create {(file)} doconstant
 dc.w loadfile-Z
prtname create {(prt)}  doconstant
 dc.w prtfile-Z
dirname create {(dir)}  doconstant
 dc.w dirfile-Z
bootname create {(boot)} doconstant
 dc.w bootfile-Z
bootscr create {(#boot)} doconstant V: hidn
 dc.w loadblk-Z

* system cons & vari

 asmlab nul donul V: hidn * <nul> deferred action
 asmlab nul-pfa vddonul V: hidn * nul defer-pfa
nvocs create {#vocs} doconstant max no of stacked vocs
vnvocs dc.w .vocs
nuser create {#user} doconstant V: hidn
      dc.w uarea
 asmlab th-entry thntry V: pif
pquitq create {(quit)} doconstant V: hidn
      dc.w vquit-Z,vquit-Z
dbon create {db-on} doconstant  debugging off/on
cdbon dc.w 0,0
pupperq create {(upper)} doconstant
vpupperq dc.w -33,-33
pjokerq create {(joker)} doconstant
vpjokerq dc.w -1,-1
dspc  create {dataspace} dovariable V: hidn ;;
vdspc dc.w -1
v2nd  create {2nd-voc} dovariable V: root (2nd order search in -find
vv2nd dc.w 0
break create {break} dovariable breakflag & -char
vbreak dc.w 1
cmc create {cmc} doconstant ;commands counter
ccmc dc.w -1
previmm setnum $140-[previmm]

voc setstr asm * assembler cons re A6
 asmlab donext next
 asmlab docol  docolon
 asmlab doexec next1
 asmlab dosemis
 asmlab docall
 asmlab dojump
 asmlab dodefer

voc setstr fth

* neutral element for misc. dummy operations
nulpv create {+nul} dovariable
        dc.w 0,0

* user vari

.udisp    setnum    0
* ------- * -L are longword vari to be addressed at {name} 2-.
* init: last bschar u0-l s0-l r0-l tib width warning fence dp-l voclink os.l
last      defuser   {last}    ; 0 \
bbs       defuser   {(bs)} V: hidn 
.udisp  setnum [.udisp]+2
u0        def2user  {u0}      ; 6 -L
s0        def2user  {s0}      ;10 -L
r0        defuser   {r0}      ;14 -L
tib       defuser   {tib}     ;16
width     defuser   {width}   ;18
warning   defuser   {warning} ;20
fence     defuser   {fence}   ;22 $16
.udisp  setnum [.udisp]+2
dp        defuser   {dp}      ;26 -L
vocdashlink defuser {voc-link} 28 /
sysos     def2user  {os}      ;30 .L
* ------- *
blk       defuser   {blk}     ;34 \
in        defuser   {in}      ;36 /
lmrg      defuser   {l-mrg}   ;38  left margin (debug)
out       defuser   {out}     ;40
row       defuser   {row}     ;42 \
scr       defuser   {scr}     ;44 /
offset    defuser   {offset}  ;46
state     defuser   {state}   ;48
base      defuser   {base}    ;50
dpl       defuser   {dpl}     ;52
fld       defuser   {fld}     ;54
.udisp  setnum [.udisp]+2
csp       def2user  {csp}     ;58 -L
hld       defuser   {hld}     ;62 -L
rsharp    defuser   {r#}      ;64
span      defuser   {span}    ;66
ntib      defuser   {#tib}    ;68 f83
tail      defuser   {tail} V: hidn
.udisp setnum [.udisp]+2
head      defuser   {head} V: hidn ;72 -L
timo      defuser   {io-time} ;76
occ4th    defuser   {cc4th}   ;78
numfil    defuser   {(r)}
promptq   defuser   {(prompt)}
up        defuser   {up}
forgetlk  defuser   {forget-lk}
* user-space for 4 voc-vari & .vocs+1 cells depth of voc.stack
; [.udisp]=.udisp user-vari/vocstack bot
ocurrent  defuser   {ocurrent} V: hidn   |
current   defuser   {current}    defining|
context   defuser   {context}   searching|
ocontext  defuser   {ocontext} V: hidn   |
 ifnum [.udisp] > 126 warning [.udisp]-2 usertop NOT disp(An,Xi) addressable
.udisp  setnum  [.udisp]+.vocs*2+2
 ifnum [.udisp]+2 > uarea warning too many user vari

xshift  create  {shift} dojump
 dc.l Xxshift-Z ( n1 c1 -- n2 ovf ( c1 +ve LSL, c1 -ve LSR )

basefetch create {base@} Xbasef
basestore create {base!} Xbases

dplfetch create {dpl@} Xdplf

zeroinstore create {0in!} Xzinsto

* code compiling:

statefetch create {state@} Xstatef

tibfetch create {tib@} Xtibf

here    create  {here}  dojump
 dc.l CXhere-Z

allot   create  {allot} dojump
 dc.l CXallot-Z

comma   create  {,} dojump
 dc.l Xcomma-Z
ccomma  create  {c,} dojump
 dc.l Xccomma-Z

overdash create {over-} Xoverd

lfa     create  {lfa}   X4dash
cfa     create  {cfa}   X2dash
nfa     create  {nfa}   dojump
 dc.l Xnfa-Z
pfa     create  {pfa}   dojump
 dc.l Xpfa-Z

traverse create {traverse} dojump
 dc.l Ctraverse-Z

latest  create {latest} dojump
 dc.l Xlatest-Z

storecsp create {!csp} dojump
 dc.l Cstocsp-Z

questesc   create {?esc}   dojump
 dc.l CXqesc-Z
questloading create {?loading} dojump
 dc.l Xqloading-Z
queststack create {?stack} dojump
 dc.l Xqstack-Z
questcomp  create {?comp} dojump
 dc.l Xqcomp-Z
questexec  create {?exec} dojump
 dc.l Xqexec-Z
questpairs create {?pairs} dojump
 dc.l Xqpairs-Z
questcsp   create {?csp}  dojump
 dc.l Xqcsp-Z
questhld   create {hld?}  dojump (-- ff | on err:-4)
 dc.l Xqhld-Z
questerror create {?error} dojump
 dc.l Xqerror-Z (f ernum -- | on error: row col)

calerr  jsr     docontinue(pc)
doerr   dc.w    error-Z,semis-Z

questqerr dc.w dojump-Z ( ernum flag -- error
 dc.l Cqqerr-Z

sysmsgq dc.w dojump-Z ( err.code - ff | err.code )
 dc.l Csysmsg-Z

;;* for compiled execution adjust dp, save last & dp
;setexb  dc.w dojump-Z
; dc.l Csetexb-Z

* restore old dp and last from tail and word
retexb create {|} dojump ;dummy head for the debugger
 dc.l Cretexb-Z

* toggle direct execution:  | any (not defining) words ... | <enter>
exbrac  create {|} dojump
 dc.l Cexbrac-Z
previmm setnum $140-[previmm]

brac    create  {`} Xbrac       "Interpret-Klammer"
previmm setnum $140-[previmm]
lbrac   dc.w    *+2-Z
        sf      ustate([bp],[up].l)
Xbrac   sf      1+ustate([bp],[up].l)
        [jnx]

carb    create  {]} Xcarb       "Compile-Klammer"

dcompile create {-compile} docolon
        dc.w statefetch-Z,nzbranch-Z
        dc.w CP01-*,semis-Z
compile create  {compile} docolon
        dc.w questcomp-Z
CP01    dc.w rplus-Z,comma-Z,semis-Z

smudge  create  {smudge}  docolon
        dc.w latest-Z,smutog-Z,semis-Z

psemicodeq create {(;code)} docolon V: hidn
        dc.w rgreat-Z
PS01    dc.w latest-Z,pfa-Z
        dc.w cfa-Z,store-Z,semis-Z

pxscodeq dc.w docolon-Z    (;code) to disp'd address
        dc.w rgreat-Z,fetch-Z,branch-Z
        dc.w PS01-*

semicode create {;code}   docolon
        dc.w questcsp-Z,compile-Z,psemicodeq-Z
        dc.w lbrac-Z,smudge-Z,assembler-Z,semis-Z
previmm setnum $140-[previmm]

lessbuilds create {<builds} docolon
        dc.w zero-Z,constant-Z,semis-Z

doesgreat create {does>} docolon
        dc.w rgreat-Z,latest-Z,pfa-Z
        dc.w store-Z,pxscodeq-Z,dodoesgreat-Z

;;cdoesgt create {:does>} docolon
;        dc.w compile-Z,branch-Z,two-Z,comma-Z
;        dc.w compile-Z,docolon-Z
;        dc.w compile-Z,doesgreat-Z
;        dc.w semis-Z

defaultis create {default-is} docolon
        dc.w dashfind-Z,zerobranch-Z
        dc.w DI02-*,drop-Z,dftcfa-Z,nzbranch-Z
        dc.w DI00-*
DI02    dc.w dfderr-Z
DI00    dc.w statezbra-Z
        dc.w DI01-*,compile-Z,lit-Z
        dc.w comma-Z,compile-Z
DI01    dc.w bdeftb-Z,semis-Z
previmm setnum $140-[previmm]

* re-defining deferred, case:, associative:, range:, vari, cons
* state @ IF hidden compile (is) ELSE ' ((is)) ENDIF
is create {is} docolon
        dc.w statezbra-Z
        dc.w I01-*,compile-Z,bisq-Z
        dc.w bcompileb-Z,semis-Z
I01     dc.w tick-Z,istobody-Z,semis-Z
previmm setnum $140-[previmm]

recurse create {recurse} docolon
        dc.w compile-Z,queststack-Z
        dc.w latest-Z,pfa-Z,cfacomma-Z,semis-Z
previmm setnum $140-[previmm]

count   create  {count} dojump
 dc.l Xcount-Z
countw  create  {count-w} dojump
 dc.l Xcountw-Z
countl  create  {count-l} dojump
 dc.l Xcountl-Z
dashcount create {-count} dojump
 dc.l Xdcount-Z

* deferred i/o words

expect  create  {expect} dodefer
 dc.w Dexpect-Z,Dexpect-Z,Dqexpect-Z
key     create  {key}    dodefer
        dc.w Dkey-Z,Dkey-Z
qkey    create  {?key}   dodefer
        dc.w Dqkey-Z,Dqkey-z
qterminal create {?terminal} dodefer
        dc.w Dqterminal-Z,Dqterminal-Z
emit    create  {emit}   dodefer
dfdemit dc.w Demit-Z,Demit-Z
type    create  {type}   dodefer
dfdtype dc.w Dtype-Z,Dtype-Z
typel   create  {type-l} dodefer
        dc.w Dtypel-Z,Dtypel-Z
pemit   create  {pemit}  dodefer
        dc.w Dpemit-Z,Dpemit-Z
ptype   create  {ptype}  dodefer
        dc.w doptype-Z,doptype-Z
prompt  create  {prompt} dodefer
dfdprmp dc.w Dconsem-Z,Dconsem-Z
echo    create  {echo}   dodefer
        dc.w Dconst-Z,Dconst-Z
bs      create  {bs}     dodefer
        dc.w DXbs-Z,DXbs-Z
del     create  {del}    dodefer
        dc.w DXdel-Z,DXdel-Z
cr      create {cr}      dodefer
        dc.w docr-Z,docr-Z
clscr   create {cls}     dodefer
        dc.w docls-Z,docls-Z

dashprint create {-print} docolon
        dc.w dashcount-Z,type-Z,semis-Z

dashtrailing create {-trailing} dojump ( addr n1 --- addr n2 )
 dc.l Cdashtrailing-Z

space create {space} dojump
 dc.l Xspace-Z

dashcr create {-cr} docolon
        dc.w zerobranch-Z
        dc.w CR01-*,cr-Z
CR01    dc.w semis-Z

pdotquoteq create {(.")} docolon V: hidn
        dc.w rgreat-Z,count-Z,twodup-Z
        dc.w plus-Z,oneplus-Z,even-Z
        dc.w greatr-Z,type-Z,semis-Z

dotquote create {."} docolon
        dc.w asciiquote-Z,statezbra-Z
        dc.w M3-*,compile-Z,pdotquoteq-Z
        dc.w wordh-Z
        dc.w cfetch-Z,one-Z,orx-Z
        dc.w oneplus-Z,allot-Z,semis-Z
previmm setnum $140-[previmm]

commentp create {.(} docolon
 dc.w lit-Z,$29
M3
 dc.w wordh-Z,count-Z,echo-Z
 dc.w semis-Z
previmm setnum $140-[previmm]

px      create  {(} dojump
 dc.l Xcommentb-Z       ( comment till ")" or e.o.l.)
previmm setnum $140-[previmm]

comments create {\} dojump ( comment till e.o.l.)
 dc.l Xcomments-Z
previmm setnum $140-[previmm]

tibmax create {tib-max} doconstant
vtibmax dc.w tibrp-rpmin-2,171

query   create  {query} dojump
 dc.l Cquery-Z

skip create {skip} dojump
 dc.l Xskip-Z
scan create {scan} dojump
 dc.l Xscan-Z

hold    create {hold} dojump
 dc.l Xhold-Z
pad     create {pad} dojump
 dc.l XCpad-Z

wordh dc.w dojump-Z
 dc.l Xwordh-Z
blword dc.w dojump-Z
 dc.l Xblword-Z

source create {source} dojump ;(ans)
 dc.l Xsource-Z

word    create {word} dojump
 dc.l Xword-Z

* (dn adr -- dn adr) BEGIN 1+ >rr c@ base@ digit WHILE
* swap base@ u* drop rot base@ u* d+ dpl @ 1+ IF 1 dpl +! ENDIF r> REPEAT r>
pnumberq create {(number)} dojump V: hidn
 dc.l Xpnumberq-Z

* ( adr -- adr+ oldcurrentbase flag ascii ) ret with base set accordingly
ascibase create {$base} dojump
 dc.l Xascibase-Z

* ( adr -- dn | fp | abort )
number  create  {number}  dodefer
        dc.w cnumberc-Z,cnumberc-Z

qnumerr  create {?numerr} dodefer V: hidn ( flag -- flag 0 )
 dc.w zqerror-Z,zqerror-Z
zqerror dc.w dojump-Z
 dc.l Xnumerr-Z

cnumberc dc.w docolon-Z,bnumberb-Z,qnumerr-Z,semis-Z

bnumberb create {`number]} dojump ;( ptr -- dn|fp ff | tf
 dc.l Xbnumberb-Z

hex     create  {hex} Xhex
decimal create  {decimal} Xdecimal

bfindb  create {`find]} dodefer V: hidn ( stg vocnfa - pfa count tf | ff ) single voc
        dc.w pfindq-Z,pfindq-Z
pfindq  create  {(find)} dojump V: hidn ( stg vocnfa - pfa count tf | ff )
 dc.l Xpfindq-Z

vqfindq dc.w dojump-Z  search all stacked vocs
 dc.l Xqfindq-Z
lpfindq dc.w dojump-Z  search local-voc
 dc.l Xlpfindq-Z

* f83-style voc-search

wfindq  create {w-find} dodefer ( ptr -- ( -find per $-ptr.w or $-ptr.b )
 dc.w pffindq-Z,pffindq-Z

pffindq  create {(wffind)} docolon V: hidn ( ptr -- ( -find per ptr.w or ptr.b )
     dc.w count-Z,zerobranch-Z
     dc.w F16c-*,onedash-Z,branch-Z
     dc.w F16c-*

dashfind create {-find} dodefer (-- pfa ccount tf|-- ff)
 dc.w pdffind-Z,pdffind-Z

pdffind create {(-ffind)} docolon V: hidn (-- pfa ccount tf|-- ff)
     dc.w blword-Z                      bl word
F16c dc.w statezbra-Z     if compiling
     dc.w F16x-*,lpfindq-Z,nzbranch-Z   search local voc.
     dc.w F16-*,rgreat-Z
F16x dc.w vqfindq-Z,nzbranch-Z          search order stacked vocs
     dc.w F16d-*
     dc.w rx-Z,lit-Z,rootv-2-Z,fetcha-Z,bfindb-Z and always the root voc.
F16d dc.w fndclr-Z                      clear serch protect bits
F16  dc.w rdrop-Z,semis-Z

fndclr dc.w dojump-Z
 dc.l Xfndclr-Z

iddot create {id.} docolon
     dc.w count-Z
     dc.w io-Z,over-Z,lit-Z,$40
     dc.w andx-Z,twogtrr-Z,dxstrip-Z
     dc.w cidot-Z,tworgreat-Z,dxstrip-Z
     dc.w bl-Z,prompt-Z,semis-Z

cidot dc.w dojump-Z
 dc.l XCidot-Z

ncase dc.w dojump-Z (adr count -- a c ) eliminate char. bit#7
 dc.l XCncase-Z

create create {create} docolon ( builds a primitive wordheader )
        dc.w questexec-Z,dashfind-Z,zerobranch-Z
        dc.w M18-*,drop-Z
        dc.w nfa-Z,iddot-Z,four-Z
        dc.w message-Z,bl-Z,prompt-Z
M18     dc.w here-Z,dup-Z,count-Z
        dc.w width-Z,fetcha-Z,min-Z
        dc.w oneplus-Z,ncase-Z,allot-Z
        dc.w over-Z,msbtog-Z,here-Z
        dc.w one-Z,andx-Z,zerobranch-Z
        dc.w M19-*,one-Z,allot-Z
        dc.w twodup-Z,here-Z
        dc.w overdash-Z,lesscmove-Z,swapx-Z
M19     dc.w drop-Z,here-Z,onedash-Z
        dc.w msbtog-Z,latest-Z,comma-Z
        dc.w dup-Z,last-Z,storea-Z
        dc.w currentf-Z,store-Z
        dc.w here-Z,twoplus-Z,comma-Z
        dc.w smudge-Z,semis-Z

bcompileb create {`compile]} docolon
        dc.w dashfind-Z,zeroeq-Z
        dc.w zqerror-Z
bcomb   dc.w drop-Z
        dc.w cfacomma-Z,semis-Z
previmm setnum $140-[previmm]

literal create  {literal} docolon
        dc.w statezbra-Z
        dc.w M20-*,compile-Z,lit-Z,comma-Z
M20     dc.w semis-Z
previmm setnum $140-[previmm]

dliteral create {dliteral} docolon
        dc.w statezbra-Z
        dc.w M21-*,compile-Z,dlit-Z,dcomma-Z
M21     dc.w semis-Z
previmm setnum $140-[previmm]

* the text interpreter, debugging:

dodebgb create {(debug)} dodefer V: hidn
vdodebug dc.w $8001,$8001     inactive by default
bdebugb create {`debug]} dodefer V: hidn
 dc.w noop-Z,noop-Z
;; dc.w ddb-Z,ddb-Z
;ddb dc.w docolon-Z,compile-Z,dodebgb-Z,semis-Z

interpret create {interpret} docolon
M22     dc.w dashfind-Z      (ptr nfa.byte tf | ff)
        dc.w zerobranch-Z
        dc.w M23-*         ? try number
        dc.w binterpb-Z
        dc.w statezbra-Z
        dc.w M22d-*,dbon-Z,zerobranch-Z
        dc.w M22d-*,bdebugb-Z
M22d    dc.w statefetch-Z
        dc.w cless-Z,zerobranch-Z       ? execute if immediate or interpreting
        dc.w M24-*,bcplb-Z <=
        dc.w cfacomma-Z,branch-Z
        dc.w M28-*
M24     dc.w cfaexec-Z,branch-Z
        dc.w M28-*
M23     dc.w here-Z,bconvertb-Z   string to number
M28     dc.w queststack-Z
        dc.w branch-Z
        dc.w M22-*

bcplb   create {`cpl]}     dodefer V: hidn
        dc.w noop-Z,noop-Z
binterpb create {`interpret]} dodefer V: hidn
        dc.w noop-Z,noop-Z

* number dpl @ 1+ -dup
*  IF 1+ IF fliteral ELSE dliteral ENDIF
* ELSE literal ENDIF ENDIF ?stack AGAIN
bconvertb create {`convert]} dodefer V: hidn (ptr --)
        dc.w numconv-Z,numconv-Z

numconv dc.w docolon-Z               compile a literal from text at ptr
        dc.w number-Z,dplfetch-Z            type of the number
        dc.w oneplus-Z,zdupbranch-Z         ? single number
        dc.w M27-*,oneplus-Z,zerobranch-Z   ? float
        dc.w M23x-*,dliteral-Z,semis-Z      double
M23x    dc.w fliteral-Z,semis-Z             float
M27     dc.w drop-Z,literal-Z,semis-Z       single

immediate create {immediate} docolon
        dc.w latest-Z,immtog-Z,semis-Z

* by 2 cells extended definition for the extra search order
vocabulary create {vocabulary} docolon
 dc.w lessbuilds-Z,lit-Z,$81A0     voc's 1st nfa
 dc.w comma-Z,currentf-Z
 dc.w dup-Z
 dc.w cfacomma-Z        latest word of this voc (context points to here)
 dc.w fourdash-Z     current search ptr
 dc.w here-Z,vocdashlink-Z
 dc.w fetcha-Z        lastvoc: link to preceeding voc
 dc.w comma-Z        <= where voc-link points to
 dc.w vocdashlink-Z
 dc.w storea-Z       this voc to voc-link
 dc.w comma-Z        initial search ptr to parent voc
 dc.w zerocomma-Z
 dc.w doesgreat-Z    find flag
dovoc   dc.w cdovoc-Z,semis-Z
cdovoc dc.w dojump-Z
 dc.l XCdovoc-Z

definitions create {definitions} dojump V: root mem: |context|current|old.current|
 dc.l CXdefinitions-Z

* initial EXecuting the job-parameter string:
loadquit dc.w docolon-Z,forth-Z
        dc.w lit-Z,quit-Z,pquitq-Z
        dc.w storea-Z,cons16-Z,chp-Z
        dc.w dup-Z,fetcha-Z,zerobranch-Z
        dc.w LQ1-*,zeroinstore-Z,off-Z
        dc.w lbrac-Z,cr-Z,branch-Z
        dc.w M29x-*
LQ1     dc.w drop-Z,branch-Z
        dc.w M29y-*

* trap0r 0 blk ! [ cr BEGIN rp! state @ 0= $3c + space emit query interpret AGAIN
* the outer interpreter will be terminated executing the <nul> word
quit create {quit} docolon
M29y    dc.w trap0r-Z            <standard entry
        dc.w zero-Z,blk-Z
        dc.w storea-Z,lbrac-Z,cr-Z
M29     dc.w rpstore-Z,lit-Z,185 <inner interpreter loop
        dc.w statefetch-Z,zeroeq-Z,dash-Z
        dc.w bl-Z,prompt-Z,prompt-Z '' or '', or nothing if (prompt) off
        dc.w query-Z            fetch keyboard or block input
M29x    dc.w interpret-Z        <parameter-string execution entry
        dc.w branch-Z
        dc.w M29-*

mem create {mem} docolon
        dc.w spfetch-Z,pad-Z,dash-Z,semis-Z

dotcpu  create  {.cpu}  docolon
dodotcpu dc.w basecpu-Z,ddot-Z,basestore-Z,semis-Z

pabortq create  {(abort)} dodefer V: hidn
        dc.w doabort-Z,doabort-Z

doabort dc.w docolon-Z
        dc.w trap0r-Z,atne-Z,work-Z,fnt-Z
        dc.w drzero-Z,decimal-Z,cr-Z,dotcpu-Z
        dc.w lit-Z,sysname-Z+1,count-Z,type-Z
        dc.w cr-Z,mem-Z,udot-Z,pdotquoteq-Z
        string.b {Bytes free, Job# }
        dc.w fthid-Z,dhexdot-Z,semis-Z

abort   create {abort} docolon
        dc.w spstore-Z,pabortq-Z
        [.quit],semis-Z

pabtqp  create {(abort")} dodefer V: hidn
        dc.w quit-Z,quit-Z

dabtqte dc.w docolon-Z,swapx-Z,zerobranch-Z
        dc.w AQ01-*,dashprint-Z,space-Z,pabtqp-Z
AQ01    dc.w drop-Z,semis-Z

abtqte create {abort"} docolon
        dc.w wquote-Z,dcompile-Z,dabtqte-Z,semis-Z
previmm setnum $140-[previmm]

error  create {error} dodefer
verror  dc.w berrorb-Z,berrorb-Z

berrorb create {`error]} docolon V: hidn
        dc.w trap0r-Z,lit-Z,27,overdash-Z,nzbranch-Z
        dc.w M17e-*,pickforth-Z
M17e    dc.w lit-Z,vftherr-Z
        dc.w onx-Z,warning-Z
        dc.w fetcha-Z,zeroless-Z
        dc.w zerobranch-Z
        dc.w M17-*
        dc.w retexb-Z,abort-Z  (end compiling state & abort)
M17     dc.w here-Z,count-Z,echo-Z
        dc.w lit-Z,'??',prompt-Z,bl-Z,prompt-Z
        dc.w message-Z,spstore-Z
        dc.w blk-Z,twofetcha-Z   blk & in
        [.quit]
        dc.w semis-Z

cold    create {cold} docolon
        dc.w empty-Z
        dc.w *+2-Z
        dc.w *+2-Z
        jmp origin(pc)

warm    create  {warm} origin+4

udmmul  create  {udm*}  dojump
 dc.l Xudmmul-Z (du1 du2 -- qu3)
dmmul   create  {dm*}   dojump
 dc.l Xdmmul-Z  (dn1 dn2 -- qn3)
dmul    create  {d*}    dojump
 dc.l Xdmul-Z   (dn1 dn2 -- dn3 | ovf)
udmul   create  {ud*}   dojump
 dc.l Xudmul-Z  (du1 du2 -- du3)
smul    create  {s*}    dojump
 dc.l Xsmul-Z   (dn1 n2 -- dn3 | ovf)
umul    create  {u*}    Xumul   (u1 u2 -- du3)
mmul    create  {m*}    Xmmul   (n1 n2 -- dn3)
mul     create  {*}     Xmul    (n1 n2 -- n3)

mplus   create  {m+}    Xmplus  (dn1 +n2 - dn3)
qmplus  create  {qm+}   dojump
 dc.l Xqmplus-Z

qmbym   create  {uqm/mod} dojump (+qn1 +dn2 - +q3r +d4q)
 dc.l Xuqmbym-Z
sqbym   create  {qm/mod} dojump  (+qn1 dn2 - q3r d4q)
 dc.l Xqmbym-Z
uqbym   create  {uq/mod} dojump  (+qn1 dn2 - d3r d4q
 dc.l Xudmbym-Z
dby     create  {d/}     dojump  (dn1 dn2 -- d3q)
 dc.l Xdby-Z
umbym   create  {um/mod} Xumbym  (udn1 un2 - u3r u4q)
mbymod  create  {m/mod}  dojump  (dn1 n2 - n3r dn4q) <called by: sharp>
 dc.l Xmbymod-Z
mby     create  {m/}     Xmby    (dn1 n2 - n3r n4q)
ubym    create  {u/mod}  Xumod   (un1 un2 - un3r un4q)
usby    create  {u/}     docolon (un1 un2 - un3q)
 dc.w ubym-Z,sdrop-Z,semis-Z
bymod   create  {/mod}   Xbymod  (n1 n2 - n3r n4q)
by      create  {/}      Xby     (n1 n2 - n3q)
mod     create  {mod}    Xmod    (n1 n2 - n3r)

uqmbymod create {ud*/mod} Xuqmbymod (dn1 dn2 dn3 - d4r d5q)
mulbymod create {*/mod}  Xmulbym (n1 n2 n3 - n4r n5q) n4 := n1 n2 m* n3 m/
mulby   create  {*/}     docolon
        dc.w    mulbymod-Z,sdrop-Z,semis-Z

voc setstr fp * -- f.p. words -- *

fliteral create {literal} docolon
        dc.w statezbra-Z
        dc.w L20-*,compile-Z,flit-Z
        dc.w comma-Z,dcomma-Z
L20     dc.w semis-Z
previmm setnum $140-[previmm]

ffetch create {@} dojump ( addr -- fp )
 dc.l Cffetch-Z

fstore create {!} dojump ( fp addr -- )
 dc.l Cfstore-Z

flit create {lit} dojump ( -- fp )
 dc.l Cflit-Z

cndtof create {$>f} dojump V: fth ( $.addr --- fp 0 <or, on error> 1 )
 dc.l Xcndtof-Z

* fp stack
fdrop   create  {drop}  dojump
 dc.l Xfdrop-Z
fdup    create  {dup}   dojump
 dc.l Xfdup-Z
fswap   create  {swap}  dojump
 dc.l Xfswap-Z
f2swap  create  {2swap} dojump
 dc.l Xf2swap-Z
fover   create  {over}  dojump
 dc.l Xfover-Z
fpick   create  {pick}  dojump
 dc.l Xfpick-Z
frot    create  {rot}   dojump
 dc.l Xfrot-Z
froll   create  {roll}  dojump
 dc.l Xfroll-Z
fgreatr create  {>r}    dojump
 dc.l Xfgr-Z
frgreat create  {r>}    dojump
 dc.l Xfrg-Z

* ri-exec op's

voc setstr mi ** minerva only **
miflong create {flong} dorix
        dc.w 9
mirecip create {1/} dorix
        dc.w 17
miarg   create {arg} dorix
        dc.w $25
miavg   create {avg} dorix
        dc.w $27
misqar  create {^2} dorix
        dc.w $29
mipower create {m^} dorix
        dc.w $2f

voc setstr fp ** any roms **
riasin  create {asin} dorix
        dc.w 32
rifloat create {float} dorix
        dc.w 8
rinlint create {nlint} dorix
        dc.w 6
riint   create {int} dorix
        dc.w 4
rinint  create {nint} dorix
        dc.w 2
riadd   create {+} dorix
        dc.w 10
risub   create {-} dorix
        dc.w 12
ridiv   create {/} dorix
        dc.w 16
riabs   create {abs} dorix
        dc.w 18
rineg   create {neg} dorix
        dc.w 20
ricos   create {cos} dorix
        dc.w 24
risin   create {sin} dorix
        dc.w 26
ritan   create {tan} dorix
        dc.w 28
ricot   create {cot} dorix
        dc.w 30
rimul   create {*} dorix
        dc.w 14
ripow   create {^} dorix
        dc.w 48
riexp   create {exp} dorix
        dc.w 46
rilog10 create {log10} dorix
        dc.w 44
riln    create {ln} dorix
        dc.w 42
risqrt  create {sqrt} dorix
        dc.w 40
riacot  create {acot} dorix
        dc.w 38
riatan  create {atan} dorix
        dc.w 36
riacos  create {acos} dorix
        dc.w 34

fmuldiv create {*/} dojump
 dc.l Xfmdiv-Z

* ( op -- ri.result ) or ( ri.prog ri.mem -nn --  ri.result )
rivec create {ri-exec} Xrivec

fdot create {.} dojump
 dc.l Xfdot-Z

voc setstr fth * number conversion

bytes   create {>|<} dojump (n1 -- c2.lo c3.hi)
 dc.l Xbytes-Z

* integer format conversion

ddashgreatq create {d->q} dojump
 dc.l Xddgq-Z
sdashgreatd create {s->d} Xsdgd
cdashgreats create {c->s} Xcdgs

htoa    create {h>a} dojump
 dc.l Xhasci-Z
atoh    create {a>h} dojump
 dc.l Xascih-Z

* integer/fp/string conversion
cfquad  create {q>f} dojump
 dc.l Xqflt-Z
cflong  create {d>f} dojump
 dc.l CXflong-Z
cfsing  create {s>f} dojump
 dc.l Xfsing-Z
clflt   create {f>d} dojump
 dc.l XXlflt-Z
cqflt   create {f>q} dojump
 dc.l Xfpq-Z
cnftd   create {f>$} dojump (fp -- addr len <or, on err> addr zero)
 dc.l Xftd-Z
ffdot   create {\.}  dojump
 dc.l Xfdot-Z

voc setstr qdos * processor mode control

srfetch create {sr@} dojump (-- nn) full length statusregister
 dc.l Xsrftc-Z

srstore create {sr!} dojump  (nn --) set P-status
 dc.l Xsrsto-Z

trap0 create {trap0} Xtrap0  (-- nn) supv. and ret staturegister

trap0s create {trap0s} Xtrap0s enter supvisor mode

trap0r create {trap0r} dojump safely (return to) user mode
 dc.l Xtrap0r-Z

* the chk-operation seems quite useless:
* the code affords extended tests because of no means
* to checking wether chk was trapped
chkf   create {chk} dojump ( n1 n2 -- f) ff if 0 < n2 < n1
 dc.l Cchkf-Z

voc setstr fth

voc setstr fp * fp constants

fzero create {0} dofscons
        dc.w    0,0
fone  create {1} dofscons
        dc.w    $0801,$4000
ftwo  create {2} dofscons
        dc.w    $0802,$4000
fthree create {3} dofscons
        dc.w    $0802,$6000
fhalve create {1/2} dofscons
        dc.w    $0800,$4000
fqartr create {1/4} dofscons
        dc.w    $07ff,$4000
fmone create {-1} dofscons
        dc.w    $0800,$8000
fmtwo create {-2} dofscons
        dc.w    $0801,$8000
fpi   create {pi} dofcons
        dc.w    $0802,$6487,$ED51

voc setstr fth * -- virtual memory -- * forth words

update  create  {update}     Xupdate
updtoff create  {update-off} Xupdoff

drzero  create  {dr0}   Xdrzero
drone   create  {dr1}   Xdrone
ediwork create {dr?} dojump ff=dr0 or tf=dr1
 dc.l Cediwork-Z


blkfetch create {blk@}  Xblkft
fencef  dc.w Xfencef-Z
lastf   dc.w Xlastf-Z
currentf dc.w Xcurrentf-Z

use     create  {use}     dovariable
vuse    dc.w    0
prev    create  {prev}    dovariable
vprev   dc.w    0
        dc.w    1         updt enable flag
bupdtb  create {(update)} doconstant
        dc.w    vprev+2-Z

rbyw    create  {r/w}   dojump
 dc.l Xrbyw-Z

* -- first limit over - erase --

nxblk create {blk+} dojump V: root ( executing from <nul>
 dc.l Xnxblk-Z

emptydashbuffers create {empty-buffers} docolon
        dc.w first-Z,limit-Z
        dc.w overdash-Z,erase-Z,semis-Z

plusbuf create  {+buf} dojump (adr1 -- adr2)
 dc.l Xplusbuf-Z

buffer  create  {buffer} dodefer
dfdbuffer dc.w Jpbufq-Z,Jpbufq-Z
Jpbufq  dc.w dojump-Z
        dc.l Xpbufq-Z

* n1 -- adr
block   create {block} dodefer
dfdblock dc.w Jpblockq-Z,Jpblockq-Z
Jpblockq dc.w dojump-Z
        dc.l Xpblockq-Z

* line screen -- adr cnt
plineq create {(line)} docolon
        dc.w greatr-Z,cbyl-Z,bbybuf-Z
        dc.w mulbymod-Z,rgreat-Z,bbyscr-Z
        dc.w mul-Z,plus-Z,block-Z
        dc.w plus-Z,cbyl-Z,semis-Z

dotline create {.line} docolon
        dc.w plineq-Z,dashtrailing-Z,type-Z,semis-Z

message create {message} docolon
        dc.w promptq-Z,fetch-Z,nzbranch-Z
        dc.w M37-*,bell-Z,drop-Z,semis-Z
M37     dc.w warning-Z,fetcha-Z,zerobranch-Z
        dc.w M36-*,four-Z,offset-Z
        dc.w fetcha-Z,bbyscr-Z,by-Z
        dc.w dash-Z,dotline-Z,semis-Z
M36     dc.w sysmsgq-Z,zdupbranch-Z
        dc.w M38-*,pdotquoteq-Z        (.")
        string.b {msg #}
        dc.w dot-Z
M38     dc.w semis-Z

load create {load} docolon
        dc.w emptydashbuffers-Z,dup-Z,scr-Z
        dc.w dup-Z,fetcha-Z,greatr-Z
        dc.w storea-Z,blk-Z,twofetcha-Z
        dc.w twogreatr-Z,zeroinstore-Z,bbyscr-Z
        dc.w mul-Z,blk-Z,storea-Z
        dc.w lit-Z,'::',prompt-Z
        dc.w lspsto-Z,interpret-Z,tworgreat-Z
        dc.w rgreat-Z,scr-Z,storea-Z
        dc.w blk-Z,twostorea-Z,semis-Z

lspsto dc.w dojump-Z
 dc.l Clpsto-Z
lspcmp dc.w dojump-Z
 dc.l Clspcmp-Z

dashdashgreat create {-->} dodefer
        dc.w bdsdsgt-Z,bdsdsgt-Z
previmm setnum $140-[previmm]
bdsdsgt dc.w docolon-Z
        dc.w questloading-Z,lspcmp-Z,zerobranch-Z
        dc.w DG01-*,scr-Z,fetcha-Z,dot-Z
        dc.w lit-Z,'::',emit-Z,dot-Z
DG01    dc.w lit-Z,'..',prompt-Z,zeroinstore-Z
        dc.w one-Z,scr-Z,plusstore-Z
        dc.w bbyscr-Z,blkfetch-Z,over-Z,mod-Z
        dc.w dash-Z,blk-Z,plusstore-Z,semis-Z

pluscont create {+continue} docolon     (nn --) skip the next nn blocks
        dc.w blk-Z,plusstore-Z,x-Z,semis-Z

edifile create {edif} docolon     (editted file data
        dc.w scrname-Z,screen-Z,ediwork-Z,zerobranch-Z
        dc.w EW01-*,twodrop-Z,filname-Z,fyle-Z
EW01    dc.w semis-Z

pushfile create {pushfile} docolon (-- c.name count ptr d.id chan)
        dc.w edifile-Z                          (fileptr) filechan
        dc.w greatr-Z,greatrr-Z,fetch-Z         >r >rr @
        dc.w threeplus-Z,twoby-Z,greatrr-Z      3+ 2/ >rr
        dc.w minus-Z,ndrop-Z                    minus ndrop
        dc.w rgreat-Z,rx-Z,spfetch-Z            r> r sp@
        dc.w fourplus-Z,rot-Z,twomul-Z          4+ rot 2*
        dc.w cmove-Z,rgreat-Z,rx-Z              cmove r> r
        dc.w chid-Z,rgreat-Z,semis-Z            ch-id r>

popfile create {popfile} docolon   ( c.name count ptr d.id chan --
        dc.w twogtrr-Z,rx-Z                     2>rr r
        dc.w close-Z,setchan-Z,greatr-Z         close set-chan >r
        dc.w fbyn-Z,min-Z,spfetch-Z             f/n min sp@
        dc.w over-Z,twoplus-Z,rx-Z              over 2+ r
        dc.w swapx-Z,cmove-Z,oneplus-Z          swap cmove 1+
        dc.w twoby-Z,ndrop-Z,rgreat-Z           2/ ndrop r>
        dc.w rgreat-Z,rgreat-Z,zerogt-Z         r> r> 0>
        dc.w zerobranch-Z                       IF
        dc.w PF02-*,zero-Z,swapx-Z              0 swap
        dc.w twogtrr-Z,open-Z,dup-Z,zerobranch-Z           2>rr open dup IF
        dc.w PF12-*,dirname-Z,fetcha-Z,sixdash-Z,mibranch-Z (dir) @ 6- +IF
        dc.w PF12-*,dirname-Z,tworfetch-Z,open-Z,twodrop-Z (dir) 2r open 2drop
PF12    dc.w rdrop-Z,rdrop-Z                               ENDIF ENDIF rdrop
PF02    dc.w twodrop-Z,semis-Z                  ENDIF 2drop

sltext create {sltext} dodefer  ( bl -- ) s-load filename to pad+
        dc.w qtext-Z,qtext-Z

lload create {l-load} dodefer
 dc.w sload1-Z,sload1-Z
sload1 dc.w docolon-Z,one-Z,sload-Z
       dc.w bootname-Z,fbyn-Z,dirname-Z,sname-Z
       dc.w semis-Z

sload create {s-load} docolon
        dc.w scr-Z,dup-Z,fetcha-Z,greatr-Z       scr dup @ >r !
        dc.w storea-Z,pushfile-Z                pushfile (chars len ptr d.id chan)
        dc.w greatrr-Z,pad-Z,twoplus-Z          >rr pad 2+
        dc.w store-Z,twogreatr-Z,greatrr-Z      ! 2>r >rr     (temp sto chan
        dc.w pad-Z,store-Z,dup-Z                pad ! dup     (and oldname-ptr
        dc.w threeplus-Z,twoby-Z,ngreatr-Z      3+ 2/ n>r
        dc.w in-Z,fetcha-Z                       in @
        dc.w pad-Z,twofetcha-Z,greatr-Z          pad 2@ >r     (push {ptr
        dc.w bl-Z,sltext-Z,pad-z                bl \name pad
        dc.w dup-Z,rgreat-Z,over-Z              dup r> over
        dc.w fetch-Z,twoplus-Z,cmove-Z          @ 2+ cmove    (inst new to oldname
        dc.w one-Z,rot-Z,greatrr-Z              1 rot >rr     (chan
        dc.w open-Z                             open
        dc.w drop-Z,greatrr-Z                   drop >rr
        dc.w zeroeq-Z,rx-Z,lit-Z,-9             0= r -9
        dc.w eq-Z,orx-Z,nzbranch-Z              = or 0IF
        dc.w PF06-*,in-Z,storea-Z,zero-Z              in ! 0 ENDIF
PF06    dc.w drop-Z,rx-Z                             drop r
        dc.w zerobranch-Z
        dc.w PF03-*                                    IF
        dc.w rx-Z,sevenplus-Z,nzbranch-Z                r 7+
        dc.w PF05-*                                      0IF
        dc.w pad-Z,dup-Z,fbyn-Z,bootname-Z,sname-Z         pad f/n (boot) !name
        dc.w one-Z,rdrop-Z,rx-Z,open-Z                     pad 1 rdrop r open
        dc.w drop-Z,greatrr-Z,zerobranch-Z                 drop >rr || >r ENDIF
        dc.w PF03-*                                       IF><ENDIF || r  IF ..
PF05    dc.w rx-Z,lit-Z                                    r -9 =/=
        dc.w -9,neq-Z,zerobranch-Z                         IF
        dc.w PF03-*,scr-Z,quest-Z                           scr ?
        dc.w lit-Z,sload-Z+2,nfa-Z                          ' sload nfa
        dc.w iddot-Z,pad-Z,dashprint-Z                      id. pad -print
        dc.w space-Z,rx-Z,message-Z                         space r message
PF03    dc.w rx-Z,zeroeq-Z,rgreat-Z             ENDIF ENDIF ENDIF
        dc.w rdrop-Z                            r 0= r> rdrop
        dc.w lit-Z,-9,eq-Z,orx-Z,zerobranch-Z   -9 = or
        dc.w PF04-*                             IF
        dc.w dirname-Z,fbyn-Z,pad-Z,sname-Z       (dir) f/n pad !name
        dc.w scr-Z,fetcha-Z,load-Z                scr @ load
PF04    dc.w rx-Z,threeplus-Z,twoby-Z           ENDIF r 3+ 2/
        dc.w nrgreat-Z,rgreat-Z,tworgreat-Z     nr> r> 2r>
        dc.w rgreat-Z,popfile-Z,lastf-Z         r> popfile last @
        dc.w iddot-Z,rgreat-Z                   id. r>
        dc.w scr-Z,storea-Z,semis-Z              scr !
previmm setnum $140-[previmm]

qfound create {?found} docolon
        dc.w dashfind-Z,dup-Z,nzbranch-Z
        dc.w PF02-*,semis-Z
previmm setnum $140-[previmm]

iftrue create {if-true} docolon
        dc.w zerobranch-Z
        dc.w FF02-*,semis-Z
previmm setnum $140-[previmm]

iffound create {if-found} docolon
        dc.w qfound-Z,nzbranch-Z
        dc.w FF01-*
FF02    dc.w dcompile-Z,comments-Z
FF01    dc.w semis-Z
previmm setnum $140-[previmm]

ifnfound create {if-nfound} docolon
        dc.w qfound-Z,nzbranch-Z
        dc.w FF02-*,semis-Z
previmm setnum $140-[previmm]

Z[prevnum] equ [previmm]
prevnum setnum [prevnum]+1
tickn   dc.w $C1A7            {'}
        dc.w [[voc]link]-Z
tick    dc.w docolon-Z
[voc]link setstr tickn
        dc.w dashfind-Z,zerobranch-Z
        dc.w TK01-*,drop-Z,literal-Z,semis-Z
TK01    dc.w zero-Z,statezbra-Z
        dc.w TK02-*,error-Z,semis-Z
TK02    dc.w message-Z,rdrop-Z,semis-Z
previmm setnum $140-[previmm]

begin create {begin} docolon
        dc.w questcomp-Z,here-Z,one-Z,semis-Z
previmm setnum $140-[previmm]

endif create {endif} docolon
        dc.w questcomp-Z,abs-Z          ;abs for else-safety
        dc.w two-Z,questpairs-Z
        dc.w greatresolve-Z,cmcoff-Z,semis-Z
previmm setnum $140-[previmm]

dox create {do} docolon
        dc.w compile-Z,pdoq-Z
        dc.w here-Z,three-Z,semis-Z
previmm setnum $140-[previmm]

loop create {loop} docolon
        dc.w three-Z,questpairs-Z,compile-Z
        dc.w ploopq-Z,back-Z,semis-Z
previmm setnum $140-[previmm]

plusloop create {+loop} docolon
        dc.w three-Z,questpairs-Z,compile-Z
        dc.w pplusloopq-Z,back-Z,semis-Z
previmm setnum $140-[previmm]

until create {until} docolon
        dc.w dup-Z,fourdash-Z,nzbranch-Z
        dc.w UL01-*,twoswap-Z,dountil-Z,branch-Z
        dc.w UL02-*
dountil dc.w docolon-Z
UL01    dc.w one-Z,questpairs-Z,qzeqbra-Z,back-Z,semis-Z
previmm setnum $140-[previmm]

cmcoff create {if-off} docolon
 dc.w lit-Z,ccmc-Z,off-Z,semis-Z
previmm setnum $140-[previmm]

* IF-optimierung mit 0= und/oder 0< oder 0> und schutz bei ENDIF
qzeqbra dc.w dojump-Z
 dc.l Xqzeqbra-Z

again create {again} docolon
        dc.w one-Z,questpairs-Z,compile-Z
        dc.w branch-Z,back-Z,semis-Z
previmm setnum $140-[previmm]

repeat create {repeat} docolon
        dc.w twoswap-Z,again-Z
UL02    dc.w twodash-Z,endif-Z,semis-Z
previmm setnum $140-[previmm]

caseq create {case?} docolon
        dc.w compile-Z,neqbra-Z,branch-Z
        dc.w IF01-*
previmm setnum $140-[previmm]

if create {if} docolon
        dc.w qzeqbra-Z
IF01    dc.w here-Z
        dc.w zerocomma-Z,two-Z,semis-Z
previmm setnum $140-[previmm]

else    create {else}   docolon
        dc.w two-Z,questpairs-Z
        dc.w compile-Z,branch-Z
        dc.w here-Z,zerocomma-Z
        dc.w swapx-Z,two-Z
        dc.w endif-Z,two-Z,minus-Z,semis-Z
previmm setnum $140-[previmm]

while   create {while}  docolon
        dc.w if-Z,twoplus-Z,semis-Z
previmm setnum $140-[previmm]

defer create {defer} docolon
        dc.w lit-Z,noop-Z,dup-Z
        dc.w constant-Z,comma-Z
        dc.w pxscodeq-Z,dodefer-Z

colon create {:} docolon
        dc.w questexec-Z,storecsp-Z,currentf-Z
        dc.w context-Z,storea-Z
        dc.w create-Z,carb-Z
        dc.w pxscodeq-Z,docolon-Z

cfetchl create  {c@l}   dojump
 dc.l Xcfetchl-Z
fetchl  create  {@l}    dojump
 dc.l Xfetchl-Z
twofetchl create {2@l}  dojump
 dc.l Xtwofetchl-Z
fourfl create {4@l} dojump
 dc.l Xfourfl-Z

cstorel create  {c!l}   dojump
 dc.l Xcstorel-Z
storel  create  {!l}    dojump
 dc.l Xstorel-Z
twostorel create {2!l}  dojump
 dc.l Xtwostorel-Z
foursl  create {4!l} dojump
 dc.l Xfoursl-Z
pstol   create  {+!l}   dojump
 dc.l Xpstol-Z
twopstol create {2+!l}  dojump
 dc.l Xtwopstol-Z

cstore  create  {c!} dojump
 dc.l Xcsto-Z
store   create  {!}  dojump
 dc.l Xstore-Z
storea  create  {!a} dojump
 dc.l Xstorea-Z
twostore create {2!} dojump
 dc.l Xtwosto-Z
fours   create  {4!} dojump
 dc.l Xfours-Z
twostorea create {2!a} dojump
 dc.l X2storea-Z

bpsto   create  {+!}    dojump bytewise
 dc.l Xbpsto-Z
plusstore create {+!a}  dojump word aligned
 dc.l Xpstoa-Z
twopsto create  {2+!}   dojump bytewise
 dc.l Xtwopsto-Z

cfetch  create  {c@} dojump
 dc.l Xcfetch-Z
fetch   create  {@}  dojump
 dc.l Xfetch-Z
twofetch create {2@} dojump
 dc.l Xtwof-Z
fourf   create  {4@} dojump
 dc.l Xfourf-Z
fetcha  create  {@a} dojump
 dc.l Xfetcha-Z
twofetcha create {2@a} dojump
 dc.l X2fetcha-Z

voc setstr fth
oneplus   create {1+} X1plus
twoplus   create {2+} X2plus
threeplus create {3+} X3plus
fourplus  create {4+} X4plus
fiveplus  create {5+} Xfivepl
sixplus   create {6+} X6plus
sevenplus create {7+} X7plus
eightplus create {8+} X8plus
onedash   create {1-} X1dash
twodash   create {2-} X2dash
threeds   create {3-} X3dash
fourdash  create {4-} X4dash
fivedash  create {5-} X5dash
sixdash   create {6-} X6dash
sevends   create {7-} X7dash
eightds   create {8-} X8dash

fourby  create  {4/}  docallw
 dc.w    Xfourby-Z
twoby   create  {2/}  docallw
 dc.w    Xtwoby-Z
mul16   create  {16*} docallw
 dc.w    X16mul-Z
tenmul  create  {10*} docallw (bh..)
 dc.w    X10mul-Z
sixmul  create  {6*}  docallw
 dc.w    X6mul-Z
fivemul create  {5*}  docallw  (bh-prog. special)
 dc.w    X5mul-Z
fourmul create  {4*}  docallw
 dc.w    Xfourmul-Z
threemul create {3*}  docallw
 dc.w    X3mul-Z
twomul  create  {2*}  docallw
 dc.w    Xtwomul-Z

d2mul   create  {d2*}   Xd2mul
d4mul   create  {d4*}   dojump
 dc.l Xd4mul-Z

nnot    create  {not}   Xnot
orx     create  {or}    Xorx
xor     create  {xor}   Xxor
andx    create  {and}   Xand
twoand  create  {2and}  Xtwoand ( dn1 dn2 -- dn)
align   create  {align} dojump
 dc.l CXalign-Z  ( n1 n2 -- nn) mask off n1 the lower n2 bits

even create {even} Xeven

cbset   create {bset} dojump
 dc.l Xbset-Z
cbclr   create {bclr} dojump
 dc.l Xbclr-Z
cbtst   create {btst} dojump
 dc.l Xbtst-Z

zneq    create  {0=/=}  Xzneq
zeroeq  create  {0=}    Xzeroeq
dzeroeq create  {d0=}   Xdzeroeq
;;qzeroeq create  {q0=}   Xqzeroeq
fzeroeq create  {0=}    Xfzeq V: fp

zerogt  create  {0>}    Xzerogt
fzerogt create  {0>}    Xfzgt V: fp

zeroless create {0<}    Xzeroless
dzeroless create {d0<}  Xdzerol
fzeroless create {0<}   Xfzl V: fp

eq      create  {=}     Xeq
deq     create  {d=}    Xdeq
;;qeq     create  {q=}    Xqeq
feq     create  {=}     Xfeq V: fp

neq     create  {=/=}   Xneq

less    create  {<}     Xless
cless   create  {uc<}   Xcless <interpret)
uless   create  {u<}    Xuless
dless   create  {d<}    Xdless
udless  create  {du<}   Xtwouless

great   create  {>}     Xgreat

plus    create  {+}     Xplus
dplus   create  {d+}    Xdplus
qplus   create  {q+}    dojump
 dc.l Xqadd-Z

dash    create  {-}     Xdash
dsub    create  {d-}    Xddash
qsub    create  {q-}    dojump
 dc.l Xqsub-Z

minus   create  {minus}  Xminus
dminus  create  {dminus} Xdminus
qminus  create  {qminus} Xqminus

plusdash  create {+-}   Xplusdash  ( n1 n2  -- n1*sgn(n2) )
dplusdash create {d+-}  Xdplusdash ( dn1 n2 -- dn1*sgn(n2))
qplusdash create {q+-}  Xqplusdash

fplusdash create {+-}   dojump V: fp
 dc.l Xfplusdash-Z

abs     create {abs}    Xabs
dabs    create {dabs}   Xdabs
qabs    create {qabs}   Xqabs

oneabs  create {1abs}   X1abs   ( 1s complement +ve )

umax    create {umax}   dojump
 dc.l Xumax-Z
umin    create {umin}   dojump
 dc.l Xumin-Z
max     create {max}    dojump
 dc.l Xmax-Z
min     create {min}    dojump
 dc.l Xmin-Z
sgn     create {sgn}    dojump
 dc.l Xsgn-Z
tsgn    create {2sgn}   dojump
 dc.l X2sgn-Z

withinq create {within?} dojump
 dc.l CXwiq-Z    (n1 n2 n3 -- f) tf if n2<=n1<n3
bounds  create {bounds}  dojump
 dc.l CXbounds-Z (n1 n2 -- n3 n4) n3:=n1+n2, n4:=n1
within  create {within} dojump
 dc.l CXwi-Z     (n1 n2 n3 -- nn )
twowithin create {2within} dojump
 dc.l CX2wi-Z    (dn1 dn2 dn3 -- dn4 )
wraps   create {wraps} dojump
 dc.l CXwraps-Z

coff    create  {1off}  X1off
off     create  {off}   dojump
 dc.l Xoff-Z
twoff   create  {2off}  dojump
 dc.l X2off-Z
conx    create  {1on}   X1on
onx     create  {on}    dojump
 dc.l Xon-Z
never   create  {never} dojump
 dc.l Xnever-Z

sdup    create  {sdup}  dojump ( n1 n2 -- n2 n1 n1
 dc.l Xsdup-Z
sdrop   create  {sdrop} Xsdrop ( n1 n2 -- n2 )
twosdrop create {2sdrop} X2sdrop
sover    create {sover} Xsover ( n1 n2 -- n2 n1 n2 )

drop     create {drop}  Xdrop
zerodrop create {0drop} X0drop ( n1 n2 -- n1 (if n2=0)
twodrop  create {2drop} Xtwodp
fourdrop create {4drop} Xfourdp
ndrop    create {ndrop} dojump
 dc.l Xndrop-Z

dashdup create  {-dup}  Xdashd
dup     create  {dup}   Xdup
twodup  create  {2dup}  Xtwodup
fourdup create  {4dup}  X4dup
ndup    create  {ndup}  dojump
 dc.l Xndup-Z

depth   create  {depth} dojump
 dc.l Xdepth-Z
pick    create  {pick}  dojump
 dc.l Xpick-Z
dashrot create  {-rot}  Xdashrot
roll    create  {roll}  dojump
 dc.l CXroll-Z

swapb   create  {><}    dojump
 dc.l Xswapb-Z
swapx   create  {swap}  dojump
 dc.l Xswapx-Z
nswap   create  {nswap} dojump
 dc.l CXnswap-Z ( nx n(x-1) ... n2 n1 xx -- n1 n(x-1) ... n2 nx )
twoswap create  {2swap} dojump
 dc.l Xtwoswap-Z

over    create  {over}  Xover  ( n1 n2 -- n1 n2 n1 )
twoover create  {2over} Xtwoover

rot     create  {rot}   Xrot
tworot  create  {2rot}  dojump
 dc.l Xtworot-Z ( dn1 dn2 dn3 --- dn2 dn3 dn1 )

spfetch create  {sp@}   Xspfetch
spstore create  {sp!}   Xspsto
cspstore create {csp!}  Xcspsto  restore sp from csp

rpstore create  {rp!}   dojump
 dc.l Xrpstore-Z
rpfetch create  {rp@}   Xrpfetch

mrgreat create  {r>m} dojump
 dc.l Xrgreatm-Z
mgreatr create  {m>r} dojump
 dc.l Xmgreatr-Z
rdrop   create  {rdrop} Xrdrop
nrgreat create  {nr>}   dojump
 dc.l Xnrgreat-Z
ngreatr create  {n>r}   dojump
 dc.l Xngreatr-Z
rgreat  create  {r>}    Xrg
greatr  create  {>r}    Xgreatr push sing
greatrr create  {>rr}   Xgrr    copy & push
rx      create  {r}     Xrx
rplus   create  {r+}    Xrplus  does: r> dup 2+ >r @

twogreatr create {2>r}  X2gr    push double
twogtrr   create {2>rr} X2grr   copy & push
tworgreat create {2r>}  X2rg    pop
tworfetch create {2r}   Xtworf  read

ix      create  {i}     Xrx
j       create  {j}     Xj
ni      create  {ni}    Xni
lix     create  {<i}    Xlix
lixl    create  {l<i}   Xlixl  fetch latest d0.l value

Z[prevnum] equ [previmm]
prevnum setnum [prevnum]+1
        dc.w $C180           the <nul> word
        dc.w [rootlink]-Z    lfa
x       dc.w dodefer-Z       cfa
vddonul dc.w donul-Z,donul-Z action & default
rootlink setstr x-4
lastlink  setstr [rootlink]
previmm setnum  $140-$80
donul  dc.w dojump-Z
 dc.l Xdonul-Z

 LIST

task    create  {task}    docolon
        dc.w    semis-Z

fthtop  equ   [fthlink]
hidntop equ   [hidnlink]
qdostop equ   [qdoslink]
fptop   equ   [fplink]
editop  equ   [edilink]
piftop  equ   [piflink]
mitop   equ   [milink]
roottop equ   [rootlink]
locvtop equ   [locvlink]
asmtop  equ   [asmlink]
*;;anstop  equ   [anslink]

Z[prevnum] equ [previmm]
voctop  equ   [lastvoc]
lastop  equ   [lastlink]  initial {last}
linktop equ   [prevlab]-2 initial {fence}
uptop   equ   [.udisp]
dptop   equ   *-Z         initial {here}

dataspace equ $8000-dptop-4*chans-8  max size ./. channel table
        data  dataspace
 END 3.9.93
6.9.93 new:
 : roll   -ve index roll in the opposite direction
 : sysflg dn byte flags
       hi -1  68010+, 0 otherwise
          -2  qxl, -1  emu, 1 pre-js, 0 otherwise
         char qdos nation mark
       lo -1  minerva (flag for ri-exec), 0 otherwise
 :[;c]  ( -- dn ) fetch the codewords of <jsr docontinue>
 outcommented: 12.9.+, now in "forth_scr"
 :code ;c *nul l list where 2local fmake-dir time$
 errors corrected
 :-recurse no smudge !
16.10.93   f-83 voc search
 :new: also previous only no-search #vocs
 :re-activated: [next]
 :changed: -find w-find
26.10.93
 :findent  breaking repetitive search
 :create   padding with two bytes to jump over zero-nfa
 :         fetch next name in case <nul> would have been recompiled
...     ANS & F83 words ...
 ANS:new:  source
 ans:n.i:  s>d d>s cells chars cell+ char+ invert
 F83:new:  #tib
 f83:n.i:  s>d
11.12.93
 :new:     blk+ baud
 :system label: iochn ( .b, i/o channel last used in trap3 )
 :flit     exponent safety deleted
 :fcons    sets dpl to -2
 :chk      parameter passing changed to ( n1 n2 -- f ( ff:-1<n2<=n1)
 :case:    and deferred (is) empty vector when $8000 found, instead of zero
 :susjb    defined (was just the name, jumping to nowhere)
 :$>f      no buffer error routine
 :[number] no error abort
 :forth+   outcommented
6.08
 :4th-memory extended due to locating many primitives below the +-32K range
 :disp+   extends to double integer
7.00 - lonword addressing for jobs created by the f6-tasker:
 :u0 s0 r0 dp hld  longwords when -2 disp addressed
 :pad hold <# # #> internally working on longword displacement
7.10   qxl-adaptation 8/94
 jmp ... nach dojump & dc.l addr-Z modified (faster)
 :edline fr expect in {qexpect}
 error, warm & cold  orderly returning when called in supervisor mode
7.12 - qxl adaptation
 :cache-words
 timer-message adjusted & more primitives to codespace
 other hi-level words to prim. in codespace
 :s-load w/o filename loading from default file {(boot)}
 :fop-over doesn't afford tk2/minerva to be present
 :!a @a 2!a 2@a  store/fetch to/from aligned address
7.15 - separate job for break & safety
 :quad integer words
7.16
 :if-optimierung bei 0= / 0> / 0< / 0> 0= / 0< 0=
 :find nfa=>lfa berechnet statt mit traverse => ca 25% compilezeit-einsparung
 :move> & <move outcommented
7.21
 :debugger in forth_scr
 :qzeqbra if-optimierung als primitive,
  optimierung bei einsprung zwischen { 0< 0= } o.dgl verriegelt/verriegelbar
  .hpr'93 
;;cn1dtof dc.w dojump-Z   convert string.b
; dc.l Xjbcndtof-Z
;*;locdef create {local} docolon V: root (--) use: local {name}
; dc.w zero-Z
; dc.w questcomp-Z
; dc.w here-Z,one-Z,andx-Z,allot-Z
; dc.w compile-Z,branch-Z,here-Z,zerocomma-Z
; dc.w also-Z,locvoc-Z,definitions-Z,lbrac-Z
; dc.w sdrop-Z,zero-Z,variable-Z
; dc.w carb-Z,ocurrent-Z,fetcha-Z
; dc.w current-Z,storea-Z
; dc.w previous-Z,greatresolve-Z,semis-Z
;previmm setnum $140-[previmm]
;newloc create {loc:} docolon V: root pretend local voc beeing empty
; dc.w questcomp-Z,lit-Z,locvocv-4-Z
; dc.w dup-Z,twoplus-Z,storea-Z,semis-Z
;previmm setnum $140-[previmm]
  eof 
